#ifndef FPGA_h
#define FPGA_h

#include "Arduino.h"

#define FPGA_DATA_CLK 22
#define FPGA_DATA_SYNC 24
#define FPGA_DATA_D7 26
#define FPGA_DATA_D6 28
#define FPGA_DATA_D5 30
#define FPGA_DATA_D4 32
#define FPGA_DATA_D3 34
#define FPGA_DATA_D2 36
#define FPGA_DATA_D1 38
#define FPGA_DATA_D0 40

class FPGA
{
  public:
    static void Init();
    static void fpgadata_clock();
    static void debug();

  private:
    static uint32_t fpgadata_tmp;
    static byte fpgadata_stage;

    static inline int digitalReadDirect(int pin);
    static inline void digitalWriteDirect(int pin, boolean val);
    static void PrintFFT(double *vData, uint16_t bufferSize);
    static uint32_t readPacket();
    static void writePacket(uint8_t packet);
    static void setPortsIN();
    static void setPortsOUT();
};

#endif
