#ifndef LCD_h
#define LCD_h

#include <SPI.h>
#include "Adafruit_GFX.h"
#include <MCUFRIEND_kbv.h>
#include <TouchScreen.h>
#include "Arduino.h"
#include "lcd.h"

#define MENU_FREQ_HZ 1
#define MENU_FREQ_KHZ 2
#define MENU_FREQ_MHZ 3
#define MENU_FREQ_COUNT 3

#define MENU_MAIN_GAIN 1
#define MENU_MAIN_AGCSPEED 2
#define MENU_MAIN_COUNT 2

class LCD
{
  public:
    static void Init();
    static void displayFreqInfo();
    static void displayTopButtons(bool redraw);
    static void displayBottomButtons();
    static void checkTouchPad();
    static void displayMainMenu();
    static void displayStatusInfo();
    static void doEvents();
    static void redraw();
    static uint32_t last_showed_freq;
    static byte menu_freq_index;
    static byte menu_main_index;
    static bool mainMenuOpened;
    static boolean needRedrawMainMenu;

  private:
    static String freq_string_hz;
    static String freq_string_khz;
    static String freq_string_mhz;
    static MCUFRIEND_kbv tft;
    static bool bandMenuOpened;
    static int last_s_meter;

    static void resetTouchpadPins();
};

#endif
