#include "Arduino.h"
#include "trx_manager.h"
#include "fpga.h"
#include "functions.h"
#include "lcd.h"

int32_t TRX_Manager::freq = 7100000;
int32_t TRX_Manager::freq_phrase = 620407; //freq in hz/oscil in hz*2^bits = (freq/50000000)*4194304;
byte TRX_Manager::mode = 0;
boolean TRX_Manager::preamp = true;
boolean TRX_Manager::agc = true;
boolean TRX_Manager::loopback = false;
byte TRX_Manager::gain_level=12;
byte TRX_Manager::agc_speed=12;
boolean TRX_Manager::ptt=0;
int32_t TRX_Manager::s_meter=1;

void TRX_Manager::Init()
{
  freq_phrase = 620407; //freq in hz/oscil in hz*2^bits = (freq/50000000)*4194304; 7.100.000
  freq = Functions::getFrequencyFromPhrase(freq_phrase);
  mode = 0; //2-IQ 1-USB 0-LSB
  LCD::displayTopButtons(false);

  pinMode (PTT, INPUT_PULLUP); //sync
  attachInterrupt(PTT, ptt_change, CHANGE);
}

void TRX_Manager::ptt_change()
{
  ptt = !digitalRead(PTT);
  LCD::displayStatusInfo();
}

void TRX_Manager::setFrequency(int32_t _freq)
{
  if (_freq < 100) _freq = 100;
  if (_freq >= 99999999) _freq = 99999999;
  freq = _freq;
  freq_phrase = round(((float)_freq / 48000000) * 4194304); //freq in hz/oscil in hz*2^bits = (freq/50000000)*4194304;
  if (freq_phrase < 0) freq_phrase = 0;
}

void TRX_Manager::setFrequencyPhrase(int32_t _phrase)
{
  freq_phrase = _phrase;
  if (freq_phrase < 0) freq_phrase = 0;
  freq = Functions::getFrequencyFromPhrase(freq_phrase);
}

int32_t TRX_Manager::getFrequency()
{
  return freq;
}

int32_t TRX_Manager::getFrequencyPhrase()
{
  return freq_phrase;
}


void TRX_Manager::setMode(byte _mode)
{
  mode = _mode;
  LCD::displayTopButtons(false);
}

byte TRX_Manager::getMode()
{
  return mode;
}


