#include <inttypes.h>
#include "encoder.h"
#include "trx_manager.h"
#include "lcd.h"
#include "fpga.h"
#include "SimpleTimer.h"

//подключение энкодера
#define ENC_CLK 47
#define ENC_DT 49
#define ENC_SW 51
#define ENC_PW 53

SimpleTimer timer;

void setup() { //первоначальные настройки
  //запускаем UART для отладки
  Serial.begin(57600);
  Serial.println("Hello Computer");

  TRX_Manager::Init(); //запускаем менеджер трансивера
  Encoder::Init(ENC_CLK, ENC_DT, ENC_SW, ENC_PW); //запускаем энкодер
  FPGA::Init(); //запускаем соединение с FPGA
  delay(1500);
  LCD::Init(); //запускаем LCD экран
  
  //таймеры
  timer.setInterval(100, LCD::doEvents); //обработка событий LCD
  timer.setInterval(100, FPGA::fpgadata_clock); //обработка событий FPGA
  
}

void loop() { //постоянный цикл
  timer.run();
}

