module agc(
data_in,
clk,
enable,
data_out,
agc_speed
);

input wire signed [23:0] data_in;
input wire clk;
input wire enable;
output wire signed [23:0] data_out;
input unsigned [3:0] agc_speed;

integer need_gain=0;
integer gain=1; //default -1 ; 8 - norm

assign data_out = data_in * gain;

always @ (posedge clk)
begin
	if(enable==1)
	begin
		if(data_out[23]==0 && (data_out[22]==1 || data_out[21]==1 || data_out[20]==1))
		begin
			need_gain<=0;
			if(gain>1)
			begin
				gain<=gain-1;
			end
		end
		
		if(data_out[23]==0 && data_out[19]==1)
		begin
			need_gain<=0;
		end
		
		if(data_in[23]==0 && data_in[19]==0)
		begin
			need_gain<=need_gain+1;
		end
		
		if(need_gain>(agc_speed*2000+2000))
		begin
			if(gain<500)
			begin
				gain<=gain+1;
			end
			need_gain<=0;
		end
	end
	else
	begin
		gain<=1;
	end
end

endmodule
