module arduino_interface(
clk_in,
s_meter,
data_out_sync,
data_out,
freq_out,
ssbmode_out,
iq_enable,
preamp_enable,
agc_enable,
loopback_enable,
gain_level,
agc_speed,
rx,
tx
);

input clk_in;
input [7:0] s_meter;
inout [7:0] data_out;
output reg data_out_sync;
output reg unsigned [21:0] freq_out=620407;
output reg ssbmode_out=0;
output reg iq_enable=0;
output reg preamp_enable=1;
output reg agc_enable=0;
output reg loopback_enable=0;
output reg unsigned [3:0] gain_level=1;
output reg unsigned [3:0] agc_speed=1;
output reg rx=1;
output reg tx=0;

reg write_en=0;
reg [7:0] write_data;

assign data_out = write_en ? write_data : 8'bz;
wire [7:0] read_data = write_en ? 8'b0 : data_out;

integer k=1;
always @ (posedge clk_in)
begin
//SEND DATA
	if (k==1)
	begin
		write_en<=1;
		data_out_sync<=1;
		write_data[7:0]<=s_meter[7:0];
		k<=2;
	end
	else if (k==2)
	begin
		data_out_sync<=0;
		k<=3;
		write_en<=0;
	end
	else if (k==3)
	begin
		ssbmode_out<=read_data[7:7];
		iq_enable<=read_data[6:6];
		freq_out[21:16]<=read_data[5:0];
		k<=4;
	end
	else if (k==4)
	begin
		freq_out[15:8]<=read_data[7:0];
		k<=5;
	end
	else if (k==5)
	begin
		freq_out[7:0]<=read_data[7:0];
		k<=6;
	end
	else if (k==6)
	begin
		preamp_enable<=read_data[7:7];
		agc_enable<=read_data[6:6];
		loopback_enable<=read_data[5:5];
		gain_level[3:0]<=read_data[4:1];
		k<=7;
	end
	else if (k==7) 
	begin
		agc_speed[3:0]<=read_data[7:4];
		if(read_data[3:3]==1)
		begin
			tx<=1;
			rx<=0;
		end
		else
		begin
			tx<=0;
			rx<=1;
		end
		k<=8;
	end
	else if (k==8)  //такт для переключения направления передачи
	begin
		write_en<=1;
		k<=1;
	end
end


endmodule
