-- -------------------------------------------------------------
--
-- Module: firssb
-- Generated by MATLAB(R) 9.4 and Filter Design HDL Coder 3.1.3.
-- Generated on: 2018-05-31 19:36:47
-- -------------------------------------------------------------

-- -------------------------------------------------------------
-- HDL Code Generation Options:
--
-- TargetLanguage: VHDL
-- FIRAdderStyle: tree
-- OptimizeForHDL: on
-- EDAScriptGeneration: off
-- Name: firssb
-- DALUTPartition: [2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  2  1]
-- TestBenchName: firssb_tb
-- TestBenchStimulus: impulse step ramp chirp noise 
-- GenerateHDLTestBench: off

-- Filter Specifications:
--
-- Sample Rate          : 96 kHz
-- Response             : Bandpass
-- Specification        : N,Fst1,Fp1,Fp2,Fst2
-- First Passband Edge  : 300 Hz
-- Filter Order         : 256
-- Second Passband Edge : 2.8 kHz
-- First Stopband Edge  : 250 Hz
-- Second Stopband Edge : 3 kHz
-- -------------------------------------------------------------

-- -------------------------------------------------------------
-- HDL Implementation    : Distributed arithmetic (DA)
-- Folding Factor        : 25
-- LUT Address Width     : 2
-- Total LUT Size (bits) : 3480
-- -------------------------------------------------------------
-- Filter Settings:
--
-- Discrete-Time FIR Filter (real)
-- -------------------------------
-- Filter Structure  : Direct-Form Symmetric FIR
-- Filter Length     : 257
-- Stable            : Yes
-- Linear Phase      : Yes (Type 1)
-- Arithmetic        : fixed
-- Numerator         : s16,19 -> [-6.250000e-02 6.250000e-02)
-- Input             : s24,23 -> [-1 1)
-- Filter Internals  : Specify Precision
--   Output          : s24,23 -> [-1 1)
--   Tap Sum         : s25,23 -> [-2 2)
--   Product         : s32,29 -> [-4 4)
--   Accumulator     : s40,29 -> [-1024 1024)
--   Round Mode      : convergent
--   Overflow Mode   : wrap
-- -------------------------------------------------------------



LIBRARY IEEE;
USE IEEE.std_logic_1164.all;
USE IEEE.numeric_std.ALL;

ENTITY firssb IS
   PORT( clk                             :   IN    std_logic; 
         clk_enable                      :   IN    std_logic; 
         reset                           :   IN    std_logic; 
         filter_in                       :   IN    std_logic_vector(23 DOWNTO 0); -- sfix24_En23
         filter_out                      :   OUT   std_logic_vector(23 DOWNTO 0)  -- sfix24_En23
         );

END firssb;


----------------------------------------------------------------
--Module Architecture: firssb
----------------------------------------------------------------
ARCHITECTURE rtl OF firssb IS
  -- Local Functions
  -- Type Definitions
  TYPE delay_pipeline_type IS ARRAY (NATURAL range <>) OF std_logic; -- boolean
  -- Constants
  CONSTANT coeff1                         : signed(15 DOWNTO 0) := to_signed(-1671, 16); -- sfix16_En19
  CONSTANT coeff2                         : signed(15 DOWNTO 0) := to_signed(-1827, 16); -- sfix16_En19
  CONSTANT coeff3                         : signed(15 DOWNTO 0) := to_signed(-1955, 16); -- sfix16_En19
  CONSTANT coeff4                         : signed(15 DOWNTO 0) := to_signed(-2050, 16); -- sfix16_En19
  CONSTANT coeff5                         : signed(15 DOWNTO 0) := to_signed(-2109, 16); -- sfix16_En19
  CONSTANT coeff6                         : signed(15 DOWNTO 0) := to_signed(-2130, 16); -- sfix16_En19
  CONSTANT coeff7                         : signed(15 DOWNTO 0) := to_signed(-2112, 16); -- sfix16_En19
  CONSTANT coeff8                         : signed(15 DOWNTO 0) := to_signed(-2055, 16); -- sfix16_En19
  CONSTANT coeff9                         : signed(15 DOWNTO 0) := to_signed(-1962, 16); -- sfix16_En19
  CONSTANT coeff10                        : signed(15 DOWNTO 0) := to_signed(-1835, 16); -- sfix16_En19
  CONSTANT coeff11                        : signed(15 DOWNTO 0) := to_signed(-1680, 16); -- sfix16_En19
  CONSTANT coeff12                        : signed(15 DOWNTO 0) := to_signed(-1503, 16); -- sfix16_En19
  CONSTANT coeff13                        : signed(15 DOWNTO 0) := to_signed(-1309, 16); -- sfix16_En19
  CONSTANT coeff14                        : signed(15 DOWNTO 0) := to_signed(-1107, 16); -- sfix16_En19
  CONSTANT coeff15                        : signed(15 DOWNTO 0) := to_signed(-905, 16); -- sfix16_En19
  CONSTANT coeff16                        : signed(15 DOWNTO 0) := to_signed(-711, 16); -- sfix16_En19
  CONSTANT coeff17                        : signed(15 DOWNTO 0) := to_signed(-532, 16); -- sfix16_En19
  CONSTANT coeff18                        : signed(15 DOWNTO 0) := to_signed(-378, 16); -- sfix16_En19
  CONSTANT coeff19                        : signed(15 DOWNTO 0) := to_signed(-255, 16); -- sfix16_En19
  CONSTANT coeff20                        : signed(15 DOWNTO 0) := to_signed(-169, 16); -- sfix16_En19
  CONSTANT coeff21                        : signed(15 DOWNTO 0) := to_signed(-125, 16); -- sfix16_En19
  CONSTANT coeff22                        : signed(15 DOWNTO 0) := to_signed(-127, 16); -- sfix16_En19
  CONSTANT coeff23                        : signed(15 DOWNTO 0) := to_signed(-176, 16); -- sfix16_En19
  CONSTANT coeff24                        : signed(15 DOWNTO 0) := to_signed(-273, 16); -- sfix16_En19
  CONSTANT coeff25                        : signed(15 DOWNTO 0) := to_signed(-416, 16); -- sfix16_En19
  CONSTANT coeff26                        : signed(15 DOWNTO 0) := to_signed(-603, 16); -- sfix16_En19
  CONSTANT coeff27                        : signed(15 DOWNTO 0) := to_signed(-828, 16); -- sfix16_En19
  CONSTANT coeff28                        : signed(15 DOWNTO 0) := to_signed(-1085, 16); -- sfix16_En19
  CONSTANT coeff29                        : signed(15 DOWNTO 0) := to_signed(-1366, 16); -- sfix16_En19
  CONSTANT coeff30                        : signed(15 DOWNTO 0) := to_signed(-1663, 16); -- sfix16_En19
  CONSTANT coeff31                        : signed(15 DOWNTO 0) := to_signed(-1966, 16); -- sfix16_En19
  CONSTANT coeff32                        : signed(15 DOWNTO 0) := to_signed(-2265, 16); -- sfix16_En19
  CONSTANT coeff33                        : signed(15 DOWNTO 0) := to_signed(-2549, 16); -- sfix16_En19
  CONSTANT coeff34                        : signed(15 DOWNTO 0) := to_signed(-2809, 16); -- sfix16_En19
  CONSTANT coeff35                        : signed(15 DOWNTO 0) := to_signed(-3036, 16); -- sfix16_En19
  CONSTANT coeff36                        : signed(15 DOWNTO 0) := to_signed(-3220, 16); -- sfix16_En19
  CONSTANT coeff37                        : signed(15 DOWNTO 0) := to_signed(-3356, 16); -- sfix16_En19
  CONSTANT coeff38                        : signed(15 DOWNTO 0) := to_signed(-3437, 16); -- sfix16_En19
  CONSTANT coeff39                        : signed(15 DOWNTO 0) := to_signed(-3460, 16); -- sfix16_En19
  CONSTANT coeff40                        : signed(15 DOWNTO 0) := to_signed(-3424, 16); -- sfix16_En19
  CONSTANT coeff41                        : signed(15 DOWNTO 0) := to_signed(-3328, 16); -- sfix16_En19
  CONSTANT coeff42                        : signed(15 DOWNTO 0) := to_signed(-3176, 16); -- sfix16_En19
  CONSTANT coeff43                        : signed(15 DOWNTO 0) := to_signed(-2971, 16); -- sfix16_En19
  CONSTANT coeff44                        : signed(15 DOWNTO 0) := to_signed(-2722, 16); -- sfix16_En19
  CONSTANT coeff45                        : signed(15 DOWNTO 0) := to_signed(-2436, 16); -- sfix16_En19
  CONSTANT coeff46                        : signed(15 DOWNTO 0) := to_signed(-2124, 16); -- sfix16_En19
  CONSTANT coeff47                        : signed(15 DOWNTO 0) := to_signed(-1797, 16); -- sfix16_En19
  CONSTANT coeff48                        : signed(15 DOWNTO 0) := to_signed(-1467, 16); -- sfix16_En19
  CONSTANT coeff49                        : signed(15 DOWNTO 0) := to_signed(-1147, 16); -- sfix16_En19
  CONSTANT coeff50                        : signed(15 DOWNTO 0) := to_signed(-851, 16); -- sfix16_En19
  CONSTANT coeff51                        : signed(15 DOWNTO 0) := to_signed(-589, 16); -- sfix16_En19
  CONSTANT coeff52                        : signed(15 DOWNTO 0) := to_signed(-373, 16); -- sfix16_En19
  CONSTANT coeff53                        : signed(15 DOWNTO 0) := to_signed(-215, 16); -- sfix16_En19
  CONSTANT coeff54                        : signed(15 DOWNTO 0) := to_signed(-121, 16); -- sfix16_En19
  CONSTANT coeff55                        : signed(15 DOWNTO 0) := to_signed(-98, 16); -- sfix16_En19
  CONSTANT coeff56                        : signed(15 DOWNTO 0) := to_signed(-150, 16); -- sfix16_En19
  CONSTANT coeff57                        : signed(15 DOWNTO 0) := to_signed(-278, 16); -- sfix16_En19
  CONSTANT coeff58                        : signed(15 DOWNTO 0) := to_signed(-480, 16); -- sfix16_En19
  CONSTANT coeff59                        : signed(15 DOWNTO 0) := to_signed(-753, 16); -- sfix16_En19
  CONSTANT coeff60                        : signed(15 DOWNTO 0) := to_signed(-1090, 16); -- sfix16_En19
  CONSTANT coeff61                        : signed(15 DOWNTO 0) := to_signed(-1480, 16); -- sfix16_En19
  CONSTANT coeff62                        : signed(15 DOWNTO 0) := to_signed(-1914, 16); -- sfix16_En19
  CONSTANT coeff63                        : signed(15 DOWNTO 0) := to_signed(-2375, 16); -- sfix16_En19
  CONSTANT coeff64                        : signed(15 DOWNTO 0) := to_signed(-2851, 16); -- sfix16_En19
  CONSTANT coeff65                        : signed(15 DOWNTO 0) := to_signed(-3324, 16); -- sfix16_En19
  CONSTANT coeff66                        : signed(15 DOWNTO 0) := to_signed(-3778, 16); -- sfix16_En19
  CONSTANT coeff67                        : signed(15 DOWNTO 0) := to_signed(-4197, 16); -- sfix16_En19
  CONSTANT coeff68                        : signed(15 DOWNTO 0) := to_signed(-4564, 16); -- sfix16_En19
  CONSTANT coeff69                        : signed(15 DOWNTO 0) := to_signed(-4865, 16); -- sfix16_En19
  CONSTANT coeff70                        : signed(15 DOWNTO 0) := to_signed(-5087, 16); -- sfix16_En19
  CONSTANT coeff71                        : signed(15 DOWNTO 0) := to_signed(-5221, 16); -- sfix16_En19
  CONSTANT coeff72                        : signed(15 DOWNTO 0) := to_signed(-5257, 16); -- sfix16_En19
  CONSTANT coeff73                        : signed(15 DOWNTO 0) := to_signed(-5193, 16); -- sfix16_En19
  CONSTANT coeff74                        : signed(15 DOWNTO 0) := to_signed(-5026, 16); -- sfix16_En19
  CONSTANT coeff75                        : signed(15 DOWNTO 0) := to_signed(-4759, 16); -- sfix16_En19
  CONSTANT coeff76                        : signed(15 DOWNTO 0) := to_signed(-4399, 16); -- sfix16_En19
  CONSTANT coeff77                        : signed(15 DOWNTO 0) := to_signed(-3956, 16); -- sfix16_En19
  CONSTANT coeff78                        : signed(15 DOWNTO 0) := to_signed(-3442, 16); -- sfix16_En19
  CONSTANT coeff79                        : signed(15 DOWNTO 0) := to_signed(-2873, 16); -- sfix16_En19
  CONSTANT coeff80                        : signed(15 DOWNTO 0) := to_signed(-2269, 16); -- sfix16_En19
  CONSTANT coeff81                        : signed(15 DOWNTO 0) := to_signed(-1651, 16); -- sfix16_En19
  CONSTANT coeff82                        : signed(15 DOWNTO 0) := to_signed(-1039, 16); -- sfix16_En19
  CONSTANT coeff83                        : signed(15 DOWNTO 0) := to_signed(-458, 16); -- sfix16_En19
  CONSTANT coeff84                        : signed(15 DOWNTO 0) := to_signed(69, 16); -- sfix16_En19
  CONSTANT coeff85                        : signed(15 DOWNTO 0) := to_signed(521, 16); -- sfix16_En19
  CONSTANT coeff86                        : signed(15 DOWNTO 0) := to_signed(877, 16); -- sfix16_En19
  CONSTANT coeff87                        : signed(15 DOWNTO 0) := to_signed(1119, 16); -- sfix16_En19
  CONSTANT coeff88                        : signed(15 DOWNTO 0) := to_signed(1232, 16); -- sfix16_En19
  CONSTANT coeff89                        : signed(15 DOWNTO 0) := to_signed(1205, 16); -- sfix16_En19
  CONSTANT coeff90                        : signed(15 DOWNTO 0) := to_signed(1030, 16); -- sfix16_En19
  CONSTANT coeff91                        : signed(15 DOWNTO 0) := to_signed(706, 16); -- sfix16_En19
  CONSTANT coeff92                        : signed(15 DOWNTO 0) := to_signed(236, 16); -- sfix16_En19
  CONSTANT coeff93                        : signed(15 DOWNTO 0) := to_signed(-373, 16); -- sfix16_En19
  CONSTANT coeff94                        : signed(15 DOWNTO 0) := to_signed(-1107, 16); -- sfix16_En19
  CONSTANT coeff95                        : signed(15 DOWNTO 0) := to_signed(-1948, 16); -- sfix16_En19
  CONSTANT coeff96                        : signed(15 DOWNTO 0) := to_signed(-2874, 16); -- sfix16_En19
  CONSTANT coeff97                        : signed(15 DOWNTO 0) := to_signed(-3856, 16); -- sfix16_En19
  CONSTANT coeff98                        : signed(15 DOWNTO 0) := to_signed(-4865, 16); -- sfix16_En19
  CONSTANT coeff99                        : signed(15 DOWNTO 0) := to_signed(-5867, 16); -- sfix16_En19
  CONSTANT coeff100                       : signed(15 DOWNTO 0) := to_signed(-6826, 16); -- sfix16_En19
  CONSTANT coeff101                       : signed(15 DOWNTO 0) := to_signed(-7706, 16); -- sfix16_En19
  CONSTANT coeff102                       : signed(15 DOWNTO 0) := to_signed(-8471, 16); -- sfix16_En19
  CONSTANT coeff103                       : signed(15 DOWNTO 0) := to_signed(-9086, 16); -- sfix16_En19
  CONSTANT coeff104                       : signed(15 DOWNTO 0) := to_signed(-9517, 16); -- sfix16_En19
  CONSTANT coeff105                       : signed(15 DOWNTO 0) := to_signed(-9734, 16); -- sfix16_En19
  CONSTANT coeff106                       : signed(15 DOWNTO 0) := to_signed(-9712, 16); -- sfix16_En19
  CONSTANT coeff107                       : signed(15 DOWNTO 0) := to_signed(-9431, 16); -- sfix16_En19
  CONSTANT coeff108                       : signed(15 DOWNTO 0) := to_signed(-8875, 16); -- sfix16_En19
  CONSTANT coeff109                       : signed(15 DOWNTO 0) := to_signed(-8036, 16); -- sfix16_En19
  CONSTANT coeff110                       : signed(15 DOWNTO 0) := to_signed(-6913, 16); -- sfix16_En19
  CONSTANT coeff111                       : signed(15 DOWNTO 0) := to_signed(-5512, 16); -- sfix16_En19
  CONSTANT coeff112                       : signed(15 DOWNTO 0) := to_signed(-3845, 16); -- sfix16_En19
  CONSTANT coeff113                       : signed(15 DOWNTO 0) := to_signed(-1933, 16); -- sfix16_En19
  CONSTANT coeff114                       : signed(15 DOWNTO 0) := to_signed(197, 16); -- sfix16_En19
  CONSTANT coeff115                       : signed(15 DOWNTO 0) := to_signed(2511, 16); -- sfix16_En19
  CONSTANT coeff116                       : signed(15 DOWNTO 0) := to_signed(4972, 16); -- sfix16_En19
  CONSTANT coeff117                       : signed(15 DOWNTO 0) := to_signed(7534, 16); -- sfix16_En19
  CONSTANT coeff118                       : signed(15 DOWNTO 0) := to_signed(10151, 16); -- sfix16_En19
  CONSTANT coeff119                       : signed(15 DOWNTO 0) := to_signed(12772, 16); -- sfix16_En19
  CONSTANT coeff120                       : signed(15 DOWNTO 0) := to_signed(15345, 16); -- sfix16_En19
  CONSTANT coeff121                       : signed(15 DOWNTO 0) := to_signed(17819, 16); -- sfix16_En19
  CONSTANT coeff122                       : signed(15 DOWNTO 0) := to_signed(20142, 16); -- sfix16_En19
  CONSTANT coeff123                       : signed(15 DOWNTO 0) := to_signed(22267, 16); -- sfix16_En19
  CONSTANT coeff124                       : signed(15 DOWNTO 0) := to_signed(24149, 16); -- sfix16_En19
  CONSTANT coeff125                       : signed(15 DOWNTO 0) := to_signed(25747, 16); -- sfix16_En19
  CONSTANT coeff126                       : signed(15 DOWNTO 0) := to_signed(27027, 16); -- sfix16_En19
  CONSTANT coeff127                       : signed(15 DOWNTO 0) := to_signed(27962, 16); -- sfix16_En19
  CONSTANT coeff128                       : signed(15 DOWNTO 0) := to_signed(28531, 16); -- sfix16_En19
  CONSTANT coeff129                       : signed(15 DOWNTO 0) := to_signed(28722, 16); -- sfix16_En19

  CONSTANT const_zero                     : std_logic := '0'; -- boolean
  -- Signals
  SIGNAL filter_in_cast                   : signed(23 DOWNTO 0); -- sfix24_En23
  SIGNAL cur_count                        : unsigned(4 DOWNTO 0); -- ufix5
  SIGNAL phase_24                         : std_logic; -- boolean
  SIGNAL phase_0                          : std_logic; -- boolean
  SIGNAL phase_24_1                       : std_logic; -- boolean
  SIGNAL serialoutb1                      : std_logic; -- boolean
  SIGNAL shiftreg                         : signed(23 DOWNTO 0); -- sfix24_En23
  SIGNAL delay_pipeline                   : delay_pipeline_type(0 TO 6143); -- boolean
  SIGNAL delayline_b23                    : std_logic; -- boolean
  SIGNAL delayline_b47                    : std_logic; -- boolean
  SIGNAL delayline_b71                    : std_logic; -- boolean
  SIGNAL delayline_b95                    : std_logic; -- boolean
  SIGNAL delayline_b119                   : std_logic; -- boolean
  SIGNAL delayline_b143                   : std_logic; -- boolean
  SIGNAL delayline_b167                   : std_logic; -- boolean
  SIGNAL delayline_b191                   : std_logic; -- boolean
  SIGNAL delayline_b215                   : std_logic; -- boolean
  SIGNAL delayline_b239                   : std_logic; -- boolean
  SIGNAL delayline_b263                   : std_logic; -- boolean
  SIGNAL delayline_b287                   : std_logic; -- boolean
  SIGNAL delayline_b311                   : std_logic; -- boolean
  SIGNAL delayline_b335                   : std_logic; -- boolean
  SIGNAL delayline_b359                   : std_logic; -- boolean
  SIGNAL delayline_b383                   : std_logic; -- boolean
  SIGNAL delayline_b407                   : std_logic; -- boolean
  SIGNAL delayline_b431                   : std_logic; -- boolean
  SIGNAL delayline_b455                   : std_logic; -- boolean
  SIGNAL delayline_b479                   : std_logic; -- boolean
  SIGNAL delayline_b503                   : std_logic; -- boolean
  SIGNAL delayline_b527                   : std_logic; -- boolean
  SIGNAL delayline_b551                   : std_logic; -- boolean
  SIGNAL delayline_b575                   : std_logic; -- boolean
  SIGNAL delayline_b599                   : std_logic; -- boolean
  SIGNAL delayline_b623                   : std_logic; -- boolean
  SIGNAL delayline_b647                   : std_logic; -- boolean
  SIGNAL delayline_b671                   : std_logic; -- boolean
  SIGNAL delayline_b695                   : std_logic; -- boolean
  SIGNAL delayline_b719                   : std_logic; -- boolean
  SIGNAL delayline_b743                   : std_logic; -- boolean
  SIGNAL delayline_b767                   : std_logic; -- boolean
  SIGNAL delayline_b791                   : std_logic; -- boolean
  SIGNAL delayline_b815                   : std_logic; -- boolean
  SIGNAL delayline_b839                   : std_logic; -- boolean
  SIGNAL delayline_b863                   : std_logic; -- boolean
  SIGNAL delayline_b887                   : std_logic; -- boolean
  SIGNAL delayline_b911                   : std_logic; -- boolean
  SIGNAL delayline_b935                   : std_logic; -- boolean
  SIGNAL delayline_b959                   : std_logic; -- boolean
  SIGNAL delayline_b983                   : std_logic; -- boolean
  SIGNAL delayline_b1007                  : std_logic; -- boolean
  SIGNAL delayline_b1031                  : std_logic; -- boolean
  SIGNAL delayline_b1055                  : std_logic; -- boolean
  SIGNAL delayline_b1079                  : std_logic; -- boolean
  SIGNAL delayline_b1103                  : std_logic; -- boolean
  SIGNAL delayline_b1127                  : std_logic; -- boolean
  SIGNAL delayline_b1151                  : std_logic; -- boolean
  SIGNAL delayline_b1175                  : std_logic; -- boolean
  SIGNAL delayline_b1199                  : std_logic; -- boolean
  SIGNAL delayline_b1223                  : std_logic; -- boolean
  SIGNAL delayline_b1247                  : std_logic; -- boolean
  SIGNAL delayline_b1271                  : std_logic; -- boolean
  SIGNAL delayline_b1295                  : std_logic; -- boolean
  SIGNAL delayline_b1319                  : std_logic; -- boolean
  SIGNAL delayline_b1343                  : std_logic; -- boolean
  SIGNAL delayline_b1367                  : std_logic; -- boolean
  SIGNAL delayline_b1391                  : std_logic; -- boolean
  SIGNAL delayline_b1415                  : std_logic; -- boolean
  SIGNAL delayline_b1439                  : std_logic; -- boolean
  SIGNAL delayline_b1463                  : std_logic; -- boolean
  SIGNAL delayline_b1487                  : std_logic; -- boolean
  SIGNAL delayline_b1511                  : std_logic; -- boolean
  SIGNAL delayline_b1535                  : std_logic; -- boolean
  SIGNAL delayline_b1559                  : std_logic; -- boolean
  SIGNAL delayline_b1583                  : std_logic; -- boolean
  SIGNAL delayline_b1607                  : std_logic; -- boolean
  SIGNAL delayline_b1631                  : std_logic; -- boolean
  SIGNAL delayline_b1655                  : std_logic; -- boolean
  SIGNAL delayline_b1679                  : std_logic; -- boolean
  SIGNAL delayline_b1703                  : std_logic; -- boolean
  SIGNAL delayline_b1727                  : std_logic; -- boolean
  SIGNAL delayline_b1751                  : std_logic; -- boolean
  SIGNAL delayline_b1775                  : std_logic; -- boolean
  SIGNAL delayline_b1799                  : std_logic; -- boolean
  SIGNAL delayline_b1823                  : std_logic; -- boolean
  SIGNAL delayline_b1847                  : std_logic; -- boolean
  SIGNAL delayline_b1871                  : std_logic; -- boolean
  SIGNAL delayline_b1895                  : std_logic; -- boolean
  SIGNAL delayline_b1919                  : std_logic; -- boolean
  SIGNAL delayline_b1943                  : std_logic; -- boolean
  SIGNAL delayline_b1967                  : std_logic; -- boolean
  SIGNAL delayline_b1991                  : std_logic; -- boolean
  SIGNAL delayline_b2015                  : std_logic; -- boolean
  SIGNAL delayline_b2039                  : std_logic; -- boolean
  SIGNAL delayline_b2063                  : std_logic; -- boolean
  SIGNAL delayline_b2087                  : std_logic; -- boolean
  SIGNAL delayline_b2111                  : std_logic; -- boolean
  SIGNAL delayline_b2135                  : std_logic; -- boolean
  SIGNAL delayline_b2159                  : std_logic; -- boolean
  SIGNAL delayline_b2183                  : std_logic; -- boolean
  SIGNAL delayline_b2207                  : std_logic; -- boolean
  SIGNAL delayline_b2231                  : std_logic; -- boolean
  SIGNAL delayline_b2255                  : std_logic; -- boolean
  SIGNAL delayline_b2279                  : std_logic; -- boolean
  SIGNAL delayline_b2303                  : std_logic; -- boolean
  SIGNAL delayline_b2327                  : std_logic; -- boolean
  SIGNAL delayline_b2351                  : std_logic; -- boolean
  SIGNAL delayline_b2375                  : std_logic; -- boolean
  SIGNAL delayline_b2399                  : std_logic; -- boolean
  SIGNAL delayline_b2423                  : std_logic; -- boolean
  SIGNAL delayline_b2447                  : std_logic; -- boolean
  SIGNAL delayline_b2471                  : std_logic; -- boolean
  SIGNAL delayline_b2495                  : std_logic; -- boolean
  SIGNAL delayline_b2519                  : std_logic; -- boolean
  SIGNAL delayline_b2543                  : std_logic; -- boolean
  SIGNAL delayline_b2567                  : std_logic; -- boolean
  SIGNAL delayline_b2591                  : std_logic; -- boolean
  SIGNAL delayline_b2615                  : std_logic; -- boolean
  SIGNAL delayline_b2639                  : std_logic; -- boolean
  SIGNAL delayline_b2663                  : std_logic; -- boolean
  SIGNAL delayline_b2687                  : std_logic; -- boolean
  SIGNAL delayline_b2711                  : std_logic; -- boolean
  SIGNAL delayline_b2735                  : std_logic; -- boolean
  SIGNAL delayline_b2759                  : std_logic; -- boolean
  SIGNAL delayline_b2783                  : std_logic; -- boolean
  SIGNAL delayline_b2807                  : std_logic; -- boolean
  SIGNAL delayline_b2831                  : std_logic; -- boolean
  SIGNAL delayline_b2855                  : std_logic; -- boolean
  SIGNAL delayline_b2879                  : std_logic; -- boolean
  SIGNAL delayline_b2903                  : std_logic; -- boolean
  SIGNAL delayline_b2927                  : std_logic; -- boolean
  SIGNAL delayline_b2951                  : std_logic; -- boolean
  SIGNAL delayline_b2975                  : std_logic; -- boolean
  SIGNAL delayline_b2999                  : std_logic; -- boolean
  SIGNAL delayline_b3023                  : std_logic; -- boolean
  SIGNAL delayline_b3047                  : std_logic; -- boolean
  SIGNAL delayline_b3071                  : std_logic; -- boolean
  SIGNAL delayline_b3095                  : std_logic; -- boolean
  SIGNAL delayline_b3119                  : std_logic; -- boolean
  SIGNAL delayline_b3143                  : std_logic; -- boolean
  SIGNAL delayline_b3167                  : std_logic; -- boolean
  SIGNAL delayline_b3191                  : std_logic; -- boolean
  SIGNAL delayline_b3215                  : std_logic; -- boolean
  SIGNAL delayline_b3239                  : std_logic; -- boolean
  SIGNAL delayline_b3263                  : std_logic; -- boolean
  SIGNAL delayline_b3287                  : std_logic; -- boolean
  SIGNAL delayline_b3311                  : std_logic; -- boolean
  SIGNAL delayline_b3335                  : std_logic; -- boolean
  SIGNAL delayline_b3359                  : std_logic; -- boolean
  SIGNAL delayline_b3383                  : std_logic; -- boolean
  SIGNAL delayline_b3407                  : std_logic; -- boolean
  SIGNAL delayline_b3431                  : std_logic; -- boolean
  SIGNAL delayline_b3455                  : std_logic; -- boolean
  SIGNAL delayline_b3479                  : std_logic; -- boolean
  SIGNAL delayline_b3503                  : std_logic; -- boolean
  SIGNAL delayline_b3527                  : std_logic; -- boolean
  SIGNAL delayline_b3551                  : std_logic; -- boolean
  SIGNAL delayline_b3575                  : std_logic; -- boolean
  SIGNAL delayline_b3599                  : std_logic; -- boolean
  SIGNAL delayline_b3623                  : std_logic; -- boolean
  SIGNAL delayline_b3647                  : std_logic; -- boolean
  SIGNAL delayline_b3671                  : std_logic; -- boolean
  SIGNAL delayline_b3695                  : std_logic; -- boolean
  SIGNAL delayline_b3719                  : std_logic; -- boolean
  SIGNAL delayline_b3743                  : std_logic; -- boolean
  SIGNAL delayline_b3767                  : std_logic; -- boolean
  SIGNAL delayline_b3791                  : std_logic; -- boolean
  SIGNAL delayline_b3815                  : std_logic; -- boolean
  SIGNAL delayline_b3839                  : std_logic; -- boolean
  SIGNAL delayline_b3863                  : std_logic; -- boolean
  SIGNAL delayline_b3887                  : std_logic; -- boolean
  SIGNAL delayline_b3911                  : std_logic; -- boolean
  SIGNAL delayline_b3935                  : std_logic; -- boolean
  SIGNAL delayline_b3959                  : std_logic; -- boolean
  SIGNAL delayline_b3983                  : std_logic; -- boolean
  SIGNAL delayline_b4007                  : std_logic; -- boolean
  SIGNAL delayline_b4031                  : std_logic; -- boolean
  SIGNAL delayline_b4055                  : std_logic; -- boolean
  SIGNAL delayline_b4079                  : std_logic; -- boolean
  SIGNAL delayline_b4103                  : std_logic; -- boolean
  SIGNAL delayline_b4127                  : std_logic; -- boolean
  SIGNAL delayline_b4151                  : std_logic; -- boolean
  SIGNAL delayline_b4175                  : std_logic; -- boolean
  SIGNAL delayline_b4199                  : std_logic; -- boolean
  SIGNAL delayline_b4223                  : std_logic; -- boolean
  SIGNAL delayline_b4247                  : std_logic; -- boolean
  SIGNAL delayline_b4271                  : std_logic; -- boolean
  SIGNAL delayline_b4295                  : std_logic; -- boolean
  SIGNAL delayline_b4319                  : std_logic; -- boolean
  SIGNAL delayline_b4343                  : std_logic; -- boolean
  SIGNAL delayline_b4367                  : std_logic; -- boolean
  SIGNAL delayline_b4391                  : std_logic; -- boolean
  SIGNAL delayline_b4415                  : std_logic; -- boolean
  SIGNAL delayline_b4439                  : std_logic; -- boolean
  SIGNAL delayline_b4463                  : std_logic; -- boolean
  SIGNAL delayline_b4487                  : std_logic; -- boolean
  SIGNAL delayline_b4511                  : std_logic; -- boolean
  SIGNAL delayline_b4535                  : std_logic; -- boolean
  SIGNAL delayline_b4559                  : std_logic; -- boolean
  SIGNAL delayline_b4583                  : std_logic; -- boolean
  SIGNAL delayline_b4607                  : std_logic; -- boolean
  SIGNAL delayline_b4631                  : std_logic; -- boolean
  SIGNAL delayline_b4655                  : std_logic; -- boolean
  SIGNAL delayline_b4679                  : std_logic; -- boolean
  SIGNAL delayline_b4703                  : std_logic; -- boolean
  SIGNAL delayline_b4727                  : std_logic; -- boolean
  SIGNAL delayline_b4751                  : std_logic; -- boolean
  SIGNAL delayline_b4775                  : std_logic; -- boolean
  SIGNAL delayline_b4799                  : std_logic; -- boolean
  SIGNAL delayline_b4823                  : std_logic; -- boolean
  SIGNAL delayline_b4847                  : std_logic; -- boolean
  SIGNAL delayline_b4871                  : std_logic; -- boolean
  SIGNAL delayline_b4895                  : std_logic; -- boolean
  SIGNAL delayline_b4919                  : std_logic; -- boolean
  SIGNAL delayline_b4943                  : std_logic; -- boolean
  SIGNAL delayline_b4967                  : std_logic; -- boolean
  SIGNAL delayline_b4991                  : std_logic; -- boolean
  SIGNAL delayline_b5015                  : std_logic; -- boolean
  SIGNAL delayline_b5039                  : std_logic; -- boolean
  SIGNAL delayline_b5063                  : std_logic; -- boolean
  SIGNAL delayline_b5087                  : std_logic; -- boolean
  SIGNAL delayline_b5111                  : std_logic; -- boolean
  SIGNAL delayline_b5135                  : std_logic; -- boolean
  SIGNAL delayline_b5159                  : std_logic; -- boolean
  SIGNAL delayline_b5183                  : std_logic; -- boolean
  SIGNAL delayline_b5207                  : std_logic; -- boolean
  SIGNAL delayline_b5231                  : std_logic; -- boolean
  SIGNAL delayline_b5255                  : std_logic; -- boolean
  SIGNAL delayline_b5279                  : std_logic; -- boolean
  SIGNAL delayline_b5303                  : std_logic; -- boolean
  SIGNAL delayline_b5327                  : std_logic; -- boolean
  SIGNAL delayline_b5351                  : std_logic; -- boolean
  SIGNAL delayline_b5375                  : std_logic; -- boolean
  SIGNAL delayline_b5399                  : std_logic; -- boolean
  SIGNAL delayline_b5423                  : std_logic; -- boolean
  SIGNAL delayline_b5447                  : std_logic; -- boolean
  SIGNAL delayline_b5471                  : std_logic; -- boolean
  SIGNAL delayline_b5495                  : std_logic; -- boolean
  SIGNAL delayline_b5519                  : std_logic; -- boolean
  SIGNAL delayline_b5543                  : std_logic; -- boolean
  SIGNAL delayline_b5567                  : std_logic; -- boolean
  SIGNAL delayline_b5591                  : std_logic; -- boolean
  SIGNAL delayline_b5615                  : std_logic; -- boolean
  SIGNAL delayline_b5639                  : std_logic; -- boolean
  SIGNAL delayline_b5663                  : std_logic; -- boolean
  SIGNAL delayline_b5687                  : std_logic; -- boolean
  SIGNAL delayline_b5711                  : std_logic; -- boolean
  SIGNAL delayline_b5735                  : std_logic; -- boolean
  SIGNAL delayline_b5759                  : std_logic; -- boolean
  SIGNAL delayline_b5783                  : std_logic; -- boolean
  SIGNAL delayline_b5807                  : std_logic; -- boolean
  SIGNAL delayline_b5831                  : std_logic; -- boolean
  SIGNAL delayline_b5855                  : std_logic; -- boolean
  SIGNAL delayline_b5879                  : std_logic; -- boolean
  SIGNAL delayline_b5903                  : std_logic; -- boolean
  SIGNAL delayline_b5927                  : std_logic; -- boolean
  SIGNAL delayline_b5951                  : std_logic; -- boolean
  SIGNAL delayline_b5975                  : std_logic; -- boolean
  SIGNAL delayline_b5999                  : std_logic; -- boolean
  SIGNAL delayline_b6023                  : std_logic; -- boolean
  SIGNAL delayline_b6047                  : std_logic; -- boolean
  SIGNAL delayline_b6071                  : std_logic; -- boolean
  SIGNAL delayline_b6095                  : std_logic; -- boolean
  SIGNAL delayline_b6119                  : std_logic; -- boolean
  SIGNAL delayline_b6143                  : std_logic; -- boolean
  SIGNAL preaddbit1                       : std_logic; -- boolean
  SIGNAL addcarry1                        : std_logic; -- boolean
  SIGNAL carrymux1                        : std_logic; -- boolean
  SIGNAL carryreg1                        : std_logic; -- boolean
  SIGNAL temp1                            : std_logic; -- boolean
  SIGNAL temp2                            : std_logic; -- boolean
  SIGNAL temp3                            : std_logic; -- boolean
  SIGNAL preaddbit2                       : std_logic; -- boolean
  SIGNAL addcarry2                        : std_logic; -- boolean
  SIGNAL carrymux2                        : std_logic; -- boolean
  SIGNAL carryreg2                        : std_logic; -- boolean
  SIGNAL temp1_1                          : std_logic; -- boolean
  SIGNAL temp2_1                          : std_logic; -- boolean
  SIGNAL temp3_1                          : std_logic; -- boolean
  SIGNAL preaddbit3                       : std_logic; -- boolean
  SIGNAL addcarry3                        : std_logic; -- boolean
  SIGNAL carrymux3                        : std_logic; -- boolean
  SIGNAL carryreg3                        : std_logic; -- boolean
  SIGNAL temp1_2                          : std_logic; -- boolean
  SIGNAL temp2_2                          : std_logic; -- boolean
  SIGNAL temp3_2                          : std_logic; -- boolean
  SIGNAL preaddbit4                       : std_logic; -- boolean
  SIGNAL addcarry4                        : std_logic; -- boolean
  SIGNAL carrymux4                        : std_logic; -- boolean
  SIGNAL carryreg4                        : std_logic; -- boolean
  SIGNAL temp1_3                          : std_logic; -- boolean
  SIGNAL temp2_3                          : std_logic; -- boolean
  SIGNAL temp3_3                          : std_logic; -- boolean
  SIGNAL preaddbit5                       : std_logic; -- boolean
  SIGNAL addcarry5                        : std_logic; -- boolean
  SIGNAL carrymux5                        : std_logic; -- boolean
  SIGNAL carryreg5                        : std_logic; -- boolean
  SIGNAL temp1_4                          : std_logic; -- boolean
  SIGNAL temp2_4                          : std_logic; -- boolean
  SIGNAL temp3_4                          : std_logic; -- boolean
  SIGNAL preaddbit6                       : std_logic; -- boolean
  SIGNAL addcarry6                        : std_logic; -- boolean
  SIGNAL carrymux6                        : std_logic; -- boolean
  SIGNAL carryreg6                        : std_logic; -- boolean
  SIGNAL temp1_5                          : std_logic; -- boolean
  SIGNAL temp2_5                          : std_logic; -- boolean
  SIGNAL temp3_5                          : std_logic; -- boolean
  SIGNAL preaddbit7                       : std_logic; -- boolean
  SIGNAL addcarry7                        : std_logic; -- boolean
  SIGNAL carrymux7                        : std_logic; -- boolean
  SIGNAL carryreg7                        : std_logic; -- boolean
  SIGNAL temp1_6                          : std_logic; -- boolean
  SIGNAL temp2_6                          : std_logic; -- boolean
  SIGNAL temp3_6                          : std_logic; -- boolean
  SIGNAL preaddbit8                       : std_logic; -- boolean
  SIGNAL addcarry8                        : std_logic; -- boolean
  SIGNAL carrymux8                        : std_logic; -- boolean
  SIGNAL carryreg8                        : std_logic; -- boolean
  SIGNAL temp1_7                          : std_logic; -- boolean
  SIGNAL temp2_7                          : std_logic; -- boolean
  SIGNAL temp3_7                          : std_logic; -- boolean
  SIGNAL preaddbit9                       : std_logic; -- boolean
  SIGNAL addcarry9                        : std_logic; -- boolean
  SIGNAL carrymux9                        : std_logic; -- boolean
  SIGNAL carryreg9                        : std_logic; -- boolean
  SIGNAL temp1_8                          : std_logic; -- boolean
  SIGNAL temp2_8                          : std_logic; -- boolean
  SIGNAL temp3_8                          : std_logic; -- boolean
  SIGNAL preaddbit10                      : std_logic; -- boolean
  SIGNAL addcarry10                       : std_logic; -- boolean
  SIGNAL carrymux10                       : std_logic; -- boolean
  SIGNAL carryreg10                       : std_logic; -- boolean
  SIGNAL temp1_9                          : std_logic; -- boolean
  SIGNAL temp2_9                          : std_logic; -- boolean
  SIGNAL temp3_9                          : std_logic; -- boolean
  SIGNAL preaddbit11                      : std_logic; -- boolean
  SIGNAL addcarry11                       : std_logic; -- boolean
  SIGNAL carrymux11                       : std_logic; -- boolean
  SIGNAL carryreg11                       : std_logic; -- boolean
  SIGNAL temp1_10                         : std_logic; -- boolean
  SIGNAL temp2_10                         : std_logic; -- boolean
  SIGNAL temp3_10                         : std_logic; -- boolean
  SIGNAL preaddbit12                      : std_logic; -- boolean
  SIGNAL addcarry12                       : std_logic; -- boolean
  SIGNAL carrymux12                       : std_logic; -- boolean
  SIGNAL carryreg12                       : std_logic; -- boolean
  SIGNAL temp1_11                         : std_logic; -- boolean
  SIGNAL temp2_11                         : std_logic; -- boolean
  SIGNAL temp3_11                         : std_logic; -- boolean
  SIGNAL preaddbit13                      : std_logic; -- boolean
  SIGNAL addcarry13                       : std_logic; -- boolean
  SIGNAL carrymux13                       : std_logic; -- boolean
  SIGNAL carryreg13                       : std_logic; -- boolean
  SIGNAL temp1_12                         : std_logic; -- boolean
  SIGNAL temp2_12                         : std_logic; -- boolean
  SIGNAL temp3_12                         : std_logic; -- boolean
  SIGNAL preaddbit14                      : std_logic; -- boolean
  SIGNAL addcarry14                       : std_logic; -- boolean
  SIGNAL carrymux14                       : std_logic; -- boolean
  SIGNAL carryreg14                       : std_logic; -- boolean
  SIGNAL temp1_13                         : std_logic; -- boolean
  SIGNAL temp2_13                         : std_logic; -- boolean
  SIGNAL temp3_13                         : std_logic; -- boolean
  SIGNAL preaddbit15                      : std_logic; -- boolean
  SIGNAL addcarry15                       : std_logic; -- boolean
  SIGNAL carrymux15                       : std_logic; -- boolean
  SIGNAL carryreg15                       : std_logic; -- boolean
  SIGNAL temp1_14                         : std_logic; -- boolean
  SIGNAL temp2_14                         : std_logic; -- boolean
  SIGNAL temp3_14                         : std_logic; -- boolean
  SIGNAL preaddbit16                      : std_logic; -- boolean
  SIGNAL addcarry16                       : std_logic; -- boolean
  SIGNAL carrymux16                       : std_logic; -- boolean
  SIGNAL carryreg16                       : std_logic; -- boolean
  SIGNAL temp1_15                         : std_logic; -- boolean
  SIGNAL temp2_15                         : std_logic; -- boolean
  SIGNAL temp3_15                         : std_logic; -- boolean
  SIGNAL preaddbit17                      : std_logic; -- boolean
  SIGNAL addcarry17                       : std_logic; -- boolean
  SIGNAL carrymux17                       : std_logic; -- boolean
  SIGNAL carryreg17                       : std_logic; -- boolean
  SIGNAL temp1_16                         : std_logic; -- boolean
  SIGNAL temp2_16                         : std_logic; -- boolean
  SIGNAL temp3_16                         : std_logic; -- boolean
  SIGNAL preaddbit18                      : std_logic; -- boolean
  SIGNAL addcarry18                       : std_logic; -- boolean
  SIGNAL carrymux18                       : std_logic; -- boolean
  SIGNAL carryreg18                       : std_logic; -- boolean
  SIGNAL temp1_17                         : std_logic; -- boolean
  SIGNAL temp2_17                         : std_logic; -- boolean
  SIGNAL temp3_17                         : std_logic; -- boolean
  SIGNAL preaddbit19                      : std_logic; -- boolean
  SIGNAL addcarry19                       : std_logic; -- boolean
  SIGNAL carrymux19                       : std_logic; -- boolean
  SIGNAL carryreg19                       : std_logic; -- boolean
  SIGNAL temp1_18                         : std_logic; -- boolean
  SIGNAL temp2_18                         : std_logic; -- boolean
  SIGNAL temp3_18                         : std_logic; -- boolean
  SIGNAL preaddbit20                      : std_logic; -- boolean
  SIGNAL addcarry20                       : std_logic; -- boolean
  SIGNAL carrymux20                       : std_logic; -- boolean
  SIGNAL carryreg20                       : std_logic; -- boolean
  SIGNAL temp1_19                         : std_logic; -- boolean
  SIGNAL temp2_19                         : std_logic; -- boolean
  SIGNAL temp3_19                         : std_logic; -- boolean
  SIGNAL preaddbit21                      : std_logic; -- boolean
  SIGNAL addcarry21                       : std_logic; -- boolean
  SIGNAL carrymux21                       : std_logic; -- boolean
  SIGNAL carryreg21                       : std_logic; -- boolean
  SIGNAL temp1_20                         : std_logic; -- boolean
  SIGNAL temp2_20                         : std_logic; -- boolean
  SIGNAL temp3_20                         : std_logic; -- boolean
  SIGNAL preaddbit22                      : std_logic; -- boolean
  SIGNAL addcarry22                       : std_logic; -- boolean
  SIGNAL carrymux22                       : std_logic; -- boolean
  SIGNAL carryreg22                       : std_logic; -- boolean
  SIGNAL temp1_21                         : std_logic; -- boolean
  SIGNAL temp2_21                         : std_logic; -- boolean
  SIGNAL temp3_21                         : std_logic; -- boolean
  SIGNAL preaddbit23                      : std_logic; -- boolean
  SIGNAL addcarry23                       : std_logic; -- boolean
  SIGNAL carrymux23                       : std_logic; -- boolean
  SIGNAL carryreg23                       : std_logic; -- boolean
  SIGNAL temp1_22                         : std_logic; -- boolean
  SIGNAL temp2_22                         : std_logic; -- boolean
  SIGNAL temp3_22                         : std_logic; -- boolean
  SIGNAL preaddbit24                      : std_logic; -- boolean
  SIGNAL addcarry24                       : std_logic; -- boolean
  SIGNAL carrymux24                       : std_logic; -- boolean
  SIGNAL carryreg24                       : std_logic; -- boolean
  SIGNAL temp1_23                         : std_logic; -- boolean
  SIGNAL temp2_23                         : std_logic; -- boolean
  SIGNAL temp3_23                         : std_logic; -- boolean
  SIGNAL preaddbit25                      : std_logic; -- boolean
  SIGNAL addcarry25                       : std_logic; -- boolean
  SIGNAL carrymux25                       : std_logic; -- boolean
  SIGNAL carryreg25                       : std_logic; -- boolean
  SIGNAL temp1_24                         : std_logic; -- boolean
  SIGNAL temp2_24                         : std_logic; -- boolean
  SIGNAL temp3_24                         : std_logic; -- boolean
  SIGNAL preaddbit26                      : std_logic; -- boolean
  SIGNAL addcarry26                       : std_logic; -- boolean
  SIGNAL carrymux26                       : std_logic; -- boolean
  SIGNAL carryreg26                       : std_logic; -- boolean
  SIGNAL temp1_25                         : std_logic; -- boolean
  SIGNAL temp2_25                         : std_logic; -- boolean
  SIGNAL temp3_25                         : std_logic; -- boolean
  SIGNAL preaddbit27                      : std_logic; -- boolean
  SIGNAL addcarry27                       : std_logic; -- boolean
  SIGNAL carrymux27                       : std_logic; -- boolean
  SIGNAL carryreg27                       : std_logic; -- boolean
  SIGNAL temp1_26                         : std_logic; -- boolean
  SIGNAL temp2_26                         : std_logic; -- boolean
  SIGNAL temp3_26                         : std_logic; -- boolean
  SIGNAL preaddbit28                      : std_logic; -- boolean
  SIGNAL addcarry28                       : std_logic; -- boolean
  SIGNAL carrymux28                       : std_logic; -- boolean
  SIGNAL carryreg28                       : std_logic; -- boolean
  SIGNAL temp1_27                         : std_logic; -- boolean
  SIGNAL temp2_27                         : std_logic; -- boolean
  SIGNAL temp3_27                         : std_logic; -- boolean
  SIGNAL preaddbit29                      : std_logic; -- boolean
  SIGNAL addcarry29                       : std_logic; -- boolean
  SIGNAL carrymux29                       : std_logic; -- boolean
  SIGNAL carryreg29                       : std_logic; -- boolean
  SIGNAL temp1_28                         : std_logic; -- boolean
  SIGNAL temp2_28                         : std_logic; -- boolean
  SIGNAL temp3_28                         : std_logic; -- boolean
  SIGNAL preaddbit30                      : std_logic; -- boolean
  SIGNAL addcarry30                       : std_logic; -- boolean
  SIGNAL carrymux30                       : std_logic; -- boolean
  SIGNAL carryreg30                       : std_logic; -- boolean
  SIGNAL temp1_29                         : std_logic; -- boolean
  SIGNAL temp2_29                         : std_logic; -- boolean
  SIGNAL temp3_29                         : std_logic; -- boolean
  SIGNAL preaddbit31                      : std_logic; -- boolean
  SIGNAL addcarry31                       : std_logic; -- boolean
  SIGNAL carrymux31                       : std_logic; -- boolean
  SIGNAL carryreg31                       : std_logic; -- boolean
  SIGNAL temp1_30                         : std_logic; -- boolean
  SIGNAL temp2_30                         : std_logic; -- boolean
  SIGNAL temp3_30                         : std_logic; -- boolean
  SIGNAL preaddbit32                      : std_logic; -- boolean
  SIGNAL addcarry32                       : std_logic; -- boolean
  SIGNAL carrymux32                       : std_logic; -- boolean
  SIGNAL carryreg32                       : std_logic; -- boolean
  SIGNAL temp1_31                         : std_logic; -- boolean
  SIGNAL temp2_31                         : std_logic; -- boolean
  SIGNAL temp3_31                         : std_logic; -- boolean
  SIGNAL preaddbit33                      : std_logic; -- boolean
  SIGNAL addcarry33                       : std_logic; -- boolean
  SIGNAL carrymux33                       : std_logic; -- boolean
  SIGNAL carryreg33                       : std_logic; -- boolean
  SIGNAL temp1_32                         : std_logic; -- boolean
  SIGNAL temp2_32                         : std_logic; -- boolean
  SIGNAL temp3_32                         : std_logic; -- boolean
  SIGNAL preaddbit34                      : std_logic; -- boolean
  SIGNAL addcarry34                       : std_logic; -- boolean
  SIGNAL carrymux34                       : std_logic; -- boolean
  SIGNAL carryreg34                       : std_logic; -- boolean
  SIGNAL temp1_33                         : std_logic; -- boolean
  SIGNAL temp2_33                         : std_logic; -- boolean
  SIGNAL temp3_33                         : std_logic; -- boolean
  SIGNAL preaddbit35                      : std_logic; -- boolean
  SIGNAL addcarry35                       : std_logic; -- boolean
  SIGNAL carrymux35                       : std_logic; -- boolean
  SIGNAL carryreg35                       : std_logic; -- boolean
  SIGNAL temp1_34                         : std_logic; -- boolean
  SIGNAL temp2_34                         : std_logic; -- boolean
  SIGNAL temp3_34                         : std_logic; -- boolean
  SIGNAL preaddbit36                      : std_logic; -- boolean
  SIGNAL addcarry36                       : std_logic; -- boolean
  SIGNAL carrymux36                       : std_logic; -- boolean
  SIGNAL carryreg36                       : std_logic; -- boolean
  SIGNAL temp1_35                         : std_logic; -- boolean
  SIGNAL temp2_35                         : std_logic; -- boolean
  SIGNAL temp3_35                         : std_logic; -- boolean
  SIGNAL preaddbit37                      : std_logic; -- boolean
  SIGNAL addcarry37                       : std_logic; -- boolean
  SIGNAL carrymux37                       : std_logic; -- boolean
  SIGNAL carryreg37                       : std_logic; -- boolean
  SIGNAL temp1_36                         : std_logic; -- boolean
  SIGNAL temp2_36                         : std_logic; -- boolean
  SIGNAL temp3_36                         : std_logic; -- boolean
  SIGNAL preaddbit38                      : std_logic; -- boolean
  SIGNAL addcarry38                       : std_logic; -- boolean
  SIGNAL carrymux38                       : std_logic; -- boolean
  SIGNAL carryreg38                       : std_logic; -- boolean
  SIGNAL temp1_37                         : std_logic; -- boolean
  SIGNAL temp2_37                         : std_logic; -- boolean
  SIGNAL temp3_37                         : std_logic; -- boolean
  SIGNAL preaddbit39                      : std_logic; -- boolean
  SIGNAL addcarry39                       : std_logic; -- boolean
  SIGNAL carrymux39                       : std_logic; -- boolean
  SIGNAL carryreg39                       : std_logic; -- boolean
  SIGNAL temp1_38                         : std_logic; -- boolean
  SIGNAL temp2_38                         : std_logic; -- boolean
  SIGNAL temp3_38                         : std_logic; -- boolean
  SIGNAL preaddbit40                      : std_logic; -- boolean
  SIGNAL addcarry40                       : std_logic; -- boolean
  SIGNAL carrymux40                       : std_logic; -- boolean
  SIGNAL carryreg40                       : std_logic; -- boolean
  SIGNAL temp1_39                         : std_logic; -- boolean
  SIGNAL temp2_39                         : std_logic; -- boolean
  SIGNAL temp3_39                         : std_logic; -- boolean
  SIGNAL preaddbit41                      : std_logic; -- boolean
  SIGNAL addcarry41                       : std_logic; -- boolean
  SIGNAL carrymux41                       : std_logic; -- boolean
  SIGNAL carryreg41                       : std_logic; -- boolean
  SIGNAL temp1_40                         : std_logic; -- boolean
  SIGNAL temp2_40                         : std_logic; -- boolean
  SIGNAL temp3_40                         : std_logic; -- boolean
  SIGNAL preaddbit42                      : std_logic; -- boolean
  SIGNAL addcarry42                       : std_logic; -- boolean
  SIGNAL carrymux42                       : std_logic; -- boolean
  SIGNAL carryreg42                       : std_logic; -- boolean
  SIGNAL temp1_41                         : std_logic; -- boolean
  SIGNAL temp2_41                         : std_logic; -- boolean
  SIGNAL temp3_41                         : std_logic; -- boolean
  SIGNAL preaddbit43                      : std_logic; -- boolean
  SIGNAL addcarry43                       : std_logic; -- boolean
  SIGNAL carrymux43                       : std_logic; -- boolean
  SIGNAL carryreg43                       : std_logic; -- boolean
  SIGNAL temp1_42                         : std_logic; -- boolean
  SIGNAL temp2_42                         : std_logic; -- boolean
  SIGNAL temp3_42                         : std_logic; -- boolean
  SIGNAL preaddbit44                      : std_logic; -- boolean
  SIGNAL addcarry44                       : std_logic; -- boolean
  SIGNAL carrymux44                       : std_logic; -- boolean
  SIGNAL carryreg44                       : std_logic; -- boolean
  SIGNAL temp1_43                         : std_logic; -- boolean
  SIGNAL temp2_43                         : std_logic; -- boolean
  SIGNAL temp3_43                         : std_logic; -- boolean
  SIGNAL preaddbit45                      : std_logic; -- boolean
  SIGNAL addcarry45                       : std_logic; -- boolean
  SIGNAL carrymux45                       : std_logic; -- boolean
  SIGNAL carryreg45                       : std_logic; -- boolean
  SIGNAL temp1_44                         : std_logic; -- boolean
  SIGNAL temp2_44                         : std_logic; -- boolean
  SIGNAL temp3_44                         : std_logic; -- boolean
  SIGNAL preaddbit46                      : std_logic; -- boolean
  SIGNAL addcarry46                       : std_logic; -- boolean
  SIGNAL carrymux46                       : std_logic; -- boolean
  SIGNAL carryreg46                       : std_logic; -- boolean
  SIGNAL temp1_45                         : std_logic; -- boolean
  SIGNAL temp2_45                         : std_logic; -- boolean
  SIGNAL temp3_45                         : std_logic; -- boolean
  SIGNAL preaddbit47                      : std_logic; -- boolean
  SIGNAL addcarry47                       : std_logic; -- boolean
  SIGNAL carrymux47                       : std_logic; -- boolean
  SIGNAL carryreg47                       : std_logic; -- boolean
  SIGNAL temp1_46                         : std_logic; -- boolean
  SIGNAL temp2_46                         : std_logic; -- boolean
  SIGNAL temp3_46                         : std_logic; -- boolean
  SIGNAL preaddbit48                      : std_logic; -- boolean
  SIGNAL addcarry48                       : std_logic; -- boolean
  SIGNAL carrymux48                       : std_logic; -- boolean
  SIGNAL carryreg48                       : std_logic; -- boolean
  SIGNAL temp1_47                         : std_logic; -- boolean
  SIGNAL temp2_47                         : std_logic; -- boolean
  SIGNAL temp3_47                         : std_logic; -- boolean
  SIGNAL preaddbit49                      : std_logic; -- boolean
  SIGNAL addcarry49                       : std_logic; -- boolean
  SIGNAL carrymux49                       : std_logic; -- boolean
  SIGNAL carryreg49                       : std_logic; -- boolean
  SIGNAL temp1_48                         : std_logic; -- boolean
  SIGNAL temp2_48                         : std_logic; -- boolean
  SIGNAL temp3_48                         : std_logic; -- boolean
  SIGNAL preaddbit50                      : std_logic; -- boolean
  SIGNAL addcarry50                       : std_logic; -- boolean
  SIGNAL carrymux50                       : std_logic; -- boolean
  SIGNAL carryreg50                       : std_logic; -- boolean
  SIGNAL temp1_49                         : std_logic; -- boolean
  SIGNAL temp2_49                         : std_logic; -- boolean
  SIGNAL temp3_49                         : std_logic; -- boolean
  SIGNAL preaddbit51                      : std_logic; -- boolean
  SIGNAL addcarry51                       : std_logic; -- boolean
  SIGNAL carrymux51                       : std_logic; -- boolean
  SIGNAL carryreg51                       : std_logic; -- boolean
  SIGNAL temp1_50                         : std_logic; -- boolean
  SIGNAL temp2_50                         : std_logic; -- boolean
  SIGNAL temp3_50                         : std_logic; -- boolean
  SIGNAL preaddbit52                      : std_logic; -- boolean
  SIGNAL addcarry52                       : std_logic; -- boolean
  SIGNAL carrymux52                       : std_logic; -- boolean
  SIGNAL carryreg52                       : std_logic; -- boolean
  SIGNAL temp1_51                         : std_logic; -- boolean
  SIGNAL temp2_51                         : std_logic; -- boolean
  SIGNAL temp3_51                         : std_logic; -- boolean
  SIGNAL preaddbit53                      : std_logic; -- boolean
  SIGNAL addcarry53                       : std_logic; -- boolean
  SIGNAL carrymux53                       : std_logic; -- boolean
  SIGNAL carryreg53                       : std_logic; -- boolean
  SIGNAL temp1_52                         : std_logic; -- boolean
  SIGNAL temp2_52                         : std_logic; -- boolean
  SIGNAL temp3_52                         : std_logic; -- boolean
  SIGNAL preaddbit54                      : std_logic; -- boolean
  SIGNAL addcarry54                       : std_logic; -- boolean
  SIGNAL carrymux54                       : std_logic; -- boolean
  SIGNAL carryreg54                       : std_logic; -- boolean
  SIGNAL temp1_53                         : std_logic; -- boolean
  SIGNAL temp2_53                         : std_logic; -- boolean
  SIGNAL temp3_53                         : std_logic; -- boolean
  SIGNAL preaddbit55                      : std_logic; -- boolean
  SIGNAL addcarry55                       : std_logic; -- boolean
  SIGNAL carrymux55                       : std_logic; -- boolean
  SIGNAL carryreg55                       : std_logic; -- boolean
  SIGNAL temp1_54                         : std_logic; -- boolean
  SIGNAL temp2_54                         : std_logic; -- boolean
  SIGNAL temp3_54                         : std_logic; -- boolean
  SIGNAL preaddbit56                      : std_logic; -- boolean
  SIGNAL addcarry56                       : std_logic; -- boolean
  SIGNAL carrymux56                       : std_logic; -- boolean
  SIGNAL carryreg56                       : std_logic; -- boolean
  SIGNAL temp1_55                         : std_logic; -- boolean
  SIGNAL temp2_55                         : std_logic; -- boolean
  SIGNAL temp3_55                         : std_logic; -- boolean
  SIGNAL preaddbit57                      : std_logic; -- boolean
  SIGNAL addcarry57                       : std_logic; -- boolean
  SIGNAL carrymux57                       : std_logic; -- boolean
  SIGNAL carryreg57                       : std_logic; -- boolean
  SIGNAL temp1_56                         : std_logic; -- boolean
  SIGNAL temp2_56                         : std_logic; -- boolean
  SIGNAL temp3_56                         : std_logic; -- boolean
  SIGNAL preaddbit58                      : std_logic; -- boolean
  SIGNAL addcarry58                       : std_logic; -- boolean
  SIGNAL carrymux58                       : std_logic; -- boolean
  SIGNAL carryreg58                       : std_logic; -- boolean
  SIGNAL temp1_57                         : std_logic; -- boolean
  SIGNAL temp2_57                         : std_logic; -- boolean
  SIGNAL temp3_57                         : std_logic; -- boolean
  SIGNAL preaddbit59                      : std_logic; -- boolean
  SIGNAL addcarry59                       : std_logic; -- boolean
  SIGNAL carrymux59                       : std_logic; -- boolean
  SIGNAL carryreg59                       : std_logic; -- boolean
  SIGNAL temp1_58                         : std_logic; -- boolean
  SIGNAL temp2_58                         : std_logic; -- boolean
  SIGNAL temp3_58                         : std_logic; -- boolean
  SIGNAL preaddbit60                      : std_logic; -- boolean
  SIGNAL addcarry60                       : std_logic; -- boolean
  SIGNAL carrymux60                       : std_logic; -- boolean
  SIGNAL carryreg60                       : std_logic; -- boolean
  SIGNAL temp1_59                         : std_logic; -- boolean
  SIGNAL temp2_59                         : std_logic; -- boolean
  SIGNAL temp3_59                         : std_logic; -- boolean
  SIGNAL preaddbit61                      : std_logic; -- boolean
  SIGNAL addcarry61                       : std_logic; -- boolean
  SIGNAL carrymux61                       : std_logic; -- boolean
  SIGNAL carryreg61                       : std_logic; -- boolean
  SIGNAL temp1_60                         : std_logic; -- boolean
  SIGNAL temp2_60                         : std_logic; -- boolean
  SIGNAL temp3_60                         : std_logic; -- boolean
  SIGNAL preaddbit62                      : std_logic; -- boolean
  SIGNAL addcarry62                       : std_logic; -- boolean
  SIGNAL carrymux62                       : std_logic; -- boolean
  SIGNAL carryreg62                       : std_logic; -- boolean
  SIGNAL temp1_61                         : std_logic; -- boolean
  SIGNAL temp2_61                         : std_logic; -- boolean
  SIGNAL temp3_61                         : std_logic; -- boolean
  SIGNAL preaddbit63                      : std_logic; -- boolean
  SIGNAL addcarry63                       : std_logic; -- boolean
  SIGNAL carrymux63                       : std_logic; -- boolean
  SIGNAL carryreg63                       : std_logic; -- boolean
  SIGNAL temp1_62                         : std_logic; -- boolean
  SIGNAL temp2_62                         : std_logic; -- boolean
  SIGNAL temp3_62                         : std_logic; -- boolean
  SIGNAL preaddbit64                      : std_logic; -- boolean
  SIGNAL addcarry64                       : std_logic; -- boolean
  SIGNAL carrymux64                       : std_logic; -- boolean
  SIGNAL carryreg64                       : std_logic; -- boolean
  SIGNAL temp1_63                         : std_logic; -- boolean
  SIGNAL temp2_63                         : std_logic; -- boolean
  SIGNAL temp3_63                         : std_logic; -- boolean
  SIGNAL preaddbit65                      : std_logic; -- boolean
  SIGNAL addcarry65                       : std_logic; -- boolean
  SIGNAL carrymux65                       : std_logic; -- boolean
  SIGNAL carryreg65                       : std_logic; -- boolean
  SIGNAL temp1_64                         : std_logic; -- boolean
  SIGNAL temp2_64                         : std_logic; -- boolean
  SIGNAL temp3_64                         : std_logic; -- boolean
  SIGNAL preaddbit66                      : std_logic; -- boolean
  SIGNAL addcarry66                       : std_logic; -- boolean
  SIGNAL carrymux66                       : std_logic; -- boolean
  SIGNAL carryreg66                       : std_logic; -- boolean
  SIGNAL temp1_65                         : std_logic; -- boolean
  SIGNAL temp2_65                         : std_logic; -- boolean
  SIGNAL temp3_65                         : std_logic; -- boolean
  SIGNAL preaddbit67                      : std_logic; -- boolean
  SIGNAL addcarry67                       : std_logic; -- boolean
  SIGNAL carrymux67                       : std_logic; -- boolean
  SIGNAL carryreg67                       : std_logic; -- boolean
  SIGNAL temp1_66                         : std_logic; -- boolean
  SIGNAL temp2_66                         : std_logic; -- boolean
  SIGNAL temp3_66                         : std_logic; -- boolean
  SIGNAL preaddbit68                      : std_logic; -- boolean
  SIGNAL addcarry68                       : std_logic; -- boolean
  SIGNAL carrymux68                       : std_logic; -- boolean
  SIGNAL carryreg68                       : std_logic; -- boolean
  SIGNAL temp1_67                         : std_logic; -- boolean
  SIGNAL temp2_67                         : std_logic; -- boolean
  SIGNAL temp3_67                         : std_logic; -- boolean
  SIGNAL preaddbit69                      : std_logic; -- boolean
  SIGNAL addcarry69                       : std_logic; -- boolean
  SIGNAL carrymux69                       : std_logic; -- boolean
  SIGNAL carryreg69                       : std_logic; -- boolean
  SIGNAL temp1_68                         : std_logic; -- boolean
  SIGNAL temp2_68                         : std_logic; -- boolean
  SIGNAL temp3_68                         : std_logic; -- boolean
  SIGNAL preaddbit70                      : std_logic; -- boolean
  SIGNAL addcarry70                       : std_logic; -- boolean
  SIGNAL carrymux70                       : std_logic; -- boolean
  SIGNAL carryreg70                       : std_logic; -- boolean
  SIGNAL temp1_69                         : std_logic; -- boolean
  SIGNAL temp2_69                         : std_logic; -- boolean
  SIGNAL temp3_69                         : std_logic; -- boolean
  SIGNAL preaddbit71                      : std_logic; -- boolean
  SIGNAL addcarry71                       : std_logic; -- boolean
  SIGNAL carrymux71                       : std_logic; -- boolean
  SIGNAL carryreg71                       : std_logic; -- boolean
  SIGNAL temp1_70                         : std_logic; -- boolean
  SIGNAL temp2_70                         : std_logic; -- boolean
  SIGNAL temp3_70                         : std_logic; -- boolean
  SIGNAL preaddbit72                      : std_logic; -- boolean
  SIGNAL addcarry72                       : std_logic; -- boolean
  SIGNAL carrymux72                       : std_logic; -- boolean
  SIGNAL carryreg72                       : std_logic; -- boolean
  SIGNAL temp1_71                         : std_logic; -- boolean
  SIGNAL temp2_71                         : std_logic; -- boolean
  SIGNAL temp3_71                         : std_logic; -- boolean
  SIGNAL preaddbit73                      : std_logic; -- boolean
  SIGNAL addcarry73                       : std_logic; -- boolean
  SIGNAL carrymux73                       : std_logic; -- boolean
  SIGNAL carryreg73                       : std_logic; -- boolean
  SIGNAL temp1_72                         : std_logic; -- boolean
  SIGNAL temp2_72                         : std_logic; -- boolean
  SIGNAL temp3_72                         : std_logic; -- boolean
  SIGNAL preaddbit74                      : std_logic; -- boolean
  SIGNAL addcarry74                       : std_logic; -- boolean
  SIGNAL carrymux74                       : std_logic; -- boolean
  SIGNAL carryreg74                       : std_logic; -- boolean
  SIGNAL temp1_73                         : std_logic; -- boolean
  SIGNAL temp2_73                         : std_logic; -- boolean
  SIGNAL temp3_73                         : std_logic; -- boolean
  SIGNAL preaddbit75                      : std_logic; -- boolean
  SIGNAL addcarry75                       : std_logic; -- boolean
  SIGNAL carrymux75                       : std_logic; -- boolean
  SIGNAL carryreg75                       : std_logic; -- boolean
  SIGNAL temp1_74                         : std_logic; -- boolean
  SIGNAL temp2_74                         : std_logic; -- boolean
  SIGNAL temp3_74                         : std_logic; -- boolean
  SIGNAL preaddbit76                      : std_logic; -- boolean
  SIGNAL addcarry76                       : std_logic; -- boolean
  SIGNAL carrymux76                       : std_logic; -- boolean
  SIGNAL carryreg76                       : std_logic; -- boolean
  SIGNAL temp1_75                         : std_logic; -- boolean
  SIGNAL temp2_75                         : std_logic; -- boolean
  SIGNAL temp3_75                         : std_logic; -- boolean
  SIGNAL preaddbit77                      : std_logic; -- boolean
  SIGNAL addcarry77                       : std_logic; -- boolean
  SIGNAL carrymux77                       : std_logic; -- boolean
  SIGNAL carryreg77                       : std_logic; -- boolean
  SIGNAL temp1_76                         : std_logic; -- boolean
  SIGNAL temp2_76                         : std_logic; -- boolean
  SIGNAL temp3_76                         : std_logic; -- boolean
  SIGNAL preaddbit78                      : std_logic; -- boolean
  SIGNAL addcarry78                       : std_logic; -- boolean
  SIGNAL carrymux78                       : std_logic; -- boolean
  SIGNAL carryreg78                       : std_logic; -- boolean
  SIGNAL temp1_77                         : std_logic; -- boolean
  SIGNAL temp2_77                         : std_logic; -- boolean
  SIGNAL temp3_77                         : std_logic; -- boolean
  SIGNAL preaddbit79                      : std_logic; -- boolean
  SIGNAL addcarry79                       : std_logic; -- boolean
  SIGNAL carrymux79                       : std_logic; -- boolean
  SIGNAL carryreg79                       : std_logic; -- boolean
  SIGNAL temp1_78                         : std_logic; -- boolean
  SIGNAL temp2_78                         : std_logic; -- boolean
  SIGNAL temp3_78                         : std_logic; -- boolean
  SIGNAL preaddbit80                      : std_logic; -- boolean
  SIGNAL addcarry80                       : std_logic; -- boolean
  SIGNAL carrymux80                       : std_logic; -- boolean
  SIGNAL carryreg80                       : std_logic; -- boolean
  SIGNAL temp1_79                         : std_logic; -- boolean
  SIGNAL temp2_79                         : std_logic; -- boolean
  SIGNAL temp3_79                         : std_logic; -- boolean
  SIGNAL preaddbit81                      : std_logic; -- boolean
  SIGNAL addcarry81                       : std_logic; -- boolean
  SIGNAL carrymux81                       : std_logic; -- boolean
  SIGNAL carryreg81                       : std_logic; -- boolean
  SIGNAL temp1_80                         : std_logic; -- boolean
  SIGNAL temp2_80                         : std_logic; -- boolean
  SIGNAL temp3_80                         : std_logic; -- boolean
  SIGNAL preaddbit82                      : std_logic; -- boolean
  SIGNAL addcarry82                       : std_logic; -- boolean
  SIGNAL carrymux82                       : std_logic; -- boolean
  SIGNAL carryreg82                       : std_logic; -- boolean
  SIGNAL temp1_81                         : std_logic; -- boolean
  SIGNAL temp2_81                         : std_logic; -- boolean
  SIGNAL temp3_81                         : std_logic; -- boolean
  SIGNAL preaddbit83                      : std_logic; -- boolean
  SIGNAL addcarry83                       : std_logic; -- boolean
  SIGNAL carrymux83                       : std_logic; -- boolean
  SIGNAL carryreg83                       : std_logic; -- boolean
  SIGNAL temp1_82                         : std_logic; -- boolean
  SIGNAL temp2_82                         : std_logic; -- boolean
  SIGNAL temp3_82                         : std_logic; -- boolean
  SIGNAL preaddbit84                      : std_logic; -- boolean
  SIGNAL addcarry84                       : std_logic; -- boolean
  SIGNAL carrymux84                       : std_logic; -- boolean
  SIGNAL carryreg84                       : std_logic; -- boolean
  SIGNAL temp1_83                         : std_logic; -- boolean
  SIGNAL temp2_83                         : std_logic; -- boolean
  SIGNAL temp3_83                         : std_logic; -- boolean
  SIGNAL preaddbit85                      : std_logic; -- boolean
  SIGNAL addcarry85                       : std_logic; -- boolean
  SIGNAL carrymux85                       : std_logic; -- boolean
  SIGNAL carryreg85                       : std_logic; -- boolean
  SIGNAL temp1_84                         : std_logic; -- boolean
  SIGNAL temp2_84                         : std_logic; -- boolean
  SIGNAL temp3_84                         : std_logic; -- boolean
  SIGNAL preaddbit86                      : std_logic; -- boolean
  SIGNAL addcarry86                       : std_logic; -- boolean
  SIGNAL carrymux86                       : std_logic; -- boolean
  SIGNAL carryreg86                       : std_logic; -- boolean
  SIGNAL temp1_85                         : std_logic; -- boolean
  SIGNAL temp2_85                         : std_logic; -- boolean
  SIGNAL temp3_85                         : std_logic; -- boolean
  SIGNAL preaddbit87                      : std_logic; -- boolean
  SIGNAL addcarry87                       : std_logic; -- boolean
  SIGNAL carrymux87                       : std_logic; -- boolean
  SIGNAL carryreg87                       : std_logic; -- boolean
  SIGNAL temp1_86                         : std_logic; -- boolean
  SIGNAL temp2_86                         : std_logic; -- boolean
  SIGNAL temp3_86                         : std_logic; -- boolean
  SIGNAL preaddbit88                      : std_logic; -- boolean
  SIGNAL addcarry88                       : std_logic; -- boolean
  SIGNAL carrymux88                       : std_logic; -- boolean
  SIGNAL carryreg88                       : std_logic; -- boolean
  SIGNAL temp1_87                         : std_logic; -- boolean
  SIGNAL temp2_87                         : std_logic; -- boolean
  SIGNAL temp3_87                         : std_logic; -- boolean
  SIGNAL preaddbit89                      : std_logic; -- boolean
  SIGNAL addcarry89                       : std_logic; -- boolean
  SIGNAL carrymux89                       : std_logic; -- boolean
  SIGNAL carryreg89                       : std_logic; -- boolean
  SIGNAL temp1_88                         : std_logic; -- boolean
  SIGNAL temp2_88                         : std_logic; -- boolean
  SIGNAL temp3_88                         : std_logic; -- boolean
  SIGNAL preaddbit90                      : std_logic; -- boolean
  SIGNAL addcarry90                       : std_logic; -- boolean
  SIGNAL carrymux90                       : std_logic; -- boolean
  SIGNAL carryreg90                       : std_logic; -- boolean
  SIGNAL temp1_89                         : std_logic; -- boolean
  SIGNAL temp2_89                         : std_logic; -- boolean
  SIGNAL temp3_89                         : std_logic; -- boolean
  SIGNAL preaddbit91                      : std_logic; -- boolean
  SIGNAL addcarry91                       : std_logic; -- boolean
  SIGNAL carrymux91                       : std_logic; -- boolean
  SIGNAL carryreg91                       : std_logic; -- boolean
  SIGNAL temp1_90                         : std_logic; -- boolean
  SIGNAL temp2_90                         : std_logic; -- boolean
  SIGNAL temp3_90                         : std_logic; -- boolean
  SIGNAL preaddbit92                      : std_logic; -- boolean
  SIGNAL addcarry92                       : std_logic; -- boolean
  SIGNAL carrymux92                       : std_logic; -- boolean
  SIGNAL carryreg92                       : std_logic; -- boolean
  SIGNAL temp1_91                         : std_logic; -- boolean
  SIGNAL temp2_91                         : std_logic; -- boolean
  SIGNAL temp3_91                         : std_logic; -- boolean
  SIGNAL preaddbit93                      : std_logic; -- boolean
  SIGNAL addcarry93                       : std_logic; -- boolean
  SIGNAL carrymux93                       : std_logic; -- boolean
  SIGNAL carryreg93                       : std_logic; -- boolean
  SIGNAL temp1_92                         : std_logic; -- boolean
  SIGNAL temp2_92                         : std_logic; -- boolean
  SIGNAL temp3_92                         : std_logic; -- boolean
  SIGNAL preaddbit94                      : std_logic; -- boolean
  SIGNAL addcarry94                       : std_logic; -- boolean
  SIGNAL carrymux94                       : std_logic; -- boolean
  SIGNAL carryreg94                       : std_logic; -- boolean
  SIGNAL temp1_93                         : std_logic; -- boolean
  SIGNAL temp2_93                         : std_logic; -- boolean
  SIGNAL temp3_93                         : std_logic; -- boolean
  SIGNAL preaddbit95                      : std_logic; -- boolean
  SIGNAL addcarry95                       : std_logic; -- boolean
  SIGNAL carrymux95                       : std_logic; -- boolean
  SIGNAL carryreg95                       : std_logic; -- boolean
  SIGNAL temp1_94                         : std_logic; -- boolean
  SIGNAL temp2_94                         : std_logic; -- boolean
  SIGNAL temp3_94                         : std_logic; -- boolean
  SIGNAL preaddbit96                      : std_logic; -- boolean
  SIGNAL addcarry96                       : std_logic; -- boolean
  SIGNAL carrymux96                       : std_logic; -- boolean
  SIGNAL carryreg96                       : std_logic; -- boolean
  SIGNAL temp1_95                         : std_logic; -- boolean
  SIGNAL temp2_95                         : std_logic; -- boolean
  SIGNAL temp3_95                         : std_logic; -- boolean
  SIGNAL preaddbit97                      : std_logic; -- boolean
  SIGNAL addcarry97                       : std_logic; -- boolean
  SIGNAL carrymux97                       : std_logic; -- boolean
  SIGNAL carryreg97                       : std_logic; -- boolean
  SIGNAL temp1_96                         : std_logic; -- boolean
  SIGNAL temp2_96                         : std_logic; -- boolean
  SIGNAL temp3_96                         : std_logic; -- boolean
  SIGNAL preaddbit98                      : std_logic; -- boolean
  SIGNAL addcarry98                       : std_logic; -- boolean
  SIGNAL carrymux98                       : std_logic; -- boolean
  SIGNAL carryreg98                       : std_logic; -- boolean
  SIGNAL temp1_97                         : std_logic; -- boolean
  SIGNAL temp2_97                         : std_logic; -- boolean
  SIGNAL temp3_97                         : std_logic; -- boolean
  SIGNAL preaddbit99                      : std_logic; -- boolean
  SIGNAL addcarry99                       : std_logic; -- boolean
  SIGNAL carrymux99                       : std_logic; -- boolean
  SIGNAL carryreg99                       : std_logic; -- boolean
  SIGNAL temp1_98                         : std_logic; -- boolean
  SIGNAL temp2_98                         : std_logic; -- boolean
  SIGNAL temp3_98                         : std_logic; -- boolean
  SIGNAL preaddbit100                     : std_logic; -- boolean
  SIGNAL addcarry100                      : std_logic; -- boolean
  SIGNAL carrymux100                      : std_logic; -- boolean
  SIGNAL carryreg100                      : std_logic; -- boolean
  SIGNAL temp1_99                         : std_logic; -- boolean
  SIGNAL temp2_99                         : std_logic; -- boolean
  SIGNAL temp3_99                         : std_logic; -- boolean
  SIGNAL preaddbit101                     : std_logic; -- boolean
  SIGNAL addcarry101                      : std_logic; -- boolean
  SIGNAL carrymux101                      : std_logic; -- boolean
  SIGNAL carryreg101                      : std_logic; -- boolean
  SIGNAL temp1_100                        : std_logic; -- boolean
  SIGNAL temp2_100                        : std_logic; -- boolean
  SIGNAL temp3_100                        : std_logic; -- boolean
  SIGNAL preaddbit102                     : std_logic; -- boolean
  SIGNAL addcarry102                      : std_logic; -- boolean
  SIGNAL carrymux102                      : std_logic; -- boolean
  SIGNAL carryreg102                      : std_logic; -- boolean
  SIGNAL temp1_101                        : std_logic; -- boolean
  SIGNAL temp2_101                        : std_logic; -- boolean
  SIGNAL temp3_101                        : std_logic; -- boolean
  SIGNAL preaddbit103                     : std_logic; -- boolean
  SIGNAL addcarry103                      : std_logic; -- boolean
  SIGNAL carrymux103                      : std_logic; -- boolean
  SIGNAL carryreg103                      : std_logic; -- boolean
  SIGNAL temp1_102                        : std_logic; -- boolean
  SIGNAL temp2_102                        : std_logic; -- boolean
  SIGNAL temp3_102                        : std_logic; -- boolean
  SIGNAL preaddbit104                     : std_logic; -- boolean
  SIGNAL addcarry104                      : std_logic; -- boolean
  SIGNAL carrymux104                      : std_logic; -- boolean
  SIGNAL carryreg104                      : std_logic; -- boolean
  SIGNAL temp1_103                        : std_logic; -- boolean
  SIGNAL temp2_103                        : std_logic; -- boolean
  SIGNAL temp3_103                        : std_logic; -- boolean
  SIGNAL preaddbit105                     : std_logic; -- boolean
  SIGNAL addcarry105                      : std_logic; -- boolean
  SIGNAL carrymux105                      : std_logic; -- boolean
  SIGNAL carryreg105                      : std_logic; -- boolean
  SIGNAL temp1_104                        : std_logic; -- boolean
  SIGNAL temp2_104                        : std_logic; -- boolean
  SIGNAL temp3_104                        : std_logic; -- boolean
  SIGNAL preaddbit106                     : std_logic; -- boolean
  SIGNAL addcarry106                      : std_logic; -- boolean
  SIGNAL carrymux106                      : std_logic; -- boolean
  SIGNAL carryreg106                      : std_logic; -- boolean
  SIGNAL temp1_105                        : std_logic; -- boolean
  SIGNAL temp2_105                        : std_logic; -- boolean
  SIGNAL temp3_105                        : std_logic; -- boolean
  SIGNAL preaddbit107                     : std_logic; -- boolean
  SIGNAL addcarry107                      : std_logic; -- boolean
  SIGNAL carrymux107                      : std_logic; -- boolean
  SIGNAL carryreg107                      : std_logic; -- boolean
  SIGNAL temp1_106                        : std_logic; -- boolean
  SIGNAL temp2_106                        : std_logic; -- boolean
  SIGNAL temp3_106                        : std_logic; -- boolean
  SIGNAL preaddbit108                     : std_logic; -- boolean
  SIGNAL addcarry108                      : std_logic; -- boolean
  SIGNAL carrymux108                      : std_logic; -- boolean
  SIGNAL carryreg108                      : std_logic; -- boolean
  SIGNAL temp1_107                        : std_logic; -- boolean
  SIGNAL temp2_107                        : std_logic; -- boolean
  SIGNAL temp3_107                        : std_logic; -- boolean
  SIGNAL preaddbit109                     : std_logic; -- boolean
  SIGNAL addcarry109                      : std_logic; -- boolean
  SIGNAL carrymux109                      : std_logic; -- boolean
  SIGNAL carryreg109                      : std_logic; -- boolean
  SIGNAL temp1_108                        : std_logic; -- boolean
  SIGNAL temp2_108                        : std_logic; -- boolean
  SIGNAL temp3_108                        : std_logic; -- boolean
  SIGNAL preaddbit110                     : std_logic; -- boolean
  SIGNAL addcarry110                      : std_logic; -- boolean
  SIGNAL carrymux110                      : std_logic; -- boolean
  SIGNAL carryreg110                      : std_logic; -- boolean
  SIGNAL temp1_109                        : std_logic; -- boolean
  SIGNAL temp2_109                        : std_logic; -- boolean
  SIGNAL temp3_109                        : std_logic; -- boolean
  SIGNAL preaddbit111                     : std_logic; -- boolean
  SIGNAL addcarry111                      : std_logic; -- boolean
  SIGNAL carrymux111                      : std_logic; -- boolean
  SIGNAL carryreg111                      : std_logic; -- boolean
  SIGNAL temp1_110                        : std_logic; -- boolean
  SIGNAL temp2_110                        : std_logic; -- boolean
  SIGNAL temp3_110                        : std_logic; -- boolean
  SIGNAL preaddbit112                     : std_logic; -- boolean
  SIGNAL addcarry112                      : std_logic; -- boolean
  SIGNAL carrymux112                      : std_logic; -- boolean
  SIGNAL carryreg112                      : std_logic; -- boolean
  SIGNAL temp1_111                        : std_logic; -- boolean
  SIGNAL temp2_111                        : std_logic; -- boolean
  SIGNAL temp3_111                        : std_logic; -- boolean
  SIGNAL preaddbit113                     : std_logic; -- boolean
  SIGNAL addcarry113                      : std_logic; -- boolean
  SIGNAL carrymux113                      : std_logic; -- boolean
  SIGNAL carryreg113                      : std_logic; -- boolean
  SIGNAL temp1_112                        : std_logic; -- boolean
  SIGNAL temp2_112                        : std_logic; -- boolean
  SIGNAL temp3_112                        : std_logic; -- boolean
  SIGNAL preaddbit114                     : std_logic; -- boolean
  SIGNAL addcarry114                      : std_logic; -- boolean
  SIGNAL carrymux114                      : std_logic; -- boolean
  SIGNAL carryreg114                      : std_logic; -- boolean
  SIGNAL temp1_113                        : std_logic; -- boolean
  SIGNAL temp2_113                        : std_logic; -- boolean
  SIGNAL temp3_113                        : std_logic; -- boolean
  SIGNAL preaddbit115                     : std_logic; -- boolean
  SIGNAL addcarry115                      : std_logic; -- boolean
  SIGNAL carrymux115                      : std_logic; -- boolean
  SIGNAL carryreg115                      : std_logic; -- boolean
  SIGNAL temp1_114                        : std_logic; -- boolean
  SIGNAL temp2_114                        : std_logic; -- boolean
  SIGNAL temp3_114                        : std_logic; -- boolean
  SIGNAL preaddbit116                     : std_logic; -- boolean
  SIGNAL addcarry116                      : std_logic; -- boolean
  SIGNAL carrymux116                      : std_logic; -- boolean
  SIGNAL carryreg116                      : std_logic; -- boolean
  SIGNAL temp1_115                        : std_logic; -- boolean
  SIGNAL temp2_115                        : std_logic; -- boolean
  SIGNAL temp3_115                        : std_logic; -- boolean
  SIGNAL preaddbit117                     : std_logic; -- boolean
  SIGNAL addcarry117                      : std_logic; -- boolean
  SIGNAL carrymux117                      : std_logic; -- boolean
  SIGNAL carryreg117                      : std_logic; -- boolean
  SIGNAL temp1_116                        : std_logic; -- boolean
  SIGNAL temp2_116                        : std_logic; -- boolean
  SIGNAL temp3_116                        : std_logic; -- boolean
  SIGNAL preaddbit118                     : std_logic; -- boolean
  SIGNAL addcarry118                      : std_logic; -- boolean
  SIGNAL carrymux118                      : std_logic; -- boolean
  SIGNAL carryreg118                      : std_logic; -- boolean
  SIGNAL temp1_117                        : std_logic; -- boolean
  SIGNAL temp2_117                        : std_logic; -- boolean
  SIGNAL temp3_117                        : std_logic; -- boolean
  SIGNAL preaddbit119                     : std_logic; -- boolean
  SIGNAL addcarry119                      : std_logic; -- boolean
  SIGNAL carrymux119                      : std_logic; -- boolean
  SIGNAL carryreg119                      : std_logic; -- boolean
  SIGNAL temp1_118                        : std_logic; -- boolean
  SIGNAL temp2_118                        : std_logic; -- boolean
  SIGNAL temp3_118                        : std_logic; -- boolean
  SIGNAL preaddbit120                     : std_logic; -- boolean
  SIGNAL addcarry120                      : std_logic; -- boolean
  SIGNAL carrymux120                      : std_logic; -- boolean
  SIGNAL carryreg120                      : std_logic; -- boolean
  SIGNAL temp1_119                        : std_logic; -- boolean
  SIGNAL temp2_119                        : std_logic; -- boolean
  SIGNAL temp3_119                        : std_logic; -- boolean
  SIGNAL preaddbit121                     : std_logic; -- boolean
  SIGNAL addcarry121                      : std_logic; -- boolean
  SIGNAL carrymux121                      : std_logic; -- boolean
  SIGNAL carryreg121                      : std_logic; -- boolean
  SIGNAL temp1_120                        : std_logic; -- boolean
  SIGNAL temp2_120                        : std_logic; -- boolean
  SIGNAL temp3_120                        : std_logic; -- boolean
  SIGNAL preaddbit122                     : std_logic; -- boolean
  SIGNAL addcarry122                      : std_logic; -- boolean
  SIGNAL carrymux122                      : std_logic; -- boolean
  SIGNAL carryreg122                      : std_logic; -- boolean
  SIGNAL temp1_121                        : std_logic; -- boolean
  SIGNAL temp2_121                        : std_logic; -- boolean
  SIGNAL temp3_121                        : std_logic; -- boolean
  SIGNAL preaddbit123                     : std_logic; -- boolean
  SIGNAL addcarry123                      : std_logic; -- boolean
  SIGNAL carrymux123                      : std_logic; -- boolean
  SIGNAL carryreg123                      : std_logic; -- boolean
  SIGNAL temp1_122                        : std_logic; -- boolean
  SIGNAL temp2_122                        : std_logic; -- boolean
  SIGNAL temp3_122                        : std_logic; -- boolean
  SIGNAL preaddbit124                     : std_logic; -- boolean
  SIGNAL addcarry124                      : std_logic; -- boolean
  SIGNAL carrymux124                      : std_logic; -- boolean
  SIGNAL carryreg124                      : std_logic; -- boolean
  SIGNAL temp1_123                        : std_logic; -- boolean
  SIGNAL temp2_123                        : std_logic; -- boolean
  SIGNAL temp3_123                        : std_logic; -- boolean
  SIGNAL preaddbit125                     : std_logic; -- boolean
  SIGNAL addcarry125                      : std_logic; -- boolean
  SIGNAL carrymux125                      : std_logic; -- boolean
  SIGNAL carryreg125                      : std_logic; -- boolean
  SIGNAL temp1_124                        : std_logic; -- boolean
  SIGNAL temp2_124                        : std_logic; -- boolean
  SIGNAL temp3_124                        : std_logic; -- boolean
  SIGNAL preaddbit126                     : std_logic; -- boolean
  SIGNAL addcarry126                      : std_logic; -- boolean
  SIGNAL carrymux126                      : std_logic; -- boolean
  SIGNAL carryreg126                      : std_logic; -- boolean
  SIGNAL temp1_125                        : std_logic; -- boolean
  SIGNAL temp2_125                        : std_logic; -- boolean
  SIGNAL temp3_125                        : std_logic; -- boolean
  SIGNAL preaddbit127                     : std_logic; -- boolean
  SIGNAL addcarry127                      : std_logic; -- boolean
  SIGNAL carrymux127                      : std_logic; -- boolean
  SIGNAL carryreg127                      : std_logic; -- boolean
  SIGNAL temp1_126                        : std_logic; -- boolean
  SIGNAL temp2_126                        : std_logic; -- boolean
  SIGNAL temp3_126                        : std_logic; -- boolean
  SIGNAL preaddbit128                     : std_logic; -- boolean
  SIGNAL addcarry128                      : std_logic; -- boolean
  SIGNAL carrymux128                      : std_logic; -- boolean
  SIGNAL carryreg128                      : std_logic; -- boolean
  SIGNAL temp1_127                        : std_logic; -- boolean
  SIGNAL temp2_127                        : std_logic; -- boolean
  SIGNAL temp3_127                        : std_logic; -- boolean
  SIGNAL mem_addr_1                       : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_1                       : signed(12 DOWNTO 0); -- sfix13_En19
  SIGNAL mem_addr_2                       : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_2                       : signed(12 DOWNTO 0); -- sfix13_En19
  SIGNAL mem_addr_3                       : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_3                       : signed(13 DOWNTO 0); -- sfix14_En19
  SIGNAL mem_addr_4                       : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_4                       : signed(13 DOWNTO 0); -- sfix14_En19
  SIGNAL mem_addr_5                       : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_5                       : signed(12 DOWNTO 0); -- sfix13_En19
  SIGNAL mem_addr_6                       : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_6                       : signed(12 DOWNTO 0); -- sfix13_En19
  SIGNAL mem_addr_7                       : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_7                       : signed(12 DOWNTO 0); -- sfix13_En19
  SIGNAL mem_addr_8                       : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_8                       : signed(11 DOWNTO 0); -- sfix12_En19
  SIGNAL mem_addr_9                       : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_9                       : signed(10 DOWNTO 0); -- sfix11_En19
  SIGNAL mem_addr_10                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_10                      : signed(9 DOWNTO 0); -- sfix10_En19
  SIGNAL mem_addr_11                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_11                      : signed(8 DOWNTO 0); -- sfix9_En19
  SIGNAL mem_addr_12                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_12                      : signed(9 DOWNTO 0); -- sfix10_En19
  SIGNAL mem_addr_13                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_13                      : signed(10 DOWNTO 0); -- sfix11_En19
  SIGNAL mem_addr_14                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_14                      : signed(11 DOWNTO 0); -- sfix12_En19
  SIGNAL mem_addr_15                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_15                      : signed(12 DOWNTO 0); -- sfix13_En19
  SIGNAL mem_addr_16                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_16                      : signed(13 DOWNTO 0); -- sfix14_En19
  SIGNAL mem_addr_17                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_17                      : signed(13 DOWNTO 0); -- sfix14_En19
  SIGNAL mem_addr_18                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_18                      : signed(13 DOWNTO 0); -- sfix14_En19
  SIGNAL mem_addr_19                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_19                      : signed(13 DOWNTO 0); -- sfix14_En19
  SIGNAL mem_addr_20                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_20                      : signed(13 DOWNTO 0); -- sfix14_En19
  SIGNAL mem_addr_21                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_21                      : signed(13 DOWNTO 0); -- sfix14_En19
  SIGNAL mem_addr_22                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_22                      : signed(13 DOWNTO 0); -- sfix14_En19
  SIGNAL mem_addr_23                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_23                      : signed(13 DOWNTO 0); -- sfix14_En19
  SIGNAL mem_addr_24                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_24                      : signed(12 DOWNTO 0); -- sfix13_En19
  SIGNAL mem_addr_25                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_25                      : signed(11 DOWNTO 0); -- sfix12_En19
  SIGNAL mem_addr_26                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_26                      : signed(10 DOWNTO 0); -- sfix11_En19
  SIGNAL mem_addr_27                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_27                      : signed(9 DOWNTO 0); -- sfix10_En19
  SIGNAL mem_addr_28                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_28                      : signed(8 DOWNTO 0); -- sfix9_En19
  SIGNAL mem_addr_29                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_29                      : signed(10 DOWNTO 0); -- sfix11_En19
  SIGNAL mem_addr_30                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_30                      : signed(11 DOWNTO 0); -- sfix12_En19
  SIGNAL mem_addr_31                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_31                      : signed(12 DOWNTO 0); -- sfix13_En19
  SIGNAL mem_addr_32                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_32                      : signed(13 DOWNTO 0); -- sfix14_En19
  SIGNAL mem_addr_33                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_33                      : signed(13 DOWNTO 0); -- sfix14_En19
  SIGNAL mem_addr_34                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_34                      : signed(14 DOWNTO 0); -- sfix15_En19
  SIGNAL mem_addr_35                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_35                      : signed(14 DOWNTO 0); -- sfix15_En19
  SIGNAL mem_addr_36                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_36                      : signed(14 DOWNTO 0); -- sfix15_En19
  SIGNAL mem_addr_37                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_37                      : signed(14 DOWNTO 0); -- sfix15_En19
  SIGNAL mem_addr_38                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_38                      : signed(14 DOWNTO 0); -- sfix15_En19
  SIGNAL mem_addr_39                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_39                      : signed(13 DOWNTO 0); -- sfix14_En19
  SIGNAL mem_addr_40                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_40                      : signed(13 DOWNTO 0); -- sfix14_En19
  SIGNAL mem_addr_41                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_41                      : signed(12 DOWNTO 0); -- sfix13_En19
  SIGNAL mem_addr_42                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_42                      : signed(9 DOWNTO 0); -- sfix10_En19
  SIGNAL mem_addr_43                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_43                      : signed(11 DOWNTO 0); -- sfix12_En19
  SIGNAL mem_addr_44                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_44                      : signed(12 DOWNTO 0); -- sfix13_En19
  SIGNAL mem_addr_45                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_45                      : signed(12 DOWNTO 0); -- sfix13_En19
  SIGNAL mem_addr_46                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_46                      : signed(10 DOWNTO 0); -- sfix11_En19
  SIGNAL mem_addr_47                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_47                      : signed(11 DOWNTO 0); -- sfix12_En19
  SIGNAL mem_addr_48                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_48                      : signed(13 DOWNTO 0); -- sfix14_En19
  SIGNAL mem_addr_49                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_49                      : signed(14 DOWNTO 0); -- sfix15_En19
  SIGNAL mem_addr_50                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_50                      : signed(14 DOWNTO 0); -- sfix15_En19
  SIGNAL mem_addr_51                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_51                      : signed(14 DOWNTO 0); -- sfix15_En19
  SIGNAL mem_addr_52                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_52                      : signed(15 DOWNTO 0); -- sfix16_En19
  SIGNAL mem_addr_53                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_53                      : signed(15 DOWNTO 0); -- sfix16_En19
  SIGNAL mem_addr_54                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_54                      : signed(15 DOWNTO 0); -- sfix16_En19
  SIGNAL mem_addr_55                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_55                      : signed(14 DOWNTO 0); -- sfix15_En19
  SIGNAL mem_addr_56                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_56                      : signed(14 DOWNTO 0); -- sfix15_En19
  SIGNAL mem_addr_57                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_57                      : signed(11 DOWNTO 0); -- sfix12_En19
  SIGNAL mem_addr_58                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_58                      : signed(13 DOWNTO 0); -- sfix14_En19
  SIGNAL mem_addr_59                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_59                      : signed(15 DOWNTO 0); -- sfix16_En19
  SIGNAL mem_addr_60                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_60                      : signed(15 DOWNTO 0); -- sfix16_En19
  SIGNAL mem_addr_61                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_61                      : signed(16 DOWNTO 0); -- sfix17_En19
  SIGNAL mem_addr_62                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_62                      : signed(16 DOWNTO 0); -- sfix17_En19
  SIGNAL mem_addr_63                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_63                      : signed(16 DOWNTO 0); -- sfix17_En19
  SIGNAL mem_addr_64                      : unsigned(1 DOWNTO 0); -- ufix2
  SIGNAL memoutb1_64                      : signed(16 DOWNTO 0); -- sfix17_En19
  SIGNAL mem_addr_65                      : std_logic; -- boolean
  SIGNAL memoutb1_65                      : signed(15 DOWNTO 0); -- sfix16_En19
  SIGNAL memoutb1                         : signed(19 DOWNTO 0); -- sfix20_En19
  SIGNAL sum1_1                           : signed(13 DOWNTO 0); -- sfix14_En19
  SIGNAL sum1_2                           : signed(14 DOWNTO 0); -- sfix15_En19
  SIGNAL sum1_3                           : signed(13 DOWNTO 0); -- sfix14_En19
  SIGNAL sum1_4                           : signed(13 DOWNTO 0); -- sfix14_En19
  SIGNAL sum1_5                           : signed(11 DOWNTO 0); -- sfix12_En19
  SIGNAL sum1_6                           : signed(10 DOWNTO 0); -- sfix11_En19
  SIGNAL sum1_7                           : signed(12 DOWNTO 0); -- sfix13_En19
  SIGNAL sum1_8                           : signed(14 DOWNTO 0); -- sfix15_En19
  SIGNAL sum1_9                           : signed(14 DOWNTO 0); -- sfix15_En19
  SIGNAL sum1_10                          : signed(14 DOWNTO 0); -- sfix15_En19
  SIGNAL sum1_11                          : signed(14 DOWNTO 0); -- sfix15_En19
  SIGNAL sum1_12                          : signed(14 DOWNTO 0); -- sfix15_En19
  SIGNAL sum1_13                          : signed(12 DOWNTO 0); -- sfix13_En19
  SIGNAL sum1_14                          : signed(10 DOWNTO 0); -- sfix11_En19
  SIGNAL sum1_15                          : signed(12 DOWNTO 0); -- sfix13_En19
  SIGNAL sum1_16                          : signed(14 DOWNTO 0); -- sfix15_En19
  SIGNAL sum1_17                          : signed(15 DOWNTO 0); -- sfix16_En19
  SIGNAL sum1_18                          : signed(15 DOWNTO 0); -- sfix16_En19
  SIGNAL sum1_19                          : signed(15 DOWNTO 0); -- sfix16_En19
  SIGNAL sum1_20                          : signed(14 DOWNTO 0); -- sfix15_En19
  SIGNAL sum1_21                          : signed(13 DOWNTO 0); -- sfix14_En19
  SIGNAL sum1_22                          : signed(13 DOWNTO 0); -- sfix14_En19
  SIGNAL sum1_23                          : signed(13 DOWNTO 0); -- sfix14_En19
  SIGNAL sum1_24                          : signed(14 DOWNTO 0); -- sfix15_En19
  SIGNAL sum1_25                          : signed(15 DOWNTO 0); -- sfix16_En19
  SIGNAL sum1_26                          : signed(16 DOWNTO 0); -- sfix17_En19
  SIGNAL sum1_27                          : signed(16 DOWNTO 0); -- sfix17_En19
  SIGNAL sum1_28                          : signed(15 DOWNTO 0); -- sfix16_En19
  SIGNAL sum1_29                          : signed(14 DOWNTO 0); -- sfix15_En19
  SIGNAL sum1_30                          : signed(16 DOWNTO 0); -- sfix17_En19
  SIGNAL sum1_31                          : signed(17 DOWNTO 0); -- sfix18_En19
  SIGNAL sum1_32                          : signed(17 DOWNTO 0); -- sfix18_En19
  SIGNAL sum2_1                           : signed(15 DOWNTO 0); -- sfix16_En19
  SIGNAL sum2_2                           : signed(14 DOWNTO 0); -- sfix15_En19
  SIGNAL sum2_3                           : signed(12 DOWNTO 0); -- sfix13_En19
  SIGNAL sum2_4                           : signed(15 DOWNTO 0); -- sfix16_En19
  SIGNAL sum2_5                           : signed(15 DOWNTO 0); -- sfix16_En19
  SIGNAL sum2_6                           : signed(15 DOWNTO 0); -- sfix16_En19
  SIGNAL sum2_7                           : signed(13 DOWNTO 0); -- sfix14_En19
  SIGNAL sum2_8                           : signed(15 DOWNTO 0); -- sfix16_En19
  SIGNAL sum2_9                           : signed(16 DOWNTO 0); -- sfix17_En19
  SIGNAL sum2_10                          : signed(16 DOWNTO 0); -- sfix17_En19
  SIGNAL sum2_11                          : signed(14 DOWNTO 0); -- sfix15_En19
  SIGNAL sum2_12                          : signed(15 DOWNTO 0); -- sfix16_En19
  SIGNAL sum2_13                          : signed(17 DOWNTO 0); -- sfix18_En19
  SIGNAL sum2_14                          : signed(17 DOWNTO 0); -- sfix18_En19
  SIGNAL sum2_15                          : signed(17 DOWNTO 0); -- sfix18_En19
  SIGNAL sum2_16                          : signed(18 DOWNTO 0); -- sfix19_En19
  SIGNAL sum3_1                           : signed(16 DOWNTO 0); -- sfix17_En19
  SIGNAL sum3_2                           : signed(16 DOWNTO 0); -- sfix17_En19
  SIGNAL sum3_3                           : signed(16 DOWNTO 0); -- sfix17_En19
  SIGNAL sum3_4                           : signed(16 DOWNTO 0); -- sfix17_En19
  SIGNAL sum3_5                           : signed(17 DOWNTO 0); -- sfix18_En19
  SIGNAL sum3_6                           : signed(16 DOWNTO 0); -- sfix17_En19
  SIGNAL sum3_7                           : signed(18 DOWNTO 0); -- sfix19_En19
  SIGNAL sum3_8                           : signed(19 DOWNTO 0); -- sfix20_En19
  SIGNAL sum4_1                           : signed(17 DOWNTO 0); -- sfix18_En19
  SIGNAL sum4_2                           : signed(17 DOWNTO 0); -- sfix18_En19
  SIGNAL sum4_3                           : signed(18 DOWNTO 0); -- sfix19_En19
  SIGNAL sum4_4                           : signed(20 DOWNTO 0); -- sfix21_En19
  SIGNAL sum5_1                           : signed(18 DOWNTO 0); -- sfix19_En19
  SIGNAL sum5_2                           : signed(21 DOWNTO 0); -- sfix22_En19
  SIGNAL sum6_1                           : signed(22 DOWNTO 0); -- sfix23_En19
  SIGNAL sum7_1                           : signed(23 DOWNTO 0); -- sfix24_En19
  SIGNAL acc_out                          : signed(46 DOWNTO 0); -- sfix47_En43
  SIGNAL memoutb1_cast                    : signed(46 DOWNTO 0); -- sfix47_En43
  SIGNAL add_sub_out                      : signed(46 DOWNTO 0); -- sfix47_En43
  SIGNAL acc_out_shft                     : signed(46 DOWNTO 0); -- sfix47_En43
  SIGNAL acc_in                           : signed(46 DOWNTO 0); -- sfix47_En43
  SIGNAL addsub_add                       : signed(46 DOWNTO 0); -- sfix47_En43
  SIGNAL addsub_sub                       : signed(46 DOWNTO 0); -- sfix47_En43
  SIGNAL add_temp                         : signed(47 DOWNTO 0); -- sfix48_En43
  SIGNAL sub_temp                         : signed(47 DOWNTO 0); -- sfix48_En43
  SIGNAL final_acc_out                    : signed(46 DOWNTO 0); -- sfix47_En43
  SIGNAL output_da                        : signed(46 DOWNTO 0); -- sfix47_En42
  SIGNAL output_typeconvert               : signed(23 DOWNTO 0); -- sfix24_En23
  SIGNAL output_register                  : signed(23 DOWNTO 0); -- sfix24_En23


BEGIN

  -- Block Statements
  filter_in_cast <= signed(filter_in);

  Counter_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      cur_count <= to_unsigned(24, 5);
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        IF cur_count >= to_unsigned(24, 5) THEN
          cur_count <= to_unsigned(0, 5);
        ELSE
          cur_count <= cur_count + to_unsigned(1, 5);
        END IF;
      END IF;
    END IF; 
  END PROCESS Counter_process;

  phase_24 <= '1' WHEN cur_count = to_unsigned(24, 5) AND clk_enable = '1' ELSE '0';

  phase_0 <= '1' WHEN cur_count = to_unsigned(0, 5) AND clk_enable = '1' ELSE '0';

  phase_24_1 <= '1' WHEN  (((cur_count = to_unsigned(24, 5))  OR
                            (cur_count = to_unsigned(0, 5))  OR
                            (cur_count = to_unsigned(1, 5))  OR
                            (cur_count = to_unsigned(2, 5))  OR
                            (cur_count = to_unsigned(3, 5))  OR
                            (cur_count = to_unsigned(4, 5))  OR
                            (cur_count = to_unsigned(5, 5))  OR
                            (cur_count = to_unsigned(6, 5))  OR
                            (cur_count = to_unsigned(7, 5))  OR
                            (cur_count = to_unsigned(8, 5))  OR
                            (cur_count = to_unsigned(9, 5))  OR
                            (cur_count = to_unsigned(10, 5))  OR
                            (cur_count = to_unsigned(11, 5))  OR
                            (cur_count = to_unsigned(12, 5))  OR
                            (cur_count = to_unsigned(13, 5))  OR
                            (cur_count = to_unsigned(14, 5))  OR
                            (cur_count = to_unsigned(15, 5))  OR
                            (cur_count = to_unsigned(16, 5))  OR
                            (cur_count = to_unsigned(17, 5))  OR
                            (cur_count = to_unsigned(18, 5))  OR
                            (cur_count = to_unsigned(19, 5))  OR
                            (cur_count = to_unsigned(20, 5))  OR
                            (cur_count = to_unsigned(21, 5))  OR
                            (cur_count = to_unsigned(22, 5)))  AND clk_enable = '1') ELSE '0';

  Serializer_1_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      shiftreg <= to_signed(0, 24);
    ELSIF clk'event AND clk = '1' THEN
      IF phase_24_1 = '1' THEN
        IF phase_24 = '1' THEN
          shiftreg <= filter_in_cast;
        ELSE
          shiftreg <= '0' & shiftreg(23 DOWNTO 1);
        END IF;
      END IF;
    END IF; 
  END PROCESS Serializer_1_process;

  serialoutb1 <= shiftreg(0);
 
  Delay_Pipeline_1_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      delay_pipeline(0 TO 6143) <= (OTHERS => '0');
    ELSIF clk'event AND clk = '1' THEN
      IF phase_24_1 = '1' THEN
        delay_pipeline(0) <= serialoutb1;
        delay_pipeline(1 TO 6143) <= delay_pipeline(0 TO 6142);
      END IF;
    END IF; 
  END PROCESS Delay_Pipeline_1_process;

  delayline_b23 <= delay_pipeline(23);

  delayline_b47 <= delay_pipeline(47);

  delayline_b71 <= delay_pipeline(71);

  delayline_b95 <= delay_pipeline(95);

  delayline_b119 <= delay_pipeline(119);

  delayline_b143 <= delay_pipeline(143);

  delayline_b167 <= delay_pipeline(167);

  delayline_b191 <= delay_pipeline(191);

  delayline_b215 <= delay_pipeline(215);

  delayline_b239 <= delay_pipeline(239);

  delayline_b263 <= delay_pipeline(263);

  delayline_b287 <= delay_pipeline(287);

  delayline_b311 <= delay_pipeline(311);

  delayline_b335 <= delay_pipeline(335);

  delayline_b359 <= delay_pipeline(359);

  delayline_b383 <= delay_pipeline(383);

  delayline_b407 <= delay_pipeline(407);

  delayline_b431 <= delay_pipeline(431);

  delayline_b455 <= delay_pipeline(455);

  delayline_b479 <= delay_pipeline(479);

  delayline_b503 <= delay_pipeline(503);

  delayline_b527 <= delay_pipeline(527);

  delayline_b551 <= delay_pipeline(551);

  delayline_b575 <= delay_pipeline(575);

  delayline_b599 <= delay_pipeline(599);

  delayline_b623 <= delay_pipeline(623);

  delayline_b647 <= delay_pipeline(647);

  delayline_b671 <= delay_pipeline(671);

  delayline_b695 <= delay_pipeline(695);

  delayline_b719 <= delay_pipeline(719);

  delayline_b743 <= delay_pipeline(743);

  delayline_b767 <= delay_pipeline(767);

  delayline_b791 <= delay_pipeline(791);

  delayline_b815 <= delay_pipeline(815);

  delayline_b839 <= delay_pipeline(839);

  delayline_b863 <= delay_pipeline(863);

  delayline_b887 <= delay_pipeline(887);

  delayline_b911 <= delay_pipeline(911);

  delayline_b935 <= delay_pipeline(935);

  delayline_b959 <= delay_pipeline(959);

  delayline_b983 <= delay_pipeline(983);

  delayline_b1007 <= delay_pipeline(1007);

  delayline_b1031 <= delay_pipeline(1031);

  delayline_b1055 <= delay_pipeline(1055);

  delayline_b1079 <= delay_pipeline(1079);

  delayline_b1103 <= delay_pipeline(1103);

  delayline_b1127 <= delay_pipeline(1127);

  delayline_b1151 <= delay_pipeline(1151);

  delayline_b1175 <= delay_pipeline(1175);

  delayline_b1199 <= delay_pipeline(1199);

  delayline_b1223 <= delay_pipeline(1223);

  delayline_b1247 <= delay_pipeline(1247);

  delayline_b1271 <= delay_pipeline(1271);

  delayline_b1295 <= delay_pipeline(1295);

  delayline_b1319 <= delay_pipeline(1319);

  delayline_b1343 <= delay_pipeline(1343);

  delayline_b1367 <= delay_pipeline(1367);

  delayline_b1391 <= delay_pipeline(1391);

  delayline_b1415 <= delay_pipeline(1415);

  delayline_b1439 <= delay_pipeline(1439);

  delayline_b1463 <= delay_pipeline(1463);

  delayline_b1487 <= delay_pipeline(1487);

  delayline_b1511 <= delay_pipeline(1511);

  delayline_b1535 <= delay_pipeline(1535);

  delayline_b1559 <= delay_pipeline(1559);

  delayline_b1583 <= delay_pipeline(1583);

  delayline_b1607 <= delay_pipeline(1607);

  delayline_b1631 <= delay_pipeline(1631);

  delayline_b1655 <= delay_pipeline(1655);

  delayline_b1679 <= delay_pipeline(1679);

  delayline_b1703 <= delay_pipeline(1703);

  delayline_b1727 <= delay_pipeline(1727);

  delayline_b1751 <= delay_pipeline(1751);

  delayline_b1775 <= delay_pipeline(1775);

  delayline_b1799 <= delay_pipeline(1799);

  delayline_b1823 <= delay_pipeline(1823);

  delayline_b1847 <= delay_pipeline(1847);

  delayline_b1871 <= delay_pipeline(1871);

  delayline_b1895 <= delay_pipeline(1895);

  delayline_b1919 <= delay_pipeline(1919);

  delayline_b1943 <= delay_pipeline(1943);

  delayline_b1967 <= delay_pipeline(1967);

  delayline_b1991 <= delay_pipeline(1991);

  delayline_b2015 <= delay_pipeline(2015);

  delayline_b2039 <= delay_pipeline(2039);

  delayline_b2063 <= delay_pipeline(2063);

  delayline_b2087 <= delay_pipeline(2087);

  delayline_b2111 <= delay_pipeline(2111);

  delayline_b2135 <= delay_pipeline(2135);

  delayline_b2159 <= delay_pipeline(2159);

  delayline_b2183 <= delay_pipeline(2183);

  delayline_b2207 <= delay_pipeline(2207);

  delayline_b2231 <= delay_pipeline(2231);

  delayline_b2255 <= delay_pipeline(2255);

  delayline_b2279 <= delay_pipeline(2279);

  delayline_b2303 <= delay_pipeline(2303);

  delayline_b2327 <= delay_pipeline(2327);

  delayline_b2351 <= delay_pipeline(2351);

  delayline_b2375 <= delay_pipeline(2375);

  delayline_b2399 <= delay_pipeline(2399);

  delayline_b2423 <= delay_pipeline(2423);

  delayline_b2447 <= delay_pipeline(2447);

  delayline_b2471 <= delay_pipeline(2471);

  delayline_b2495 <= delay_pipeline(2495);

  delayline_b2519 <= delay_pipeline(2519);

  delayline_b2543 <= delay_pipeline(2543);

  delayline_b2567 <= delay_pipeline(2567);

  delayline_b2591 <= delay_pipeline(2591);

  delayline_b2615 <= delay_pipeline(2615);

  delayline_b2639 <= delay_pipeline(2639);

  delayline_b2663 <= delay_pipeline(2663);

  delayline_b2687 <= delay_pipeline(2687);

  delayline_b2711 <= delay_pipeline(2711);

  delayline_b2735 <= delay_pipeline(2735);

  delayline_b2759 <= delay_pipeline(2759);

  delayline_b2783 <= delay_pipeline(2783);

  delayline_b2807 <= delay_pipeline(2807);

  delayline_b2831 <= delay_pipeline(2831);

  delayline_b2855 <= delay_pipeline(2855);

  delayline_b2879 <= delay_pipeline(2879);

  delayline_b2903 <= delay_pipeline(2903);

  delayline_b2927 <= delay_pipeline(2927);

  delayline_b2951 <= delay_pipeline(2951);

  delayline_b2975 <= delay_pipeline(2975);

  delayline_b2999 <= delay_pipeline(2999);

  delayline_b3023 <= delay_pipeline(3023);

  delayline_b3047 <= delay_pipeline(3047);

  delayline_b3071 <= delay_pipeline(3071);

  delayline_b3095 <= delay_pipeline(3095);

  delayline_b3119 <= delay_pipeline(3119);

  delayline_b3143 <= delay_pipeline(3143);

  delayline_b3167 <= delay_pipeline(3167);

  delayline_b3191 <= delay_pipeline(3191);

  delayline_b3215 <= delay_pipeline(3215);

  delayline_b3239 <= delay_pipeline(3239);

  delayline_b3263 <= delay_pipeline(3263);

  delayline_b3287 <= delay_pipeline(3287);

  delayline_b3311 <= delay_pipeline(3311);

  delayline_b3335 <= delay_pipeline(3335);

  delayline_b3359 <= delay_pipeline(3359);

  delayline_b3383 <= delay_pipeline(3383);

  delayline_b3407 <= delay_pipeline(3407);

  delayline_b3431 <= delay_pipeline(3431);

  delayline_b3455 <= delay_pipeline(3455);

  delayline_b3479 <= delay_pipeline(3479);

  delayline_b3503 <= delay_pipeline(3503);

  delayline_b3527 <= delay_pipeline(3527);

  delayline_b3551 <= delay_pipeline(3551);

  delayline_b3575 <= delay_pipeline(3575);

  delayline_b3599 <= delay_pipeline(3599);

  delayline_b3623 <= delay_pipeline(3623);

  delayline_b3647 <= delay_pipeline(3647);

  delayline_b3671 <= delay_pipeline(3671);

  delayline_b3695 <= delay_pipeline(3695);

  delayline_b3719 <= delay_pipeline(3719);

  delayline_b3743 <= delay_pipeline(3743);

  delayline_b3767 <= delay_pipeline(3767);

  delayline_b3791 <= delay_pipeline(3791);

  delayline_b3815 <= delay_pipeline(3815);

  delayline_b3839 <= delay_pipeline(3839);

  delayline_b3863 <= delay_pipeline(3863);

  delayline_b3887 <= delay_pipeline(3887);

  delayline_b3911 <= delay_pipeline(3911);

  delayline_b3935 <= delay_pipeline(3935);

  delayline_b3959 <= delay_pipeline(3959);

  delayline_b3983 <= delay_pipeline(3983);

  delayline_b4007 <= delay_pipeline(4007);

  delayline_b4031 <= delay_pipeline(4031);

  delayline_b4055 <= delay_pipeline(4055);

  delayline_b4079 <= delay_pipeline(4079);

  delayline_b4103 <= delay_pipeline(4103);

  delayline_b4127 <= delay_pipeline(4127);

  delayline_b4151 <= delay_pipeline(4151);

  delayline_b4175 <= delay_pipeline(4175);

  delayline_b4199 <= delay_pipeline(4199);

  delayline_b4223 <= delay_pipeline(4223);

  delayline_b4247 <= delay_pipeline(4247);

  delayline_b4271 <= delay_pipeline(4271);

  delayline_b4295 <= delay_pipeline(4295);

  delayline_b4319 <= delay_pipeline(4319);

  delayline_b4343 <= delay_pipeline(4343);

  delayline_b4367 <= delay_pipeline(4367);

  delayline_b4391 <= delay_pipeline(4391);

  delayline_b4415 <= delay_pipeline(4415);

  delayline_b4439 <= delay_pipeline(4439);

  delayline_b4463 <= delay_pipeline(4463);

  delayline_b4487 <= delay_pipeline(4487);

  delayline_b4511 <= delay_pipeline(4511);

  delayline_b4535 <= delay_pipeline(4535);

  delayline_b4559 <= delay_pipeline(4559);

  delayline_b4583 <= delay_pipeline(4583);

  delayline_b4607 <= delay_pipeline(4607);

  delayline_b4631 <= delay_pipeline(4631);

  delayline_b4655 <= delay_pipeline(4655);

  delayline_b4679 <= delay_pipeline(4679);

  delayline_b4703 <= delay_pipeline(4703);

  delayline_b4727 <= delay_pipeline(4727);

  delayline_b4751 <= delay_pipeline(4751);

  delayline_b4775 <= delay_pipeline(4775);

  delayline_b4799 <= delay_pipeline(4799);

  delayline_b4823 <= delay_pipeline(4823);

  delayline_b4847 <= delay_pipeline(4847);

  delayline_b4871 <= delay_pipeline(4871);

  delayline_b4895 <= delay_pipeline(4895);

  delayline_b4919 <= delay_pipeline(4919);

  delayline_b4943 <= delay_pipeline(4943);

  delayline_b4967 <= delay_pipeline(4967);

  delayline_b4991 <= delay_pipeline(4991);

  delayline_b5015 <= delay_pipeline(5015);

  delayline_b5039 <= delay_pipeline(5039);

  delayline_b5063 <= delay_pipeline(5063);

  delayline_b5087 <= delay_pipeline(5087);

  delayline_b5111 <= delay_pipeline(5111);

  delayline_b5135 <= delay_pipeline(5135);

  delayline_b5159 <= delay_pipeline(5159);

  delayline_b5183 <= delay_pipeline(5183);

  delayline_b5207 <= delay_pipeline(5207);

  delayline_b5231 <= delay_pipeline(5231);

  delayline_b5255 <= delay_pipeline(5255);

  delayline_b5279 <= delay_pipeline(5279);

  delayline_b5303 <= delay_pipeline(5303);

  delayline_b5327 <= delay_pipeline(5327);

  delayline_b5351 <= delay_pipeline(5351);

  delayline_b5375 <= delay_pipeline(5375);

  delayline_b5399 <= delay_pipeline(5399);

  delayline_b5423 <= delay_pipeline(5423);

  delayline_b5447 <= delay_pipeline(5447);

  delayline_b5471 <= delay_pipeline(5471);

  delayline_b5495 <= delay_pipeline(5495);

  delayline_b5519 <= delay_pipeline(5519);

  delayline_b5543 <= delay_pipeline(5543);

  delayline_b5567 <= delay_pipeline(5567);

  delayline_b5591 <= delay_pipeline(5591);

  delayline_b5615 <= delay_pipeline(5615);

  delayline_b5639 <= delay_pipeline(5639);

  delayline_b5663 <= delay_pipeline(5663);

  delayline_b5687 <= delay_pipeline(5687);

  delayline_b5711 <= delay_pipeline(5711);

  delayline_b5735 <= delay_pipeline(5735);

  delayline_b5759 <= delay_pipeline(5759);

  delayline_b5783 <= delay_pipeline(5783);

  delayline_b5807 <= delay_pipeline(5807);

  delayline_b5831 <= delay_pipeline(5831);

  delayline_b5855 <= delay_pipeline(5855);

  delayline_b5879 <= delay_pipeline(5879);

  delayline_b5903 <= delay_pipeline(5903);

  delayline_b5927 <= delay_pipeline(5927);

  delayline_b5951 <= delay_pipeline(5951);

  delayline_b5975 <= delay_pipeline(5975);

  delayline_b5999 <= delay_pipeline(5999);

  delayline_b6023 <= delay_pipeline(6023);

  delayline_b6047 <= delay_pipeline(6047);

  delayline_b6071 <= delay_pipeline(6071);

  delayline_b6095 <= delay_pipeline(6095);

  delayline_b6119 <= delay_pipeline(6119);

  delayline_b6143 <= delay_pipeline(6143);

  preaddbit1 <=  serialoutb1 XOR delayline_b6143 XOR carrymux1;

  temp1 <=  serialoutb1 AND delayline_b6143;

  temp2 <=  delayline_b6143 AND carrymux1;

  temp3 <=  serialoutb1 AND carrymux1;

  addcarry1 <=  temp1 OR temp2 OR temp3;

  carrymux1 <= const_zero WHEN ( phase_0 = '1' ) ELSE
               carryreg1;
  Carry_reg1_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg1 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg1 <= addcarry1;
      END IF;
    END IF; 
  END PROCESS Carry_reg1_process;

  preaddbit2 <=  delayline_b23 XOR delayline_b6119 XOR carrymux2;

  temp1_1 <=  delayline_b23 AND delayline_b6119;

  temp2_1 <=  delayline_b6119 AND carrymux2;

  temp3_1 <=  delayline_b23 AND carrymux2;

  addcarry2 <=  temp1_1 OR temp2_1 OR temp3_1;

  carrymux2 <= const_zero WHEN ( phase_0 = '1' ) ELSE
               carryreg2;
  Carry_reg2_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg2 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg2 <= addcarry2;
      END IF;
    END IF; 
  END PROCESS Carry_reg2_process;

  preaddbit3 <=  delayline_b47 XOR delayline_b6095 XOR carrymux3;

  temp1_2 <=  delayline_b47 AND delayline_b6095;

  temp2_2 <=  delayline_b6095 AND carrymux3;

  temp3_2 <=  delayline_b47 AND carrymux3;

  addcarry3 <=  temp1_2 OR temp2_2 OR temp3_2;

  carrymux3 <= const_zero WHEN ( phase_0 = '1' ) ELSE
               carryreg3;
  Carry_reg3_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg3 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg3 <= addcarry3;
      END IF;
    END IF; 
  END PROCESS Carry_reg3_process;

  preaddbit4 <=  delayline_b71 XOR delayline_b6071 XOR carrymux4;

  temp1_3 <=  delayline_b71 AND delayline_b6071;

  temp2_3 <=  delayline_b6071 AND carrymux4;

  temp3_3 <=  delayline_b71 AND carrymux4;

  addcarry4 <=  temp1_3 OR temp2_3 OR temp3_3;

  carrymux4 <= const_zero WHEN ( phase_0 = '1' ) ELSE
               carryreg4;
  Carry_reg4_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg4 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg4 <= addcarry4;
      END IF;
    END IF; 
  END PROCESS Carry_reg4_process;

  preaddbit5 <=  delayline_b95 XOR delayline_b6047 XOR carrymux5;

  temp1_4 <=  delayline_b95 AND delayline_b6047;

  temp2_4 <=  delayline_b6047 AND carrymux5;

  temp3_4 <=  delayline_b95 AND carrymux5;

  addcarry5 <=  temp1_4 OR temp2_4 OR temp3_4;

  carrymux5 <= const_zero WHEN ( phase_0 = '1' ) ELSE
               carryreg5;
  Carry_reg5_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg5 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg5 <= addcarry5;
      END IF;
    END IF; 
  END PROCESS Carry_reg5_process;

  preaddbit6 <=  delayline_b119 XOR delayline_b6023 XOR carrymux6;

  temp1_5 <=  delayline_b119 AND delayline_b6023;

  temp2_5 <=  delayline_b6023 AND carrymux6;

  temp3_5 <=  delayline_b119 AND carrymux6;

  addcarry6 <=  temp1_5 OR temp2_5 OR temp3_5;

  carrymux6 <= const_zero WHEN ( phase_0 = '1' ) ELSE
               carryreg6;
  Carry_reg6_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg6 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg6 <= addcarry6;
      END IF;
    END IF; 
  END PROCESS Carry_reg6_process;

  preaddbit7 <=  delayline_b143 XOR delayline_b5999 XOR carrymux7;

  temp1_6 <=  delayline_b143 AND delayline_b5999;

  temp2_6 <=  delayline_b5999 AND carrymux7;

  temp3_6 <=  delayline_b143 AND carrymux7;

  addcarry7 <=  temp1_6 OR temp2_6 OR temp3_6;

  carrymux7 <= const_zero WHEN ( phase_0 = '1' ) ELSE
               carryreg7;
  Carry_reg7_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg7 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg7 <= addcarry7;
      END IF;
    END IF; 
  END PROCESS Carry_reg7_process;

  preaddbit8 <=  delayline_b167 XOR delayline_b5975 XOR carrymux8;

  temp1_7 <=  delayline_b167 AND delayline_b5975;

  temp2_7 <=  delayline_b5975 AND carrymux8;

  temp3_7 <=  delayline_b167 AND carrymux8;

  addcarry8 <=  temp1_7 OR temp2_7 OR temp3_7;

  carrymux8 <= const_zero WHEN ( phase_0 = '1' ) ELSE
               carryreg8;
  Carry_reg8_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg8 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg8 <= addcarry8;
      END IF;
    END IF; 
  END PROCESS Carry_reg8_process;

  preaddbit9 <=  delayline_b191 XOR delayline_b5951 XOR carrymux9;

  temp1_8 <=  delayline_b191 AND delayline_b5951;

  temp2_8 <=  delayline_b5951 AND carrymux9;

  temp3_8 <=  delayline_b191 AND carrymux9;

  addcarry9 <=  temp1_8 OR temp2_8 OR temp3_8;

  carrymux9 <= const_zero WHEN ( phase_0 = '1' ) ELSE
               carryreg9;
  Carry_reg9_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg9 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg9 <= addcarry9;
      END IF;
    END IF; 
  END PROCESS Carry_reg9_process;

  preaddbit10 <=  delayline_b215 XOR delayline_b5927 XOR carrymux10;

  temp1_9 <=  delayline_b215 AND delayline_b5927;

  temp2_9 <=  delayline_b5927 AND carrymux10;

  temp3_9 <=  delayline_b215 AND carrymux10;

  addcarry10 <=  temp1_9 OR temp2_9 OR temp3_9;

  carrymux10 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg10;
  Carry_reg10_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg10 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg10 <= addcarry10;
      END IF;
    END IF; 
  END PROCESS Carry_reg10_process;

  preaddbit11 <=  delayline_b239 XOR delayline_b5903 XOR carrymux11;

  temp1_10 <=  delayline_b239 AND delayline_b5903;

  temp2_10 <=  delayline_b5903 AND carrymux11;

  temp3_10 <=  delayline_b239 AND carrymux11;

  addcarry11 <=  temp1_10 OR temp2_10 OR temp3_10;

  carrymux11 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg11;
  Carry_reg11_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg11 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg11 <= addcarry11;
      END IF;
    END IF; 
  END PROCESS Carry_reg11_process;

  preaddbit12 <=  delayline_b263 XOR delayline_b5879 XOR carrymux12;

  temp1_11 <=  delayline_b263 AND delayline_b5879;

  temp2_11 <=  delayline_b5879 AND carrymux12;

  temp3_11 <=  delayline_b263 AND carrymux12;

  addcarry12 <=  temp1_11 OR temp2_11 OR temp3_11;

  carrymux12 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg12;
  Carry_reg12_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg12 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg12 <= addcarry12;
      END IF;
    END IF; 
  END PROCESS Carry_reg12_process;

  preaddbit13 <=  delayline_b287 XOR delayline_b5855 XOR carrymux13;

  temp1_12 <=  delayline_b287 AND delayline_b5855;

  temp2_12 <=  delayline_b5855 AND carrymux13;

  temp3_12 <=  delayline_b287 AND carrymux13;

  addcarry13 <=  temp1_12 OR temp2_12 OR temp3_12;

  carrymux13 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg13;
  Carry_reg13_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg13 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg13 <= addcarry13;
      END IF;
    END IF; 
  END PROCESS Carry_reg13_process;

  preaddbit14 <=  delayline_b311 XOR delayline_b5831 XOR carrymux14;

  temp1_13 <=  delayline_b311 AND delayline_b5831;

  temp2_13 <=  delayline_b5831 AND carrymux14;

  temp3_13 <=  delayline_b311 AND carrymux14;

  addcarry14 <=  temp1_13 OR temp2_13 OR temp3_13;

  carrymux14 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg14;
  Carry_reg14_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg14 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg14 <= addcarry14;
      END IF;
    END IF; 
  END PROCESS Carry_reg14_process;

  preaddbit15 <=  delayline_b335 XOR delayline_b5807 XOR carrymux15;

  temp1_14 <=  delayline_b335 AND delayline_b5807;

  temp2_14 <=  delayline_b5807 AND carrymux15;

  temp3_14 <=  delayline_b335 AND carrymux15;

  addcarry15 <=  temp1_14 OR temp2_14 OR temp3_14;

  carrymux15 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg15;
  Carry_reg15_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg15 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg15 <= addcarry15;
      END IF;
    END IF; 
  END PROCESS Carry_reg15_process;

  preaddbit16 <=  delayline_b359 XOR delayline_b5783 XOR carrymux16;

  temp1_15 <=  delayline_b359 AND delayline_b5783;

  temp2_15 <=  delayline_b5783 AND carrymux16;

  temp3_15 <=  delayline_b359 AND carrymux16;

  addcarry16 <=  temp1_15 OR temp2_15 OR temp3_15;

  carrymux16 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg16;
  Carry_reg16_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg16 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg16 <= addcarry16;
      END IF;
    END IF; 
  END PROCESS Carry_reg16_process;

  preaddbit17 <=  delayline_b383 XOR delayline_b5759 XOR carrymux17;

  temp1_16 <=  delayline_b383 AND delayline_b5759;

  temp2_16 <=  delayline_b5759 AND carrymux17;

  temp3_16 <=  delayline_b383 AND carrymux17;

  addcarry17 <=  temp1_16 OR temp2_16 OR temp3_16;

  carrymux17 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg17;
  Carry_reg17_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg17 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg17 <= addcarry17;
      END IF;
    END IF; 
  END PROCESS Carry_reg17_process;

  preaddbit18 <=  delayline_b407 XOR delayline_b5735 XOR carrymux18;

  temp1_17 <=  delayline_b407 AND delayline_b5735;

  temp2_17 <=  delayline_b5735 AND carrymux18;

  temp3_17 <=  delayline_b407 AND carrymux18;

  addcarry18 <=  temp1_17 OR temp2_17 OR temp3_17;

  carrymux18 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg18;
  Carry_reg18_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg18 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg18 <= addcarry18;
      END IF;
    END IF; 
  END PROCESS Carry_reg18_process;

  preaddbit19 <=  delayline_b431 XOR delayline_b5711 XOR carrymux19;

  temp1_18 <=  delayline_b431 AND delayline_b5711;

  temp2_18 <=  delayline_b5711 AND carrymux19;

  temp3_18 <=  delayline_b431 AND carrymux19;

  addcarry19 <=  temp1_18 OR temp2_18 OR temp3_18;

  carrymux19 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg19;
  Carry_reg19_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg19 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg19 <= addcarry19;
      END IF;
    END IF; 
  END PROCESS Carry_reg19_process;

  preaddbit20 <=  delayline_b455 XOR delayline_b5687 XOR carrymux20;

  temp1_19 <=  delayline_b455 AND delayline_b5687;

  temp2_19 <=  delayline_b5687 AND carrymux20;

  temp3_19 <=  delayline_b455 AND carrymux20;

  addcarry20 <=  temp1_19 OR temp2_19 OR temp3_19;

  carrymux20 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg20;
  Carry_reg20_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg20 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg20 <= addcarry20;
      END IF;
    END IF; 
  END PROCESS Carry_reg20_process;

  preaddbit21 <=  delayline_b479 XOR delayline_b5663 XOR carrymux21;

  temp1_20 <=  delayline_b479 AND delayline_b5663;

  temp2_20 <=  delayline_b5663 AND carrymux21;

  temp3_20 <=  delayline_b479 AND carrymux21;

  addcarry21 <=  temp1_20 OR temp2_20 OR temp3_20;

  carrymux21 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg21;
  Carry_reg21_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg21 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg21 <= addcarry21;
      END IF;
    END IF; 
  END PROCESS Carry_reg21_process;

  preaddbit22 <=  delayline_b503 XOR delayline_b5639 XOR carrymux22;

  temp1_21 <=  delayline_b503 AND delayline_b5639;

  temp2_21 <=  delayline_b5639 AND carrymux22;

  temp3_21 <=  delayline_b503 AND carrymux22;

  addcarry22 <=  temp1_21 OR temp2_21 OR temp3_21;

  carrymux22 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg22;
  Carry_reg22_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg22 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg22 <= addcarry22;
      END IF;
    END IF; 
  END PROCESS Carry_reg22_process;

  preaddbit23 <=  delayline_b527 XOR delayline_b5615 XOR carrymux23;

  temp1_22 <=  delayline_b527 AND delayline_b5615;

  temp2_22 <=  delayline_b5615 AND carrymux23;

  temp3_22 <=  delayline_b527 AND carrymux23;

  addcarry23 <=  temp1_22 OR temp2_22 OR temp3_22;

  carrymux23 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg23;
  Carry_reg23_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg23 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg23 <= addcarry23;
      END IF;
    END IF; 
  END PROCESS Carry_reg23_process;

  preaddbit24 <=  delayline_b551 XOR delayline_b5591 XOR carrymux24;

  temp1_23 <=  delayline_b551 AND delayline_b5591;

  temp2_23 <=  delayline_b5591 AND carrymux24;

  temp3_23 <=  delayline_b551 AND carrymux24;

  addcarry24 <=  temp1_23 OR temp2_23 OR temp3_23;

  carrymux24 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg24;
  Carry_reg24_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg24 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg24 <= addcarry24;
      END IF;
    END IF; 
  END PROCESS Carry_reg24_process;

  preaddbit25 <=  delayline_b575 XOR delayline_b5567 XOR carrymux25;

  temp1_24 <=  delayline_b575 AND delayline_b5567;

  temp2_24 <=  delayline_b5567 AND carrymux25;

  temp3_24 <=  delayline_b575 AND carrymux25;

  addcarry25 <=  temp1_24 OR temp2_24 OR temp3_24;

  carrymux25 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg25;
  Carry_reg25_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg25 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg25 <= addcarry25;
      END IF;
    END IF; 
  END PROCESS Carry_reg25_process;

  preaddbit26 <=  delayline_b599 XOR delayline_b5543 XOR carrymux26;

  temp1_25 <=  delayline_b599 AND delayline_b5543;

  temp2_25 <=  delayline_b5543 AND carrymux26;

  temp3_25 <=  delayline_b599 AND carrymux26;

  addcarry26 <=  temp1_25 OR temp2_25 OR temp3_25;

  carrymux26 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg26;
  Carry_reg26_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg26 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg26 <= addcarry26;
      END IF;
    END IF; 
  END PROCESS Carry_reg26_process;

  preaddbit27 <=  delayline_b623 XOR delayline_b5519 XOR carrymux27;

  temp1_26 <=  delayline_b623 AND delayline_b5519;

  temp2_26 <=  delayline_b5519 AND carrymux27;

  temp3_26 <=  delayline_b623 AND carrymux27;

  addcarry27 <=  temp1_26 OR temp2_26 OR temp3_26;

  carrymux27 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg27;
  Carry_reg27_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg27 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg27 <= addcarry27;
      END IF;
    END IF; 
  END PROCESS Carry_reg27_process;

  preaddbit28 <=  delayline_b647 XOR delayline_b5495 XOR carrymux28;

  temp1_27 <=  delayline_b647 AND delayline_b5495;

  temp2_27 <=  delayline_b5495 AND carrymux28;

  temp3_27 <=  delayline_b647 AND carrymux28;

  addcarry28 <=  temp1_27 OR temp2_27 OR temp3_27;

  carrymux28 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg28;
  Carry_reg28_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg28 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg28 <= addcarry28;
      END IF;
    END IF; 
  END PROCESS Carry_reg28_process;

  preaddbit29 <=  delayline_b671 XOR delayline_b5471 XOR carrymux29;

  temp1_28 <=  delayline_b671 AND delayline_b5471;

  temp2_28 <=  delayline_b5471 AND carrymux29;

  temp3_28 <=  delayline_b671 AND carrymux29;

  addcarry29 <=  temp1_28 OR temp2_28 OR temp3_28;

  carrymux29 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg29;
  Carry_reg29_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg29 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg29 <= addcarry29;
      END IF;
    END IF; 
  END PROCESS Carry_reg29_process;

  preaddbit30 <=  delayline_b695 XOR delayline_b5447 XOR carrymux30;

  temp1_29 <=  delayline_b695 AND delayline_b5447;

  temp2_29 <=  delayline_b5447 AND carrymux30;

  temp3_29 <=  delayline_b695 AND carrymux30;

  addcarry30 <=  temp1_29 OR temp2_29 OR temp3_29;

  carrymux30 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg30;
  Carry_reg30_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg30 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg30 <= addcarry30;
      END IF;
    END IF; 
  END PROCESS Carry_reg30_process;

  preaddbit31 <=  delayline_b719 XOR delayline_b5423 XOR carrymux31;

  temp1_30 <=  delayline_b719 AND delayline_b5423;

  temp2_30 <=  delayline_b5423 AND carrymux31;

  temp3_30 <=  delayline_b719 AND carrymux31;

  addcarry31 <=  temp1_30 OR temp2_30 OR temp3_30;

  carrymux31 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg31;
  Carry_reg31_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg31 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg31 <= addcarry31;
      END IF;
    END IF; 
  END PROCESS Carry_reg31_process;

  preaddbit32 <=  delayline_b743 XOR delayline_b5399 XOR carrymux32;

  temp1_31 <=  delayline_b743 AND delayline_b5399;

  temp2_31 <=  delayline_b5399 AND carrymux32;

  temp3_31 <=  delayline_b743 AND carrymux32;

  addcarry32 <=  temp1_31 OR temp2_31 OR temp3_31;

  carrymux32 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg32;
  Carry_reg32_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg32 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg32 <= addcarry32;
      END IF;
    END IF; 
  END PROCESS Carry_reg32_process;

  preaddbit33 <=  delayline_b767 XOR delayline_b5375 XOR carrymux33;

  temp1_32 <=  delayline_b767 AND delayline_b5375;

  temp2_32 <=  delayline_b5375 AND carrymux33;

  temp3_32 <=  delayline_b767 AND carrymux33;

  addcarry33 <=  temp1_32 OR temp2_32 OR temp3_32;

  carrymux33 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg33;
  Carry_reg33_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg33 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg33 <= addcarry33;
      END IF;
    END IF; 
  END PROCESS Carry_reg33_process;

  preaddbit34 <=  delayline_b791 XOR delayline_b5351 XOR carrymux34;

  temp1_33 <=  delayline_b791 AND delayline_b5351;

  temp2_33 <=  delayline_b5351 AND carrymux34;

  temp3_33 <=  delayline_b791 AND carrymux34;

  addcarry34 <=  temp1_33 OR temp2_33 OR temp3_33;

  carrymux34 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg34;
  Carry_reg34_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg34 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg34 <= addcarry34;
      END IF;
    END IF; 
  END PROCESS Carry_reg34_process;

  preaddbit35 <=  delayline_b815 XOR delayline_b5327 XOR carrymux35;

  temp1_34 <=  delayline_b815 AND delayline_b5327;

  temp2_34 <=  delayline_b5327 AND carrymux35;

  temp3_34 <=  delayline_b815 AND carrymux35;

  addcarry35 <=  temp1_34 OR temp2_34 OR temp3_34;

  carrymux35 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg35;
  Carry_reg35_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg35 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg35 <= addcarry35;
      END IF;
    END IF; 
  END PROCESS Carry_reg35_process;

  preaddbit36 <=  delayline_b839 XOR delayline_b5303 XOR carrymux36;

  temp1_35 <=  delayline_b839 AND delayline_b5303;

  temp2_35 <=  delayline_b5303 AND carrymux36;

  temp3_35 <=  delayline_b839 AND carrymux36;

  addcarry36 <=  temp1_35 OR temp2_35 OR temp3_35;

  carrymux36 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg36;
  Carry_reg36_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg36 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg36 <= addcarry36;
      END IF;
    END IF; 
  END PROCESS Carry_reg36_process;

  preaddbit37 <=  delayline_b863 XOR delayline_b5279 XOR carrymux37;

  temp1_36 <=  delayline_b863 AND delayline_b5279;

  temp2_36 <=  delayline_b5279 AND carrymux37;

  temp3_36 <=  delayline_b863 AND carrymux37;

  addcarry37 <=  temp1_36 OR temp2_36 OR temp3_36;

  carrymux37 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg37;
  Carry_reg37_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg37 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg37 <= addcarry37;
      END IF;
    END IF; 
  END PROCESS Carry_reg37_process;

  preaddbit38 <=  delayline_b887 XOR delayline_b5255 XOR carrymux38;

  temp1_37 <=  delayline_b887 AND delayline_b5255;

  temp2_37 <=  delayline_b5255 AND carrymux38;

  temp3_37 <=  delayline_b887 AND carrymux38;

  addcarry38 <=  temp1_37 OR temp2_37 OR temp3_37;

  carrymux38 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg38;
  Carry_reg38_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg38 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg38 <= addcarry38;
      END IF;
    END IF; 
  END PROCESS Carry_reg38_process;

  preaddbit39 <=  delayline_b911 XOR delayline_b5231 XOR carrymux39;

  temp1_38 <=  delayline_b911 AND delayline_b5231;

  temp2_38 <=  delayline_b5231 AND carrymux39;

  temp3_38 <=  delayline_b911 AND carrymux39;

  addcarry39 <=  temp1_38 OR temp2_38 OR temp3_38;

  carrymux39 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg39;
  Carry_reg39_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg39 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg39 <= addcarry39;
      END IF;
    END IF; 
  END PROCESS Carry_reg39_process;

  preaddbit40 <=  delayline_b935 XOR delayline_b5207 XOR carrymux40;

  temp1_39 <=  delayline_b935 AND delayline_b5207;

  temp2_39 <=  delayline_b5207 AND carrymux40;

  temp3_39 <=  delayline_b935 AND carrymux40;

  addcarry40 <=  temp1_39 OR temp2_39 OR temp3_39;

  carrymux40 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg40;
  Carry_reg40_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg40 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg40 <= addcarry40;
      END IF;
    END IF; 
  END PROCESS Carry_reg40_process;

  preaddbit41 <=  delayline_b959 XOR delayline_b5183 XOR carrymux41;

  temp1_40 <=  delayline_b959 AND delayline_b5183;

  temp2_40 <=  delayline_b5183 AND carrymux41;

  temp3_40 <=  delayline_b959 AND carrymux41;

  addcarry41 <=  temp1_40 OR temp2_40 OR temp3_40;

  carrymux41 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg41;
  Carry_reg41_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg41 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg41 <= addcarry41;
      END IF;
    END IF; 
  END PROCESS Carry_reg41_process;

  preaddbit42 <=  delayline_b983 XOR delayline_b5159 XOR carrymux42;

  temp1_41 <=  delayline_b983 AND delayline_b5159;

  temp2_41 <=  delayline_b5159 AND carrymux42;

  temp3_41 <=  delayline_b983 AND carrymux42;

  addcarry42 <=  temp1_41 OR temp2_41 OR temp3_41;

  carrymux42 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg42;
  Carry_reg42_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg42 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg42 <= addcarry42;
      END IF;
    END IF; 
  END PROCESS Carry_reg42_process;

  preaddbit43 <=  delayline_b1007 XOR delayline_b5135 XOR carrymux43;

  temp1_42 <=  delayline_b1007 AND delayline_b5135;

  temp2_42 <=  delayline_b5135 AND carrymux43;

  temp3_42 <=  delayline_b1007 AND carrymux43;

  addcarry43 <=  temp1_42 OR temp2_42 OR temp3_42;

  carrymux43 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg43;
  Carry_reg43_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg43 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg43 <= addcarry43;
      END IF;
    END IF; 
  END PROCESS Carry_reg43_process;

  preaddbit44 <=  delayline_b1031 XOR delayline_b5111 XOR carrymux44;

  temp1_43 <=  delayline_b1031 AND delayline_b5111;

  temp2_43 <=  delayline_b5111 AND carrymux44;

  temp3_43 <=  delayline_b1031 AND carrymux44;

  addcarry44 <=  temp1_43 OR temp2_43 OR temp3_43;

  carrymux44 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg44;
  Carry_reg44_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg44 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg44 <= addcarry44;
      END IF;
    END IF; 
  END PROCESS Carry_reg44_process;

  preaddbit45 <=  delayline_b1055 XOR delayline_b5087 XOR carrymux45;

  temp1_44 <=  delayline_b1055 AND delayline_b5087;

  temp2_44 <=  delayline_b5087 AND carrymux45;

  temp3_44 <=  delayline_b1055 AND carrymux45;

  addcarry45 <=  temp1_44 OR temp2_44 OR temp3_44;

  carrymux45 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg45;
  Carry_reg45_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg45 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg45 <= addcarry45;
      END IF;
    END IF; 
  END PROCESS Carry_reg45_process;

  preaddbit46 <=  delayline_b1079 XOR delayline_b5063 XOR carrymux46;

  temp1_45 <=  delayline_b1079 AND delayline_b5063;

  temp2_45 <=  delayline_b5063 AND carrymux46;

  temp3_45 <=  delayline_b1079 AND carrymux46;

  addcarry46 <=  temp1_45 OR temp2_45 OR temp3_45;

  carrymux46 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg46;
  Carry_reg46_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg46 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg46 <= addcarry46;
      END IF;
    END IF; 
  END PROCESS Carry_reg46_process;

  preaddbit47 <=  delayline_b1103 XOR delayline_b5039 XOR carrymux47;

  temp1_46 <=  delayline_b1103 AND delayline_b5039;

  temp2_46 <=  delayline_b5039 AND carrymux47;

  temp3_46 <=  delayline_b1103 AND carrymux47;

  addcarry47 <=  temp1_46 OR temp2_46 OR temp3_46;

  carrymux47 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg47;
  Carry_reg47_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg47 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg47 <= addcarry47;
      END IF;
    END IF; 
  END PROCESS Carry_reg47_process;

  preaddbit48 <=  delayline_b1127 XOR delayline_b5015 XOR carrymux48;

  temp1_47 <=  delayline_b1127 AND delayline_b5015;

  temp2_47 <=  delayline_b5015 AND carrymux48;

  temp3_47 <=  delayline_b1127 AND carrymux48;

  addcarry48 <=  temp1_47 OR temp2_47 OR temp3_47;

  carrymux48 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg48;
  Carry_reg48_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg48 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg48 <= addcarry48;
      END IF;
    END IF; 
  END PROCESS Carry_reg48_process;

  preaddbit49 <=  delayline_b1151 XOR delayline_b4991 XOR carrymux49;

  temp1_48 <=  delayline_b1151 AND delayline_b4991;

  temp2_48 <=  delayline_b4991 AND carrymux49;

  temp3_48 <=  delayline_b1151 AND carrymux49;

  addcarry49 <=  temp1_48 OR temp2_48 OR temp3_48;

  carrymux49 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg49;
  Carry_reg49_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg49 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg49 <= addcarry49;
      END IF;
    END IF; 
  END PROCESS Carry_reg49_process;

  preaddbit50 <=  delayline_b1175 XOR delayline_b4967 XOR carrymux50;

  temp1_49 <=  delayline_b1175 AND delayline_b4967;

  temp2_49 <=  delayline_b4967 AND carrymux50;

  temp3_49 <=  delayline_b1175 AND carrymux50;

  addcarry50 <=  temp1_49 OR temp2_49 OR temp3_49;

  carrymux50 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg50;
  Carry_reg50_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg50 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg50 <= addcarry50;
      END IF;
    END IF; 
  END PROCESS Carry_reg50_process;

  preaddbit51 <=  delayline_b1199 XOR delayline_b4943 XOR carrymux51;

  temp1_50 <=  delayline_b1199 AND delayline_b4943;

  temp2_50 <=  delayline_b4943 AND carrymux51;

  temp3_50 <=  delayline_b1199 AND carrymux51;

  addcarry51 <=  temp1_50 OR temp2_50 OR temp3_50;

  carrymux51 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg51;
  Carry_reg51_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg51 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg51 <= addcarry51;
      END IF;
    END IF; 
  END PROCESS Carry_reg51_process;

  preaddbit52 <=  delayline_b1223 XOR delayline_b4919 XOR carrymux52;

  temp1_51 <=  delayline_b1223 AND delayline_b4919;

  temp2_51 <=  delayline_b4919 AND carrymux52;

  temp3_51 <=  delayline_b1223 AND carrymux52;

  addcarry52 <=  temp1_51 OR temp2_51 OR temp3_51;

  carrymux52 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg52;
  Carry_reg52_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg52 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg52 <= addcarry52;
      END IF;
    END IF; 
  END PROCESS Carry_reg52_process;

  preaddbit53 <=  delayline_b1247 XOR delayline_b4895 XOR carrymux53;

  temp1_52 <=  delayline_b1247 AND delayline_b4895;

  temp2_52 <=  delayline_b4895 AND carrymux53;

  temp3_52 <=  delayline_b1247 AND carrymux53;

  addcarry53 <=  temp1_52 OR temp2_52 OR temp3_52;

  carrymux53 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg53;
  Carry_reg53_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg53 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg53 <= addcarry53;
      END IF;
    END IF; 
  END PROCESS Carry_reg53_process;

  preaddbit54 <=  delayline_b1271 XOR delayline_b4871 XOR carrymux54;

  temp1_53 <=  delayline_b1271 AND delayline_b4871;

  temp2_53 <=  delayline_b4871 AND carrymux54;

  temp3_53 <=  delayline_b1271 AND carrymux54;

  addcarry54 <=  temp1_53 OR temp2_53 OR temp3_53;

  carrymux54 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg54;
  Carry_reg54_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg54 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg54 <= addcarry54;
      END IF;
    END IF; 
  END PROCESS Carry_reg54_process;

  preaddbit55 <=  delayline_b1295 XOR delayline_b4847 XOR carrymux55;

  temp1_54 <=  delayline_b1295 AND delayline_b4847;

  temp2_54 <=  delayline_b4847 AND carrymux55;

  temp3_54 <=  delayline_b1295 AND carrymux55;

  addcarry55 <=  temp1_54 OR temp2_54 OR temp3_54;

  carrymux55 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg55;
  Carry_reg55_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg55 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg55 <= addcarry55;
      END IF;
    END IF; 
  END PROCESS Carry_reg55_process;

  preaddbit56 <=  delayline_b1319 XOR delayline_b4823 XOR carrymux56;

  temp1_55 <=  delayline_b1319 AND delayline_b4823;

  temp2_55 <=  delayline_b4823 AND carrymux56;

  temp3_55 <=  delayline_b1319 AND carrymux56;

  addcarry56 <=  temp1_55 OR temp2_55 OR temp3_55;

  carrymux56 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg56;
  Carry_reg56_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg56 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg56 <= addcarry56;
      END IF;
    END IF; 
  END PROCESS Carry_reg56_process;

  preaddbit57 <=  delayline_b1343 XOR delayline_b4799 XOR carrymux57;

  temp1_56 <=  delayline_b1343 AND delayline_b4799;

  temp2_56 <=  delayline_b4799 AND carrymux57;

  temp3_56 <=  delayline_b1343 AND carrymux57;

  addcarry57 <=  temp1_56 OR temp2_56 OR temp3_56;

  carrymux57 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg57;
  Carry_reg57_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg57 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg57 <= addcarry57;
      END IF;
    END IF; 
  END PROCESS Carry_reg57_process;

  preaddbit58 <=  delayline_b1367 XOR delayline_b4775 XOR carrymux58;

  temp1_57 <=  delayline_b1367 AND delayline_b4775;

  temp2_57 <=  delayline_b4775 AND carrymux58;

  temp3_57 <=  delayline_b1367 AND carrymux58;

  addcarry58 <=  temp1_57 OR temp2_57 OR temp3_57;

  carrymux58 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg58;
  Carry_reg58_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg58 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg58 <= addcarry58;
      END IF;
    END IF; 
  END PROCESS Carry_reg58_process;

  preaddbit59 <=  delayline_b1391 XOR delayline_b4751 XOR carrymux59;

  temp1_58 <=  delayline_b1391 AND delayline_b4751;

  temp2_58 <=  delayline_b4751 AND carrymux59;

  temp3_58 <=  delayline_b1391 AND carrymux59;

  addcarry59 <=  temp1_58 OR temp2_58 OR temp3_58;

  carrymux59 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg59;
  Carry_reg59_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg59 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg59 <= addcarry59;
      END IF;
    END IF; 
  END PROCESS Carry_reg59_process;

  preaddbit60 <=  delayline_b1415 XOR delayline_b4727 XOR carrymux60;

  temp1_59 <=  delayline_b1415 AND delayline_b4727;

  temp2_59 <=  delayline_b4727 AND carrymux60;

  temp3_59 <=  delayline_b1415 AND carrymux60;

  addcarry60 <=  temp1_59 OR temp2_59 OR temp3_59;

  carrymux60 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg60;
  Carry_reg60_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg60 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg60 <= addcarry60;
      END IF;
    END IF; 
  END PROCESS Carry_reg60_process;

  preaddbit61 <=  delayline_b1439 XOR delayline_b4703 XOR carrymux61;

  temp1_60 <=  delayline_b1439 AND delayline_b4703;

  temp2_60 <=  delayline_b4703 AND carrymux61;

  temp3_60 <=  delayline_b1439 AND carrymux61;

  addcarry61 <=  temp1_60 OR temp2_60 OR temp3_60;

  carrymux61 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg61;
  Carry_reg61_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg61 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg61 <= addcarry61;
      END IF;
    END IF; 
  END PROCESS Carry_reg61_process;

  preaddbit62 <=  delayline_b1463 XOR delayline_b4679 XOR carrymux62;

  temp1_61 <=  delayline_b1463 AND delayline_b4679;

  temp2_61 <=  delayline_b4679 AND carrymux62;

  temp3_61 <=  delayline_b1463 AND carrymux62;

  addcarry62 <=  temp1_61 OR temp2_61 OR temp3_61;

  carrymux62 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg62;
  Carry_reg62_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg62 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg62 <= addcarry62;
      END IF;
    END IF; 
  END PROCESS Carry_reg62_process;

  preaddbit63 <=  delayline_b1487 XOR delayline_b4655 XOR carrymux63;

  temp1_62 <=  delayline_b1487 AND delayline_b4655;

  temp2_62 <=  delayline_b4655 AND carrymux63;

  temp3_62 <=  delayline_b1487 AND carrymux63;

  addcarry63 <=  temp1_62 OR temp2_62 OR temp3_62;

  carrymux63 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg63;
  Carry_reg63_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg63 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg63 <= addcarry63;
      END IF;
    END IF; 
  END PROCESS Carry_reg63_process;

  preaddbit64 <=  delayline_b1511 XOR delayline_b4631 XOR carrymux64;

  temp1_63 <=  delayline_b1511 AND delayline_b4631;

  temp2_63 <=  delayline_b4631 AND carrymux64;

  temp3_63 <=  delayline_b1511 AND carrymux64;

  addcarry64 <=  temp1_63 OR temp2_63 OR temp3_63;

  carrymux64 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg64;
  Carry_reg64_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg64 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg64 <= addcarry64;
      END IF;
    END IF; 
  END PROCESS Carry_reg64_process;

  preaddbit65 <=  delayline_b1535 XOR delayline_b4607 XOR carrymux65;

  temp1_64 <=  delayline_b1535 AND delayline_b4607;

  temp2_64 <=  delayline_b4607 AND carrymux65;

  temp3_64 <=  delayline_b1535 AND carrymux65;

  addcarry65 <=  temp1_64 OR temp2_64 OR temp3_64;

  carrymux65 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg65;
  Carry_reg65_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg65 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg65 <= addcarry65;
      END IF;
    END IF; 
  END PROCESS Carry_reg65_process;

  preaddbit66 <=  delayline_b1559 XOR delayline_b4583 XOR carrymux66;

  temp1_65 <=  delayline_b1559 AND delayline_b4583;

  temp2_65 <=  delayline_b4583 AND carrymux66;

  temp3_65 <=  delayline_b1559 AND carrymux66;

  addcarry66 <=  temp1_65 OR temp2_65 OR temp3_65;

  carrymux66 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg66;
  Carry_reg66_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg66 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg66 <= addcarry66;
      END IF;
    END IF; 
  END PROCESS Carry_reg66_process;

  preaddbit67 <=  delayline_b1583 XOR delayline_b4559 XOR carrymux67;

  temp1_66 <=  delayline_b1583 AND delayline_b4559;

  temp2_66 <=  delayline_b4559 AND carrymux67;

  temp3_66 <=  delayline_b1583 AND carrymux67;

  addcarry67 <=  temp1_66 OR temp2_66 OR temp3_66;

  carrymux67 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg67;
  Carry_reg67_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg67 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg67 <= addcarry67;
      END IF;
    END IF; 
  END PROCESS Carry_reg67_process;

  preaddbit68 <=  delayline_b1607 XOR delayline_b4535 XOR carrymux68;

  temp1_67 <=  delayline_b1607 AND delayline_b4535;

  temp2_67 <=  delayline_b4535 AND carrymux68;

  temp3_67 <=  delayline_b1607 AND carrymux68;

  addcarry68 <=  temp1_67 OR temp2_67 OR temp3_67;

  carrymux68 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg68;
  Carry_reg68_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg68 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg68 <= addcarry68;
      END IF;
    END IF; 
  END PROCESS Carry_reg68_process;

  preaddbit69 <=  delayline_b1631 XOR delayline_b4511 XOR carrymux69;

  temp1_68 <=  delayline_b1631 AND delayline_b4511;

  temp2_68 <=  delayline_b4511 AND carrymux69;

  temp3_68 <=  delayline_b1631 AND carrymux69;

  addcarry69 <=  temp1_68 OR temp2_68 OR temp3_68;

  carrymux69 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg69;
  Carry_reg69_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg69 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg69 <= addcarry69;
      END IF;
    END IF; 
  END PROCESS Carry_reg69_process;

  preaddbit70 <=  delayline_b1655 XOR delayline_b4487 XOR carrymux70;

  temp1_69 <=  delayline_b1655 AND delayline_b4487;

  temp2_69 <=  delayline_b4487 AND carrymux70;

  temp3_69 <=  delayline_b1655 AND carrymux70;

  addcarry70 <=  temp1_69 OR temp2_69 OR temp3_69;

  carrymux70 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg70;
  Carry_reg70_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg70 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg70 <= addcarry70;
      END IF;
    END IF; 
  END PROCESS Carry_reg70_process;

  preaddbit71 <=  delayline_b1679 XOR delayline_b4463 XOR carrymux71;

  temp1_70 <=  delayline_b1679 AND delayline_b4463;

  temp2_70 <=  delayline_b4463 AND carrymux71;

  temp3_70 <=  delayline_b1679 AND carrymux71;

  addcarry71 <=  temp1_70 OR temp2_70 OR temp3_70;

  carrymux71 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg71;
  Carry_reg71_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg71 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg71 <= addcarry71;
      END IF;
    END IF; 
  END PROCESS Carry_reg71_process;

  preaddbit72 <=  delayline_b1703 XOR delayline_b4439 XOR carrymux72;

  temp1_71 <=  delayline_b1703 AND delayline_b4439;

  temp2_71 <=  delayline_b4439 AND carrymux72;

  temp3_71 <=  delayline_b1703 AND carrymux72;

  addcarry72 <=  temp1_71 OR temp2_71 OR temp3_71;

  carrymux72 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg72;
  Carry_reg72_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg72 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg72 <= addcarry72;
      END IF;
    END IF; 
  END PROCESS Carry_reg72_process;

  preaddbit73 <=  delayline_b1727 XOR delayline_b4415 XOR carrymux73;

  temp1_72 <=  delayline_b1727 AND delayline_b4415;

  temp2_72 <=  delayline_b4415 AND carrymux73;

  temp3_72 <=  delayline_b1727 AND carrymux73;

  addcarry73 <=  temp1_72 OR temp2_72 OR temp3_72;

  carrymux73 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg73;
  Carry_reg73_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg73 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg73 <= addcarry73;
      END IF;
    END IF; 
  END PROCESS Carry_reg73_process;

  preaddbit74 <=  delayline_b1751 XOR delayline_b4391 XOR carrymux74;

  temp1_73 <=  delayline_b1751 AND delayline_b4391;

  temp2_73 <=  delayline_b4391 AND carrymux74;

  temp3_73 <=  delayline_b1751 AND carrymux74;

  addcarry74 <=  temp1_73 OR temp2_73 OR temp3_73;

  carrymux74 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg74;
  Carry_reg74_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg74 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg74 <= addcarry74;
      END IF;
    END IF; 
  END PROCESS Carry_reg74_process;

  preaddbit75 <=  delayline_b1775 XOR delayline_b4367 XOR carrymux75;

  temp1_74 <=  delayline_b1775 AND delayline_b4367;

  temp2_74 <=  delayline_b4367 AND carrymux75;

  temp3_74 <=  delayline_b1775 AND carrymux75;

  addcarry75 <=  temp1_74 OR temp2_74 OR temp3_74;

  carrymux75 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg75;
  Carry_reg75_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg75 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg75 <= addcarry75;
      END IF;
    END IF; 
  END PROCESS Carry_reg75_process;

  preaddbit76 <=  delayline_b1799 XOR delayline_b4343 XOR carrymux76;

  temp1_75 <=  delayline_b1799 AND delayline_b4343;

  temp2_75 <=  delayline_b4343 AND carrymux76;

  temp3_75 <=  delayline_b1799 AND carrymux76;

  addcarry76 <=  temp1_75 OR temp2_75 OR temp3_75;

  carrymux76 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg76;
  Carry_reg76_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg76 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg76 <= addcarry76;
      END IF;
    END IF; 
  END PROCESS Carry_reg76_process;

  preaddbit77 <=  delayline_b1823 XOR delayline_b4319 XOR carrymux77;

  temp1_76 <=  delayline_b1823 AND delayline_b4319;

  temp2_76 <=  delayline_b4319 AND carrymux77;

  temp3_76 <=  delayline_b1823 AND carrymux77;

  addcarry77 <=  temp1_76 OR temp2_76 OR temp3_76;

  carrymux77 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg77;
  Carry_reg77_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg77 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg77 <= addcarry77;
      END IF;
    END IF; 
  END PROCESS Carry_reg77_process;

  preaddbit78 <=  delayline_b1847 XOR delayline_b4295 XOR carrymux78;

  temp1_77 <=  delayline_b1847 AND delayline_b4295;

  temp2_77 <=  delayline_b4295 AND carrymux78;

  temp3_77 <=  delayline_b1847 AND carrymux78;

  addcarry78 <=  temp1_77 OR temp2_77 OR temp3_77;

  carrymux78 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg78;
  Carry_reg78_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg78 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg78 <= addcarry78;
      END IF;
    END IF; 
  END PROCESS Carry_reg78_process;

  preaddbit79 <=  delayline_b1871 XOR delayline_b4271 XOR carrymux79;

  temp1_78 <=  delayline_b1871 AND delayline_b4271;

  temp2_78 <=  delayline_b4271 AND carrymux79;

  temp3_78 <=  delayline_b1871 AND carrymux79;

  addcarry79 <=  temp1_78 OR temp2_78 OR temp3_78;

  carrymux79 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg79;
  Carry_reg79_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg79 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg79 <= addcarry79;
      END IF;
    END IF; 
  END PROCESS Carry_reg79_process;

  preaddbit80 <=  delayline_b1895 XOR delayline_b4247 XOR carrymux80;

  temp1_79 <=  delayline_b1895 AND delayline_b4247;

  temp2_79 <=  delayline_b4247 AND carrymux80;

  temp3_79 <=  delayline_b1895 AND carrymux80;

  addcarry80 <=  temp1_79 OR temp2_79 OR temp3_79;

  carrymux80 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg80;
  Carry_reg80_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg80 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg80 <= addcarry80;
      END IF;
    END IF; 
  END PROCESS Carry_reg80_process;

  preaddbit81 <=  delayline_b1919 XOR delayline_b4223 XOR carrymux81;

  temp1_80 <=  delayline_b1919 AND delayline_b4223;

  temp2_80 <=  delayline_b4223 AND carrymux81;

  temp3_80 <=  delayline_b1919 AND carrymux81;

  addcarry81 <=  temp1_80 OR temp2_80 OR temp3_80;

  carrymux81 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg81;
  Carry_reg81_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg81 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg81 <= addcarry81;
      END IF;
    END IF; 
  END PROCESS Carry_reg81_process;

  preaddbit82 <=  delayline_b1943 XOR delayline_b4199 XOR carrymux82;

  temp1_81 <=  delayline_b1943 AND delayline_b4199;

  temp2_81 <=  delayline_b4199 AND carrymux82;

  temp3_81 <=  delayline_b1943 AND carrymux82;

  addcarry82 <=  temp1_81 OR temp2_81 OR temp3_81;

  carrymux82 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg82;
  Carry_reg82_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg82 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg82 <= addcarry82;
      END IF;
    END IF; 
  END PROCESS Carry_reg82_process;

  preaddbit83 <=  delayline_b1967 XOR delayline_b4175 XOR carrymux83;

  temp1_82 <=  delayline_b1967 AND delayline_b4175;

  temp2_82 <=  delayline_b4175 AND carrymux83;

  temp3_82 <=  delayline_b1967 AND carrymux83;

  addcarry83 <=  temp1_82 OR temp2_82 OR temp3_82;

  carrymux83 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg83;
  Carry_reg83_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg83 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg83 <= addcarry83;
      END IF;
    END IF; 
  END PROCESS Carry_reg83_process;

  preaddbit84 <=  delayline_b1991 XOR delayline_b4151 XOR carrymux84;

  temp1_83 <=  delayline_b1991 AND delayline_b4151;

  temp2_83 <=  delayline_b4151 AND carrymux84;

  temp3_83 <=  delayline_b1991 AND carrymux84;

  addcarry84 <=  temp1_83 OR temp2_83 OR temp3_83;

  carrymux84 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg84;
  Carry_reg84_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg84 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg84 <= addcarry84;
      END IF;
    END IF; 
  END PROCESS Carry_reg84_process;

  preaddbit85 <=  delayline_b2015 XOR delayline_b4127 XOR carrymux85;

  temp1_84 <=  delayline_b2015 AND delayline_b4127;

  temp2_84 <=  delayline_b4127 AND carrymux85;

  temp3_84 <=  delayline_b2015 AND carrymux85;

  addcarry85 <=  temp1_84 OR temp2_84 OR temp3_84;

  carrymux85 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg85;
  Carry_reg85_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg85 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg85 <= addcarry85;
      END IF;
    END IF; 
  END PROCESS Carry_reg85_process;

  preaddbit86 <=  delayline_b2039 XOR delayline_b4103 XOR carrymux86;

  temp1_85 <=  delayline_b2039 AND delayline_b4103;

  temp2_85 <=  delayline_b4103 AND carrymux86;

  temp3_85 <=  delayline_b2039 AND carrymux86;

  addcarry86 <=  temp1_85 OR temp2_85 OR temp3_85;

  carrymux86 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg86;
  Carry_reg86_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg86 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg86 <= addcarry86;
      END IF;
    END IF; 
  END PROCESS Carry_reg86_process;

  preaddbit87 <=  delayline_b2063 XOR delayline_b4079 XOR carrymux87;

  temp1_86 <=  delayline_b2063 AND delayline_b4079;

  temp2_86 <=  delayline_b4079 AND carrymux87;

  temp3_86 <=  delayline_b2063 AND carrymux87;

  addcarry87 <=  temp1_86 OR temp2_86 OR temp3_86;

  carrymux87 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg87;
  Carry_reg87_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg87 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg87 <= addcarry87;
      END IF;
    END IF; 
  END PROCESS Carry_reg87_process;

  preaddbit88 <=  delayline_b2087 XOR delayline_b4055 XOR carrymux88;

  temp1_87 <=  delayline_b2087 AND delayline_b4055;

  temp2_87 <=  delayline_b4055 AND carrymux88;

  temp3_87 <=  delayline_b2087 AND carrymux88;

  addcarry88 <=  temp1_87 OR temp2_87 OR temp3_87;

  carrymux88 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg88;
  Carry_reg88_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg88 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg88 <= addcarry88;
      END IF;
    END IF; 
  END PROCESS Carry_reg88_process;

  preaddbit89 <=  delayline_b2111 XOR delayline_b4031 XOR carrymux89;

  temp1_88 <=  delayline_b2111 AND delayline_b4031;

  temp2_88 <=  delayline_b4031 AND carrymux89;

  temp3_88 <=  delayline_b2111 AND carrymux89;

  addcarry89 <=  temp1_88 OR temp2_88 OR temp3_88;

  carrymux89 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg89;
  Carry_reg89_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg89 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg89 <= addcarry89;
      END IF;
    END IF; 
  END PROCESS Carry_reg89_process;

  preaddbit90 <=  delayline_b2135 XOR delayline_b4007 XOR carrymux90;

  temp1_89 <=  delayline_b2135 AND delayline_b4007;

  temp2_89 <=  delayline_b4007 AND carrymux90;

  temp3_89 <=  delayline_b2135 AND carrymux90;

  addcarry90 <=  temp1_89 OR temp2_89 OR temp3_89;

  carrymux90 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg90;
  Carry_reg90_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg90 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg90 <= addcarry90;
      END IF;
    END IF; 
  END PROCESS Carry_reg90_process;

  preaddbit91 <=  delayline_b2159 XOR delayline_b3983 XOR carrymux91;

  temp1_90 <=  delayline_b2159 AND delayline_b3983;

  temp2_90 <=  delayline_b3983 AND carrymux91;

  temp3_90 <=  delayline_b2159 AND carrymux91;

  addcarry91 <=  temp1_90 OR temp2_90 OR temp3_90;

  carrymux91 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg91;
  Carry_reg91_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg91 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg91 <= addcarry91;
      END IF;
    END IF; 
  END PROCESS Carry_reg91_process;

  preaddbit92 <=  delayline_b2183 XOR delayline_b3959 XOR carrymux92;

  temp1_91 <=  delayline_b2183 AND delayline_b3959;

  temp2_91 <=  delayline_b3959 AND carrymux92;

  temp3_91 <=  delayline_b2183 AND carrymux92;

  addcarry92 <=  temp1_91 OR temp2_91 OR temp3_91;

  carrymux92 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg92;
  Carry_reg92_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg92 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg92 <= addcarry92;
      END IF;
    END IF; 
  END PROCESS Carry_reg92_process;

  preaddbit93 <=  delayline_b2207 XOR delayline_b3935 XOR carrymux93;

  temp1_92 <=  delayline_b2207 AND delayline_b3935;

  temp2_92 <=  delayline_b3935 AND carrymux93;

  temp3_92 <=  delayline_b2207 AND carrymux93;

  addcarry93 <=  temp1_92 OR temp2_92 OR temp3_92;

  carrymux93 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg93;
  Carry_reg93_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg93 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg93 <= addcarry93;
      END IF;
    END IF; 
  END PROCESS Carry_reg93_process;

  preaddbit94 <=  delayline_b2231 XOR delayline_b3911 XOR carrymux94;

  temp1_93 <=  delayline_b2231 AND delayline_b3911;

  temp2_93 <=  delayline_b3911 AND carrymux94;

  temp3_93 <=  delayline_b2231 AND carrymux94;

  addcarry94 <=  temp1_93 OR temp2_93 OR temp3_93;

  carrymux94 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg94;
  Carry_reg94_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg94 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg94 <= addcarry94;
      END IF;
    END IF; 
  END PROCESS Carry_reg94_process;

  preaddbit95 <=  delayline_b2255 XOR delayline_b3887 XOR carrymux95;

  temp1_94 <=  delayline_b2255 AND delayline_b3887;

  temp2_94 <=  delayline_b3887 AND carrymux95;

  temp3_94 <=  delayline_b2255 AND carrymux95;

  addcarry95 <=  temp1_94 OR temp2_94 OR temp3_94;

  carrymux95 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg95;
  Carry_reg95_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg95 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg95 <= addcarry95;
      END IF;
    END IF; 
  END PROCESS Carry_reg95_process;

  preaddbit96 <=  delayline_b2279 XOR delayline_b3863 XOR carrymux96;

  temp1_95 <=  delayline_b2279 AND delayline_b3863;

  temp2_95 <=  delayline_b3863 AND carrymux96;

  temp3_95 <=  delayline_b2279 AND carrymux96;

  addcarry96 <=  temp1_95 OR temp2_95 OR temp3_95;

  carrymux96 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg96;
  Carry_reg96_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg96 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg96 <= addcarry96;
      END IF;
    END IF; 
  END PROCESS Carry_reg96_process;

  preaddbit97 <=  delayline_b2303 XOR delayline_b3839 XOR carrymux97;

  temp1_96 <=  delayline_b2303 AND delayline_b3839;

  temp2_96 <=  delayline_b3839 AND carrymux97;

  temp3_96 <=  delayline_b2303 AND carrymux97;

  addcarry97 <=  temp1_96 OR temp2_96 OR temp3_96;

  carrymux97 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg97;
  Carry_reg97_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg97 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg97 <= addcarry97;
      END IF;
    END IF; 
  END PROCESS Carry_reg97_process;

  preaddbit98 <=  delayline_b2327 XOR delayline_b3815 XOR carrymux98;

  temp1_97 <=  delayline_b2327 AND delayline_b3815;

  temp2_97 <=  delayline_b3815 AND carrymux98;

  temp3_97 <=  delayline_b2327 AND carrymux98;

  addcarry98 <=  temp1_97 OR temp2_97 OR temp3_97;

  carrymux98 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg98;
  Carry_reg98_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg98 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg98 <= addcarry98;
      END IF;
    END IF; 
  END PROCESS Carry_reg98_process;

  preaddbit99 <=  delayline_b2351 XOR delayline_b3791 XOR carrymux99;

  temp1_98 <=  delayline_b2351 AND delayline_b3791;

  temp2_98 <=  delayline_b3791 AND carrymux99;

  temp3_98 <=  delayline_b2351 AND carrymux99;

  addcarry99 <=  temp1_98 OR temp2_98 OR temp3_98;

  carrymux99 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                carryreg99;
  Carry_reg99_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg99 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg99 <= addcarry99;
      END IF;
    END IF; 
  END PROCESS Carry_reg99_process;

  preaddbit100 <=  delayline_b2375 XOR delayline_b3767 XOR carrymux100;

  temp1_99 <=  delayline_b2375 AND delayline_b3767;

  temp2_99 <=  delayline_b3767 AND carrymux100;

  temp3_99 <=  delayline_b2375 AND carrymux100;

  addcarry100 <=  temp1_99 OR temp2_99 OR temp3_99;

  carrymux100 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                 carryreg100;
  Carry_reg100_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg100 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg100 <= addcarry100;
      END IF;
    END IF; 
  END PROCESS Carry_reg100_process;

  preaddbit101 <=  delayline_b2399 XOR delayline_b3743 XOR carrymux101;

  temp1_100 <=  delayline_b2399 AND delayline_b3743;

  temp2_100 <=  delayline_b3743 AND carrymux101;

  temp3_100 <=  delayline_b2399 AND carrymux101;

  addcarry101 <=  temp1_100 OR temp2_100 OR temp3_100;

  carrymux101 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                 carryreg101;
  Carry_reg101_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg101 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg101 <= addcarry101;
      END IF;
    END IF; 
  END PROCESS Carry_reg101_process;

  preaddbit102 <=  delayline_b2423 XOR delayline_b3719 XOR carrymux102;

  temp1_101 <=  delayline_b2423 AND delayline_b3719;

  temp2_101 <=  delayline_b3719 AND carrymux102;

  temp3_101 <=  delayline_b2423 AND carrymux102;

  addcarry102 <=  temp1_101 OR temp2_101 OR temp3_101;

  carrymux102 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                 carryreg102;
  Carry_reg102_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg102 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg102 <= addcarry102;
      END IF;
    END IF; 
  END PROCESS Carry_reg102_process;

  preaddbit103 <=  delayline_b2447 XOR delayline_b3695 XOR carrymux103;

  temp1_102 <=  delayline_b2447 AND delayline_b3695;

  temp2_102 <=  delayline_b3695 AND carrymux103;

  temp3_102 <=  delayline_b2447 AND carrymux103;

  addcarry103 <=  temp1_102 OR temp2_102 OR temp3_102;

  carrymux103 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                 carryreg103;
  Carry_reg103_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg103 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg103 <= addcarry103;
      END IF;
    END IF; 
  END PROCESS Carry_reg103_process;

  preaddbit104 <=  delayline_b2471 XOR delayline_b3671 XOR carrymux104;

  temp1_103 <=  delayline_b2471 AND delayline_b3671;

  temp2_103 <=  delayline_b3671 AND carrymux104;

  temp3_103 <=  delayline_b2471 AND carrymux104;

  addcarry104 <=  temp1_103 OR temp2_103 OR temp3_103;

  carrymux104 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                 carryreg104;
  Carry_reg104_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg104 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg104 <= addcarry104;
      END IF;
    END IF; 
  END PROCESS Carry_reg104_process;

  preaddbit105 <=  delayline_b2495 XOR delayline_b3647 XOR carrymux105;

  temp1_104 <=  delayline_b2495 AND delayline_b3647;

  temp2_104 <=  delayline_b3647 AND carrymux105;

  temp3_104 <=  delayline_b2495 AND carrymux105;

  addcarry105 <=  temp1_104 OR temp2_104 OR temp3_104;

  carrymux105 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                 carryreg105;
  Carry_reg105_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg105 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg105 <= addcarry105;
      END IF;
    END IF; 
  END PROCESS Carry_reg105_process;

  preaddbit106 <=  delayline_b2519 XOR delayline_b3623 XOR carrymux106;

  temp1_105 <=  delayline_b2519 AND delayline_b3623;

  temp2_105 <=  delayline_b3623 AND carrymux106;

  temp3_105 <=  delayline_b2519 AND carrymux106;

  addcarry106 <=  temp1_105 OR temp2_105 OR temp3_105;

  carrymux106 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                 carryreg106;
  Carry_reg106_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg106 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg106 <= addcarry106;
      END IF;
    END IF; 
  END PROCESS Carry_reg106_process;

  preaddbit107 <=  delayline_b2543 XOR delayline_b3599 XOR carrymux107;

  temp1_106 <=  delayline_b2543 AND delayline_b3599;

  temp2_106 <=  delayline_b3599 AND carrymux107;

  temp3_106 <=  delayline_b2543 AND carrymux107;

  addcarry107 <=  temp1_106 OR temp2_106 OR temp3_106;

  carrymux107 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                 carryreg107;
  Carry_reg107_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg107 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg107 <= addcarry107;
      END IF;
    END IF; 
  END PROCESS Carry_reg107_process;

  preaddbit108 <=  delayline_b2567 XOR delayline_b3575 XOR carrymux108;

  temp1_107 <=  delayline_b2567 AND delayline_b3575;

  temp2_107 <=  delayline_b3575 AND carrymux108;

  temp3_107 <=  delayline_b2567 AND carrymux108;

  addcarry108 <=  temp1_107 OR temp2_107 OR temp3_107;

  carrymux108 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                 carryreg108;
  Carry_reg108_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg108 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg108 <= addcarry108;
      END IF;
    END IF; 
  END PROCESS Carry_reg108_process;

  preaddbit109 <=  delayline_b2591 XOR delayline_b3551 XOR carrymux109;

  temp1_108 <=  delayline_b2591 AND delayline_b3551;

  temp2_108 <=  delayline_b3551 AND carrymux109;

  temp3_108 <=  delayline_b2591 AND carrymux109;

  addcarry109 <=  temp1_108 OR temp2_108 OR temp3_108;

  carrymux109 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                 carryreg109;
  Carry_reg109_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg109 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg109 <= addcarry109;
      END IF;
    END IF; 
  END PROCESS Carry_reg109_process;

  preaddbit110 <=  delayline_b2615 XOR delayline_b3527 XOR carrymux110;

  temp1_109 <=  delayline_b2615 AND delayline_b3527;

  temp2_109 <=  delayline_b3527 AND carrymux110;

  temp3_109 <=  delayline_b2615 AND carrymux110;

  addcarry110 <=  temp1_109 OR temp2_109 OR temp3_109;

  carrymux110 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                 carryreg110;
  Carry_reg110_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg110 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg110 <= addcarry110;
      END IF;
    END IF; 
  END PROCESS Carry_reg110_process;

  preaddbit111 <=  delayline_b2639 XOR delayline_b3503 XOR carrymux111;

  temp1_110 <=  delayline_b2639 AND delayline_b3503;

  temp2_110 <=  delayline_b3503 AND carrymux111;

  temp3_110 <=  delayline_b2639 AND carrymux111;

  addcarry111 <=  temp1_110 OR temp2_110 OR temp3_110;

  carrymux111 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                 carryreg111;
  Carry_reg111_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg111 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg111 <= addcarry111;
      END IF;
    END IF; 
  END PROCESS Carry_reg111_process;

  preaddbit112 <=  delayline_b2663 XOR delayline_b3479 XOR carrymux112;

  temp1_111 <=  delayline_b2663 AND delayline_b3479;

  temp2_111 <=  delayline_b3479 AND carrymux112;

  temp3_111 <=  delayline_b2663 AND carrymux112;

  addcarry112 <=  temp1_111 OR temp2_111 OR temp3_111;

  carrymux112 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                 carryreg112;
  Carry_reg112_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg112 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg112 <= addcarry112;
      END IF;
    END IF; 
  END PROCESS Carry_reg112_process;

  preaddbit113 <=  delayline_b2687 XOR delayline_b3455 XOR carrymux113;

  temp1_112 <=  delayline_b2687 AND delayline_b3455;

  temp2_112 <=  delayline_b3455 AND carrymux113;

  temp3_112 <=  delayline_b2687 AND carrymux113;

  addcarry113 <=  temp1_112 OR temp2_112 OR temp3_112;

  carrymux113 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                 carryreg113;
  Carry_reg113_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg113 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg113 <= addcarry113;
      END IF;
    END IF; 
  END PROCESS Carry_reg113_process;

  preaddbit114 <=  delayline_b2711 XOR delayline_b3431 XOR carrymux114;

  temp1_113 <=  delayline_b2711 AND delayline_b3431;

  temp2_113 <=  delayline_b3431 AND carrymux114;

  temp3_113 <=  delayline_b2711 AND carrymux114;

  addcarry114 <=  temp1_113 OR temp2_113 OR temp3_113;

  carrymux114 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                 carryreg114;
  Carry_reg114_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg114 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg114 <= addcarry114;
      END IF;
    END IF; 
  END PROCESS Carry_reg114_process;

  preaddbit115 <=  delayline_b2735 XOR delayline_b3407 XOR carrymux115;

  temp1_114 <=  delayline_b2735 AND delayline_b3407;

  temp2_114 <=  delayline_b3407 AND carrymux115;

  temp3_114 <=  delayline_b2735 AND carrymux115;

  addcarry115 <=  temp1_114 OR temp2_114 OR temp3_114;

  carrymux115 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                 carryreg115;
  Carry_reg115_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg115 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg115 <= addcarry115;
      END IF;
    END IF; 
  END PROCESS Carry_reg115_process;

  preaddbit116 <=  delayline_b2759 XOR delayline_b3383 XOR carrymux116;

  temp1_115 <=  delayline_b2759 AND delayline_b3383;

  temp2_115 <=  delayline_b3383 AND carrymux116;

  temp3_115 <=  delayline_b2759 AND carrymux116;

  addcarry116 <=  temp1_115 OR temp2_115 OR temp3_115;

  carrymux116 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                 carryreg116;
  Carry_reg116_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg116 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg116 <= addcarry116;
      END IF;
    END IF; 
  END PROCESS Carry_reg116_process;

  preaddbit117 <=  delayline_b2783 XOR delayline_b3359 XOR carrymux117;

  temp1_116 <=  delayline_b2783 AND delayline_b3359;

  temp2_116 <=  delayline_b3359 AND carrymux117;

  temp3_116 <=  delayline_b2783 AND carrymux117;

  addcarry117 <=  temp1_116 OR temp2_116 OR temp3_116;

  carrymux117 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                 carryreg117;
  Carry_reg117_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg117 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg117 <= addcarry117;
      END IF;
    END IF; 
  END PROCESS Carry_reg117_process;

  preaddbit118 <=  delayline_b2807 XOR delayline_b3335 XOR carrymux118;

  temp1_117 <=  delayline_b2807 AND delayline_b3335;

  temp2_117 <=  delayline_b3335 AND carrymux118;

  temp3_117 <=  delayline_b2807 AND carrymux118;

  addcarry118 <=  temp1_117 OR temp2_117 OR temp3_117;

  carrymux118 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                 carryreg118;
  Carry_reg118_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg118 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg118 <= addcarry118;
      END IF;
    END IF; 
  END PROCESS Carry_reg118_process;

  preaddbit119 <=  delayline_b2831 XOR delayline_b3311 XOR carrymux119;

  temp1_118 <=  delayline_b2831 AND delayline_b3311;

  temp2_118 <=  delayline_b3311 AND carrymux119;

  temp3_118 <=  delayline_b2831 AND carrymux119;

  addcarry119 <=  temp1_118 OR temp2_118 OR temp3_118;

  carrymux119 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                 carryreg119;
  Carry_reg119_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg119 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg119 <= addcarry119;
      END IF;
    END IF; 
  END PROCESS Carry_reg119_process;

  preaddbit120 <=  delayline_b2855 XOR delayline_b3287 XOR carrymux120;

  temp1_119 <=  delayline_b2855 AND delayline_b3287;

  temp2_119 <=  delayline_b3287 AND carrymux120;

  temp3_119 <=  delayline_b2855 AND carrymux120;

  addcarry120 <=  temp1_119 OR temp2_119 OR temp3_119;

  carrymux120 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                 carryreg120;
  Carry_reg120_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg120 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg120 <= addcarry120;
      END IF;
    END IF; 
  END PROCESS Carry_reg120_process;

  preaddbit121 <=  delayline_b2879 XOR delayline_b3263 XOR carrymux121;

  temp1_120 <=  delayline_b2879 AND delayline_b3263;

  temp2_120 <=  delayline_b3263 AND carrymux121;

  temp3_120 <=  delayline_b2879 AND carrymux121;

  addcarry121 <=  temp1_120 OR temp2_120 OR temp3_120;

  carrymux121 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                 carryreg121;
  Carry_reg121_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg121 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg121 <= addcarry121;
      END IF;
    END IF; 
  END PROCESS Carry_reg121_process;

  preaddbit122 <=  delayline_b2903 XOR delayline_b3239 XOR carrymux122;

  temp1_121 <=  delayline_b2903 AND delayline_b3239;

  temp2_121 <=  delayline_b3239 AND carrymux122;

  temp3_121 <=  delayline_b2903 AND carrymux122;

  addcarry122 <=  temp1_121 OR temp2_121 OR temp3_121;

  carrymux122 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                 carryreg122;
  Carry_reg122_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg122 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg122 <= addcarry122;
      END IF;
    END IF; 
  END PROCESS Carry_reg122_process;

  preaddbit123 <=  delayline_b2927 XOR delayline_b3215 XOR carrymux123;

  temp1_122 <=  delayline_b2927 AND delayline_b3215;

  temp2_122 <=  delayline_b3215 AND carrymux123;

  temp3_122 <=  delayline_b2927 AND carrymux123;

  addcarry123 <=  temp1_122 OR temp2_122 OR temp3_122;

  carrymux123 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                 carryreg123;
  Carry_reg123_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg123 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg123 <= addcarry123;
      END IF;
    END IF; 
  END PROCESS Carry_reg123_process;

  preaddbit124 <=  delayline_b2951 XOR delayline_b3191 XOR carrymux124;

  temp1_123 <=  delayline_b2951 AND delayline_b3191;

  temp2_123 <=  delayline_b3191 AND carrymux124;

  temp3_123 <=  delayline_b2951 AND carrymux124;

  addcarry124 <=  temp1_123 OR temp2_123 OR temp3_123;

  carrymux124 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                 carryreg124;
  Carry_reg124_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg124 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg124 <= addcarry124;
      END IF;
    END IF; 
  END PROCESS Carry_reg124_process;

  preaddbit125 <=  delayline_b2975 XOR delayline_b3167 XOR carrymux125;

  temp1_124 <=  delayline_b2975 AND delayline_b3167;

  temp2_124 <=  delayline_b3167 AND carrymux125;

  temp3_124 <=  delayline_b2975 AND carrymux125;

  addcarry125 <=  temp1_124 OR temp2_124 OR temp3_124;

  carrymux125 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                 carryreg125;
  Carry_reg125_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg125 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg125 <= addcarry125;
      END IF;
    END IF; 
  END PROCESS Carry_reg125_process;

  preaddbit126 <=  delayline_b2999 XOR delayline_b3143 XOR carrymux126;

  temp1_125 <=  delayline_b2999 AND delayline_b3143;

  temp2_125 <=  delayline_b3143 AND carrymux126;

  temp3_125 <=  delayline_b2999 AND carrymux126;

  addcarry126 <=  temp1_125 OR temp2_125 OR temp3_125;

  carrymux126 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                 carryreg126;
  Carry_reg126_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg126 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg126 <= addcarry126;
      END IF;
    END IF; 
  END PROCESS Carry_reg126_process;

  preaddbit127 <=  delayline_b3023 XOR delayline_b3119 XOR carrymux127;

  temp1_126 <=  delayline_b3023 AND delayline_b3119;

  temp2_126 <=  delayline_b3119 AND carrymux127;

  temp3_126 <=  delayline_b3023 AND carrymux127;

  addcarry127 <=  temp1_126 OR temp2_126 OR temp3_126;

  carrymux127 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                 carryreg127;
  Carry_reg127_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg127 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg127 <= addcarry127;
      END IF;
    END IF; 
  END PROCESS Carry_reg127_process;

  preaddbit128 <=  delayline_b3047 XOR delayline_b3095 XOR carrymux128;

  temp1_127 <=  delayline_b3047 AND delayline_b3095;

  temp2_127 <=  delayline_b3095 AND carrymux128;

  temp3_127 <=  delayline_b3047 AND carrymux128;

  addcarry128 <=  temp1_127 OR temp2_127 OR temp3_127;

  carrymux128 <= const_zero WHEN ( phase_0 = '1' ) ELSE
                 carryreg128;
  Carry_reg128_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      carryreg128 <= '0';
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        carryreg128 <= addcarry128;
      END IF;
    END IF; 
  END PROCESS Carry_reg128_process;

  mem_addr_1 <= preaddbit2 & preaddbit1;

  PROCESS(mem_addr_1)
  BEGIN
    CASE mem_addr_1 IS
      WHEN "00" => memoutb1_1 <= "0000000000000";
      WHEN "01" => memoutb1_1 <= "1100101111001";
      WHEN "10" => memoutb1_1 <= "1100011011101";
      WHEN "11" => memoutb1_1 <= "1001001010110";
      WHEN OTHERS => memoutb1_1 <= "1001001010110";
    END CASE;
  END PROCESS;

  mem_addr_2 <= preaddbit4 & preaddbit3;

  PROCESS(mem_addr_2)
  BEGIN
    CASE mem_addr_2 IS
      WHEN "00" => memoutb1_2 <= "0000000000000";
      WHEN "01" => memoutb1_2 <= "1100001011101";
      WHEN "10" => memoutb1_2 <= "1011111111110";
      WHEN "11" => memoutb1_2 <= "1000001011011";
      WHEN OTHERS => memoutb1_2 <= "1000001011011";
    END CASE;
  END PROCESS;

  mem_addr_3 <= preaddbit6 & preaddbit5;

  PROCESS(mem_addr_3)
  BEGIN
    CASE mem_addr_3 IS
      WHEN "00" => memoutb1_3 <= "00000000000000";
      WHEN "01" => memoutb1_3 <= "11011111000011";
      WHEN "10" => memoutb1_3 <= "11011110101110";
      WHEN "11" => memoutb1_3 <= "10111101110001";
      WHEN OTHERS => memoutb1_3 <= "10111101110001";
    END CASE;
  END PROCESS;

  mem_addr_4 <= preaddbit8 & preaddbit7;

  PROCESS(mem_addr_4)
  BEGIN
    CASE mem_addr_4 IS
      WHEN "00" => memoutb1_4 <= "00000000000000";
      WHEN "01" => memoutb1_4 <= "11011111000000";
      WHEN "10" => memoutb1_4 <= "11011111111001";
      WHEN "11" => memoutb1_4 <= "10111110111001";
      WHEN OTHERS => memoutb1_4 <= "10111110111001";
    END CASE;
  END PROCESS;

  mem_addr_5 <= preaddbit10 & preaddbit9;

  PROCESS(mem_addr_5)
  BEGIN
    CASE mem_addr_5 IS
      WHEN "00" => memoutb1_5 <= "0000000000000";
      WHEN "01" => memoutb1_5 <= "1100001010110";
      WHEN "10" => memoutb1_5 <= "1100011010101";
      WHEN "11" => memoutb1_5 <= "1000100101011";
      WHEN OTHERS => memoutb1_5 <= "1000100101011";
    END CASE;
  END PROCESS;

  mem_addr_6 <= preaddbit12 & preaddbit11;

  PROCESS(mem_addr_6)
  BEGIN
    CASE mem_addr_6 IS
      WHEN "00" => memoutb1_6 <= "0000000000000";
      WHEN "01" => memoutb1_6 <= "1100101110000";
      WHEN "10" => memoutb1_6 <= "1101000100001";
      WHEN "11" => memoutb1_6 <= "1001110010001";
      WHEN OTHERS => memoutb1_6 <= "1001110010001";
    END CASE;
  END PROCESS;

  mem_addr_7 <= preaddbit14 & preaddbit13;

  PROCESS(mem_addr_7)
  BEGIN
    CASE mem_addr_7 IS
      WHEN "00" => memoutb1_7 <= "0000000000000";
      WHEN "01" => memoutb1_7 <= "1101011100011";
      WHEN "10" => memoutb1_7 <= "1101110101101";
      WHEN "11" => memoutb1_7 <= "1011010010000";
      WHEN OTHERS => memoutb1_7 <= "1011010010000";
    END CASE;
  END PROCESS;

  mem_addr_8 <= preaddbit16 & preaddbit15;

  PROCESS(mem_addr_8)
  BEGIN
    CASE mem_addr_8 IS
      WHEN "00" => memoutb1_8 <= "000000000000";
      WHEN "01" => memoutb1_8 <= "110001110111";
      WHEN "10" => memoutb1_8 <= "110100111001";
      WHEN "11" => memoutb1_8 <= "100110110000";
      WHEN OTHERS => memoutb1_8 <= "100110110000";
    END CASE;
  END PROCESS;

  mem_addr_9 <= preaddbit18 & preaddbit17;

  PROCESS(mem_addr_9)
  BEGIN
    CASE mem_addr_9 IS
      WHEN "00" => memoutb1_9 <= "00000000000";
      WHEN "01" => memoutb1_9 <= "10111101100";
      WHEN "10" => memoutb1_9 <= "11010000110";
      WHEN "11" => memoutb1_9 <= "10001110010";
      WHEN OTHERS => memoutb1_9 <= "10001110010";
    END CASE;
  END PROCESS;

  mem_addr_10 <= preaddbit20 & preaddbit19;

  PROCESS(mem_addr_10)
  BEGIN
    CASE mem_addr_10 IS
      WHEN "00" => memoutb1_10 <= "0000000000";
      WHEN "01" => memoutb1_10 <= "1100000001";
      WHEN "10" => memoutb1_10 <= "1101010111";
      WHEN "11" => memoutb1_10 <= "1001011000";
      WHEN OTHERS => memoutb1_10 <= "1001011000";
    END CASE;
  END PROCESS;

  mem_addr_11 <= preaddbit22 & preaddbit21;

  PROCESS(mem_addr_11)
  BEGIN
    CASE mem_addr_11 IS
      WHEN "00" => memoutb1_11 <= "000000000";
      WHEN "01" => memoutb1_11 <= "110000011";
      WHEN "10" => memoutb1_11 <= "110000001";
      WHEN "11" => memoutb1_11 <= "100000100";
      WHEN OTHERS => memoutb1_11 <= "100000100";
    END CASE;
  END PROCESS;

  mem_addr_12 <= preaddbit24 & preaddbit23;

  PROCESS(mem_addr_12)
  BEGIN
    CASE mem_addr_12 IS
      WHEN "00" => memoutb1_12 <= "0000000000";
      WHEN "01" => memoutb1_12 <= "1101010000";
      WHEN "10" => memoutb1_12 <= "1011101111";
      WHEN "11" => memoutb1_12 <= "1000111111";
      WHEN OTHERS => memoutb1_12 <= "1000111111";
    END CASE;
  END PROCESS;

  mem_addr_13 <= preaddbit26 & preaddbit25;

  PROCESS(mem_addr_13)
  BEGIN
    CASE mem_addr_13 IS
      WHEN "00" => memoutb1_13 <= "00000000000";
      WHEN "01" => memoutb1_13 <= "11001100000";
      WHEN "10" => memoutb1_13 <= "10110100101";
      WHEN "11" => memoutb1_13 <= "10000000101";
      WHEN OTHERS => memoutb1_13 <= "10000000101";
    END CASE;
  END PROCESS;

  mem_addr_14 <= preaddbit28 & preaddbit27;

  PROCESS(mem_addr_14)
  BEGIN
    CASE mem_addr_14 IS
      WHEN "00" => memoutb1_14 <= "000000000000";
      WHEN "01" => memoutb1_14 <= "110011000100";
      WHEN "10" => memoutb1_14 <= "101111000011";
      WHEN "11" => memoutb1_14 <= "100010000111";
      WHEN OTHERS => memoutb1_14 <= "100010000111";
    END CASE;
  END PROCESS;

  mem_addr_15 <= preaddbit30 & preaddbit29;

  PROCESS(mem_addr_15)
  BEGIN
    CASE mem_addr_15 IS
      WHEN "00" => memoutb1_15 <= "0000000000000";
      WHEN "01" => memoutb1_15 <= "1101010101010";
      WHEN "10" => memoutb1_15 <= "1100110000001";
      WHEN "11" => memoutb1_15 <= "1010000101011";
      WHEN OTHERS => memoutb1_15 <= "1010000101011";
    END CASE;
  END PROCESS;

  mem_addr_16 <= preaddbit32 & preaddbit31;

  PROCESS(mem_addr_16)
  BEGIN
    CASE mem_addr_16 IS
      WHEN "00" => memoutb1_16 <= "00000000000000";
      WHEN "01" => memoutb1_16 <= "11100001010010";
      WHEN "10" => memoutb1_16 <= "11011100100111";
      WHEN "11" => memoutb1_16 <= "10111101111001";
      WHEN OTHERS => memoutb1_16 <= "10111101111001";
    END CASE;
  END PROCESS;

  mem_addr_17 <= preaddbit34 & preaddbit33;

  PROCESS(mem_addr_17)
  BEGIN
    CASE mem_addr_17 IS
      WHEN "00" => memoutb1_17 <= "00000000000000";
      WHEN "01" => memoutb1_17 <= "11011000001011";
      WHEN "10" => memoutb1_17 <= "11010100000111";
      WHEN "11" => memoutb1_17 <= "10101100010010";
      WHEN OTHERS => memoutb1_17 <= "10101100010010";
    END CASE;
  END PROCESS;

  mem_addr_18 <= preaddbit36 & preaddbit35;

  PROCESS(mem_addr_18)
  BEGIN
    CASE mem_addr_18 IS
      WHEN "00" => memoutb1_18 <= "00000000000000";
      WHEN "01" => memoutb1_18 <= "11010000100100";
      WHEN "10" => memoutb1_18 <= "11001101101100";
      WHEN "11" => memoutb1_18 <= "10011110010000";
      WHEN OTHERS => memoutb1_18 <= "10011110010000";
    END CASE;
  END PROCESS;

  mem_addr_19 <= preaddbit38 & preaddbit37;

  PROCESS(mem_addr_19)
  BEGIN
    CASE mem_addr_19 IS
      WHEN "00" => memoutb1_19 <= "00000000000000";
      WHEN "01" => memoutb1_19 <= "11001011100100";
      WHEN "10" => memoutb1_19 <= "11001010010011";
      WHEN "11" => memoutb1_19 <= "10010101110111";
      WHEN OTHERS => memoutb1_19 <= "10010101110111";
    END CASE;
  END PROCESS;

  mem_addr_20 <= preaddbit40 & preaddbit39;

  PROCESS(mem_addr_20)
  BEGIN
    CASE mem_addr_20 IS
      WHEN "00" => memoutb1_20 <= "00000000000000";
      WHEN "01" => memoutb1_20 <= "11001001111100";
      WHEN "10" => memoutb1_20 <= "11001010100000";
      WHEN "11" => memoutb1_20 <= "10010100011100";
      WHEN OTHERS => memoutb1_20 <= "10010100011100";
    END CASE;
  END PROCESS;

  mem_addr_21 <= preaddbit42 & preaddbit41;

  PROCESS(mem_addr_21)
  BEGIN
    CASE mem_addr_21 IS
      WHEN "00" => memoutb1_21 <= "00000000000000";
      WHEN "01" => memoutb1_21 <= "11001100000000";
      WHEN "10" => memoutb1_21 <= "11001110011000";
      WHEN "11" => memoutb1_21 <= "10011010011000";
      WHEN OTHERS => memoutb1_21 <= "10011010011000";
    END CASE;
  END PROCESS;

  mem_addr_22 <= preaddbit44 & preaddbit43;

  PROCESS(mem_addr_22)
  BEGIN
    CASE mem_addr_22 IS
      WHEN "00" => memoutb1_22 <= "00000000000000";
      WHEN "01" => memoutb1_22 <= "11010001100101";
      WHEN "10" => memoutb1_22 <= "11010101011110";
      WHEN "11" => memoutb1_22 <= "10100111000011";
      WHEN OTHERS => memoutb1_22 <= "10100111000011";
    END CASE;
  END PROCESS;

  mem_addr_23 <= preaddbit46 & preaddbit45;

  PROCESS(mem_addr_23)
  BEGIN
    CASE mem_addr_23 IS
      WHEN "00" => memoutb1_23 <= "00000000000000";
      WHEN "01" => memoutb1_23 <= "11011001111100";
      WHEN "10" => memoutb1_23 <= "11011110110100";
      WHEN "11" => memoutb1_23 <= "10111000110000";
      WHEN OTHERS => memoutb1_23 <= "10111000110000";
    END CASE;
  END PROCESS;

  mem_addr_24 <= preaddbit48 & preaddbit47;

  PROCESS(mem_addr_24)
  BEGIN
    CASE mem_addr_24 IS
      WHEN "00" => memoutb1_24 <= "0000000000000";
      WHEN "01" => memoutb1_24 <= "1100011111011";
      WHEN "10" => memoutb1_24 <= "1101001000101";
      WHEN "11" => memoutb1_24 <= "1001101000000";
      WHEN OTHERS => memoutb1_24 <= "1001101000000";
    END CASE;
  END PROCESS;

  mem_addr_25 <= preaddbit50 & preaddbit49;

  PROCESS(mem_addr_25)
  BEGIN
    CASE mem_addr_25 IS
      WHEN "00" => memoutb1_25 <= "000000000000";
      WHEN "01" => memoutb1_25 <= "101110000101";
      WHEN "10" => memoutb1_25 <= "110010101101";
      WHEN "11" => memoutb1_25 <= "100000110010";
      WHEN OTHERS => memoutb1_25 <= "100000110010";
    END CASE;
  END PROCESS;

  mem_addr_26 <= preaddbit52 & preaddbit51;

  PROCESS(mem_addr_26)
  BEGIN
    CASE mem_addr_26 IS
      WHEN "00" => memoutb1_26 <= "00000000000";
      WHEN "01" => memoutb1_26 <= "10110110011";
      WHEN "10" => memoutb1_26 <= "11010001011";
      WHEN "11" => memoutb1_26 <= "10000111110";
      WHEN OTHERS => memoutb1_26 <= "10000111110";
    END CASE;
  END PROCESS;

  mem_addr_27 <= preaddbit54 & preaddbit53;

  PROCESS(mem_addr_27)
  BEGIN
    CASE mem_addr_27 IS
      WHEN "00" => memoutb1_27 <= "0000000000";
      WHEN "01" => memoutb1_27 <= "1100101001";
      WHEN "10" => memoutb1_27 <= "1110000111";
      WHEN "11" => memoutb1_27 <= "1010110000";
      WHEN OTHERS => memoutb1_27 <= "1010110000";
    END CASE;
  END PROCESS;

  mem_addr_28 <= preaddbit56 & preaddbit55;

  PROCESS(mem_addr_28)
  BEGIN
    CASE mem_addr_28 IS
      WHEN "00" => memoutb1_28 <= "000000000";
      WHEN "01" => memoutb1_28 <= "110011110";
      WHEN "10" => memoutb1_28 <= "101101010";
      WHEN "11" => memoutb1_28 <= "100001000";
      WHEN OTHERS => memoutb1_28 <= "100001000";
    END CASE;
  END PROCESS;

  mem_addr_29 <= preaddbit58 & preaddbit57;

  PROCESS(mem_addr_29)
  BEGIN
    CASE mem_addr_29 IS
      WHEN "00" => memoutb1_29 <= "00000000000";
      WHEN "01" => memoutb1_29 <= "11011101010";
      WHEN "10" => memoutb1_29 <= "11000100000";
      WHEN "11" => memoutb1_29 <= "10100001010";
      WHEN OTHERS => memoutb1_29 <= "10100001010";
    END CASE;
  END PROCESS;

  mem_addr_30 <= preaddbit60 & preaddbit59;

  PROCESS(mem_addr_30)
  BEGIN
    CASE mem_addr_30 IS
      WHEN "00" => memoutb1_30 <= "000000000000";
      WHEN "01" => memoutb1_30 <= "110100001111";
      WHEN "10" => memoutb1_30 <= "101110111110";
      WHEN "11" => memoutb1_30 <= "100011001101";
      WHEN OTHERS => memoutb1_30 <= "100011001101";
    END CASE;
  END PROCESS;

  mem_addr_31 <= preaddbit62 & preaddbit61;

  PROCESS(mem_addr_31)
  BEGIN
    CASE mem_addr_31 IS
      WHEN "00" => memoutb1_31 <= "0000000000000";
      WHEN "01" => memoutb1_31 <= "1101000111000";
      WHEN "10" => memoutb1_31 <= "1100010000110";
      WHEN "11" => memoutb1_31 <= "1001010111110";
      WHEN OTHERS => memoutb1_31 <= "1001010111110";
    END CASE;
  END PROCESS;

  mem_addr_32 <= preaddbit64 & preaddbit63;

  PROCESS(mem_addr_32)
  BEGIN
    CASE mem_addr_32 IS
      WHEN "00" => memoutb1_32 <= "00000000000000";
      WHEN "01" => memoutb1_32 <= "11011010111001";
      WHEN "10" => memoutb1_32 <= "11010011011101";
      WHEN "11" => memoutb1_32 <= "10101110010110";
      WHEN OTHERS => memoutb1_32 <= "10101110010110";
    END CASE;
  END PROCESS;

  mem_addr_33 <= preaddbit66 & preaddbit65;

  PROCESS(mem_addr_33)
  BEGIN
    CASE mem_addr_33 IS
      WHEN "00" => memoutb1_33 <= "00000000000000";
      WHEN "01" => memoutb1_33 <= "11001100000100";
      WHEN "10" => memoutb1_33 <= "11000100111110";
      WHEN "11" => memoutb1_33 <= "10010001000010";
      WHEN OTHERS => memoutb1_33 <= "10010001000010";
    END CASE;
  END PROCESS;

  mem_addr_34 <= preaddbit68 & preaddbit67;

  PROCESS(mem_addr_34)
  BEGIN
    CASE mem_addr_34 IS
      WHEN "00" => memoutb1_34 <= "000000000000000";
      WHEN "01" => memoutb1_34 <= "110111110011011";
      WHEN "10" => memoutb1_34 <= "110111000101100";
      WHEN "11" => memoutb1_34 <= "101110111000111";
      WHEN OTHERS => memoutb1_34 <= "101110111000111";
    END CASE;
  END PROCESS;

  mem_addr_35 <= preaddbit70 & preaddbit69;

  PROCESS(mem_addr_35)
  BEGIN
    CASE mem_addr_35 IS
      WHEN "00" => memoutb1_35 <= "000000000000000";
      WHEN "01" => memoutb1_35 <= "110110011111111";
      WHEN "10" => memoutb1_35 <= "110110000100001";
      WHEN "11" => memoutb1_35 <= "101100100100000";
      WHEN OTHERS => memoutb1_35 <= "101100100100000";
    END CASE;
  END PROCESS;

  mem_addr_36 <= preaddbit72 & preaddbit71;

  PROCESS(mem_addr_36)
  BEGIN
    CASE mem_addr_36 IS
      WHEN "00" => memoutb1_36 <= "000000000000000";
      WHEN "01" => memoutb1_36 <= "110101110011011";
      WHEN "10" => memoutb1_36 <= "110101101110111";
      WHEN "11" => memoutb1_36 <= "101011100010010";
      WHEN OTHERS => memoutb1_36 <= "101011100010010";
    END CASE;
  END PROCESS;

  mem_addr_37 <= preaddbit74 & preaddbit73;

  PROCESS(mem_addr_37)
  BEGIN
    CASE mem_addr_37 IS
      WHEN "00" => memoutb1_37 <= "000000000000000";
      WHEN "01" => memoutb1_37 <= "110101110110111";
      WHEN "10" => memoutb1_37 <= "110110001011110";
      WHEN "11" => memoutb1_37 <= "101100000010101";
      WHEN OTHERS => memoutb1_37 <= "101100000010101";
    END CASE;
  END PROCESS;

  mem_addr_38 <= preaddbit76 & preaddbit75;

  PROCESS(mem_addr_38)
  BEGIN
    CASE mem_addr_38 IS
      WHEN "00" => memoutb1_38 <= "000000000000000";
      WHEN "01" => memoutb1_38 <= "110110101101001";
      WHEN "10" => memoutb1_38 <= "110111011010001";
      WHEN "11" => memoutb1_38 <= "101110000111010";
      WHEN OTHERS => memoutb1_38 <= "101110000111010";
    END CASE;
  END PROCESS;

  mem_addr_39 <= preaddbit78 & preaddbit77;

  PROCESS(mem_addr_39)
  BEGIN
    CASE mem_addr_39 IS
      WHEN "00" => memoutb1_39 <= "00000000000000";
      WHEN "01" => memoutb1_39 <= "11000010001100";
      WHEN "10" => memoutb1_39 <= "11001010001110";
      WHEN "11" => memoutb1_39 <= "10001100011010";
      WHEN OTHERS => memoutb1_39 <= "10001100011010";
    END CASE;
  END PROCESS;

  mem_addr_40 <= preaddbit80 & preaddbit79;

  PROCESS(mem_addr_40)
  BEGIN
    CASE mem_addr_40 IS
      WHEN "00" => memoutb1_40 <= "00000000000000";
      WHEN "01" => memoutb1_40 <= "11010011000111";
      WHEN "10" => memoutb1_40 <= "11011100100011";
      WHEN "11" => memoutb1_40 <= "10101111101010";
      WHEN OTHERS => memoutb1_40 <= "10101111101010";
    END CASE;
  END PROCESS;

  mem_addr_41 <= preaddbit82 & preaddbit81;

  PROCESS(mem_addr_41)
  BEGIN
    CASE mem_addr_41 IS
      WHEN "00" => memoutb1_41 <= "0000000000000";
      WHEN "01" => memoutb1_41 <= "1100110001101";
      WHEN "10" => memoutb1_41 <= "1101111110001";
      WHEN "11" => memoutb1_41 <= "1010101111110";
      WHEN OTHERS => memoutb1_41 <= "1010101111110";
    END CASE;
  END PROCESS;

  mem_addr_42 <= preaddbit84 & preaddbit83;

  PROCESS(mem_addr_42)
  BEGIN
    CASE mem_addr_42 IS
      WHEN "00" => memoutb1_42 <= "0000000000";
      WHEN "01" => memoutb1_42 <= "1000110110";
      WHEN "10" => memoutb1_42 <= "0001000101";
      WHEN "11" => memoutb1_42 <= "1001111011";
      WHEN OTHERS => memoutb1_42 <= "1001111011";
    END CASE;
  END PROCESS;

  mem_addr_43 <= preaddbit86 & preaddbit85;

  PROCESS(mem_addr_43)
  BEGIN
    CASE mem_addr_43 IS
      WHEN "00" => memoutb1_43 <= "000000000000";
      WHEN "01" => memoutb1_43 <= "001000001001";
      WHEN "10" => memoutb1_43 <= "001101101101";
      WHEN "11" => memoutb1_43 <= "010101110110";
      WHEN OTHERS => memoutb1_43 <= "010101110110";
    END CASE;
  END PROCESS;

  mem_addr_44 <= preaddbit88 & preaddbit87;

  PROCESS(mem_addr_44)
  BEGIN
    CASE mem_addr_44 IS
      WHEN "00" => memoutb1_44 <= "0000000000000";
      WHEN "01" => memoutb1_44 <= "0010001011111";
      WHEN "10" => memoutb1_44 <= "0010011010000";
      WHEN "11" => memoutb1_44 <= "0100100101111";
      WHEN OTHERS => memoutb1_44 <= "0100100101111";
    END CASE;
  END PROCESS;

  mem_addr_45 <= preaddbit90 & preaddbit89;

  PROCESS(mem_addr_45)
  BEGIN
    CASE mem_addr_45 IS
      WHEN "00" => memoutb1_45 <= "0000000000000";
      WHEN "01" => memoutb1_45 <= "0010010110101";
      WHEN "10" => memoutb1_45 <= "0010000000110";
      WHEN "11" => memoutb1_45 <= "0100010111011";
      WHEN OTHERS => memoutb1_45 <= "0100010111011";
    END CASE;
  END PROCESS;

  mem_addr_46 <= preaddbit92 & preaddbit91;

  PROCESS(mem_addr_46)
  BEGIN
    CASE mem_addr_46 IS
      WHEN "00" => memoutb1_46 <= "00000000000";
      WHEN "01" => memoutb1_46 <= "01011000010";
      WHEN "10" => memoutb1_46 <= "00011101100";
      WHEN "11" => memoutb1_46 <= "01110101110";
      WHEN OTHERS => memoutb1_46 <= "01110101110";
    END CASE;
  END PROCESS;

  mem_addr_47 <= preaddbit94 & preaddbit93;

  PROCESS(mem_addr_47)
  BEGIN
    CASE mem_addr_47 IS
      WHEN "00" => memoutb1_47 <= "000000000000";
      WHEN "01" => memoutb1_47 <= "111010001011";
      WHEN "10" => memoutb1_47 <= "101110101101";
      WHEN "11" => memoutb1_47 <= "101000111000";
      WHEN OTHERS => memoutb1_47 <= "101000111000";
    END CASE;
  END PROCESS;

  mem_addr_48 <= preaddbit96 & preaddbit95;

  PROCESS(mem_addr_48)
  BEGIN
    CASE mem_addr_48 IS
      WHEN "00" => memoutb1_48 <= "00000000000000";
      WHEN "01" => memoutb1_48 <= "11100001100100";
      WHEN "10" => memoutb1_48 <= "11010011000110";
      WHEN "11" => memoutb1_48 <= "10110100101010";
      WHEN OTHERS => memoutb1_48 <= "10110100101010";
    END CASE;
  END PROCESS;

  mem_addr_49 <= preaddbit98 & preaddbit97;

  PROCESS(mem_addr_49)
  BEGIN
    CASE mem_addr_49 IS
      WHEN "00" => memoutb1_49 <= "000000000000000";
      WHEN "01" => memoutb1_49 <= "111000011110000";
      WHEN "10" => memoutb1_49 <= "110110011111111";
      WHEN "11" => memoutb1_49 <= "101110111101111";
      WHEN OTHERS => memoutb1_49 <= "101110111101111";
    END CASE;
  END PROCESS;

  mem_addr_50 <= preaddbit100 & preaddbit99;

  PROCESS(mem_addr_50)
  BEGIN
    CASE mem_addr_50 IS
      WHEN "00" => memoutb1_50 <= "000000000000000";
      WHEN "01" => memoutb1_50 <= "110100100010101";
      WHEN "10" => memoutb1_50 <= "110010101010110";
      WHEN "11" => memoutb1_50 <= "100111001101011";
      WHEN OTHERS => memoutb1_50 <= "100111001101011";
    END CASE;
  END PROCESS;

  mem_addr_51 <= preaddbit102 & preaddbit101;

  PROCESS(mem_addr_51)
  BEGIN
    CASE mem_addr_51 IS
      WHEN "00" => memoutb1_51 <= "000000000000000";
      WHEN "01" => memoutb1_51 <= "110000111100110";
      WHEN "10" => memoutb1_51 <= "101111011101001";
      WHEN "11" => memoutb1_51 <= "100000011001111";
      WHEN OTHERS => memoutb1_51 <= "100000011001111";
    END CASE;
  END PROCESS;

  mem_addr_52 <= preaddbit104 & preaddbit103;

  PROCESS(mem_addr_52)
  BEGIN
    CASE mem_addr_52 IS
      WHEN "00" => memoutb1_52 <= "0000000000000000";
      WHEN "01" => memoutb1_52 <= "1101110010000010";
      WHEN "10" => memoutb1_52 <= "1101101011010011";
      WHEN "11" => memoutb1_52 <= "1011011101010101";
      WHEN OTHERS => memoutb1_52 <= "1011011101010101";
    END CASE;
  END PROCESS;

  mem_addr_53 <= preaddbit106 & preaddbit105;

  PROCESS(mem_addr_53)
  BEGIN
    CASE mem_addr_53 IS
      WHEN "00" => memoutb1_53 <= "0000000000000000";
      WHEN "01" => memoutb1_53 <= "1101100111111010";
      WHEN "10" => memoutb1_53 <= "1101101000010000";
      WHEN "11" => memoutb1_53 <= "1011010000001010";
      WHEN OTHERS => memoutb1_53 <= "1011010000001010";
    END CASE;
  END PROCESS;

  mem_addr_54 <= preaddbit108 & preaddbit107;

  PROCESS(mem_addr_54)
  BEGIN
    CASE mem_addr_54 IS
      WHEN "00" => memoutb1_54 <= "0000000000000000";
      WHEN "01" => memoutb1_54 <= "1101101100101001";
      WHEN "10" => memoutb1_54 <= "1101110101010101";
      WHEN "11" => memoutb1_54 <= "1011100001111110";
      WHEN OTHERS => memoutb1_54 <= "1011100001111110";
    END CASE;
  END PROCESS;

  mem_addr_55 <= preaddbit110 & preaddbit109;

  PROCESS(mem_addr_55)
  BEGIN
    CASE mem_addr_55 IS
      WHEN "00" => memoutb1_55 <= "000000000000000";
      WHEN "01" => memoutb1_55 <= "110000010011100";
      WHEN "10" => memoutb1_55 <= "110010011111111";
      WHEN "11" => memoutb1_55 <= "100010110011011";
      WHEN OTHERS => memoutb1_55 <= "100010110011011";
    END CASE;
  END PROCESS;

  mem_addr_56 <= preaddbit112 & preaddbit111;

  PROCESS(mem_addr_56)
  BEGIN
    CASE mem_addr_56 IS
      WHEN "00" => memoutb1_56 <= "000000000000000";
      WHEN "01" => memoutb1_56 <= "110101001111000";
      WHEN "10" => memoutb1_56 <= "111000011111011";
      WHEN "11" => memoutb1_56 <= "101101101110011";
      WHEN OTHERS => memoutb1_56 <= "101101101110011";
    END CASE;
  END PROCESS;

  mem_addr_57 <= preaddbit114 & preaddbit113;

  PROCESS(mem_addr_57)
  BEGIN
    CASE mem_addr_57 IS
      WHEN "00" => memoutb1_57 <= "000000000000";
      WHEN "01" => memoutb1_57 <= "100001110011";
      WHEN "10" => memoutb1_57 <= "000011000101";
      WHEN "11" => memoutb1_57 <= "100100111000";
      WHEN OTHERS => memoutb1_57 <= "100100111000";
    END CASE;
  END PROCESS;

  mem_addr_58 <= preaddbit116 & preaddbit115;

  PROCESS(mem_addr_58)
  BEGIN
    CASE mem_addr_58 IS
      WHEN "00" => memoutb1_58 <= "00000000000000";
      WHEN "01" => memoutb1_58 <= "00100111001111";
      WHEN "10" => memoutb1_58 <= "01001101101100";
      WHEN "11" => memoutb1_58 <= "01110100111011";
      WHEN OTHERS => memoutb1_58 <= "01110100111011";
    END CASE;
  END PROCESS;

  mem_addr_59 <= preaddbit118 & preaddbit117;

  PROCESS(mem_addr_59)
  BEGIN
    CASE mem_addr_59 IS
      WHEN "00" => memoutb1_59 <= "0000000000000000";
      WHEN "01" => memoutb1_59 <= "0001110101101110";
      WHEN "10" => memoutb1_59 <= "0010011110100111";
      WHEN "11" => memoutb1_59 <= "0100010100010101";
      WHEN OTHERS => memoutb1_59 <= "0100010100010101";
    END CASE;
  END PROCESS;

  mem_addr_60 <= preaddbit120 & preaddbit119;

  PROCESS(mem_addr_60)
  BEGIN
    CASE mem_addr_60 IS
      WHEN "00" => memoutb1_60 <= "0000000000000000";
      WHEN "01" => memoutb1_60 <= "0011000111100100";
      WHEN "10" => memoutb1_60 <= "0011101111110001";
      WHEN "11" => memoutb1_60 <= "0110110111010101";
      WHEN OTHERS => memoutb1_60 <= "0110110111010101";
    END CASE;
  END PROCESS;

  mem_addr_61 <= preaddbit122 & preaddbit121;

  PROCESS(mem_addr_61)
  BEGIN
    CASE mem_addr_61 IS
      WHEN "00" => memoutb1_61 <= "00000000000000000";
      WHEN "01" => memoutb1_61 <= "00100010110011011";
      WHEN "10" => memoutb1_61 <= "00100111010101110";
      WHEN "11" => memoutb1_61 <= "01001010001001001";
      WHEN OTHERS => memoutb1_61 <= "01001010001001001";
    END CASE;
  END PROCESS;

  mem_addr_62 <= preaddbit124 & preaddbit123;

  PROCESS(mem_addr_62)
  BEGIN
    CASE mem_addr_62 IS
      WHEN "00" => memoutb1_62 <= "00000000000000000";
      WHEN "01" => memoutb1_62 <= "00101011011111011";
      WHEN "10" => memoutb1_62 <= "00101111001010101";
      WHEN "11" => memoutb1_62 <= "01011010101010000";
      WHEN OTHERS => memoutb1_62 <= "01011010101010000";
    END CASE;
  END PROCESS;

  mem_addr_63 <= preaddbit126 & preaddbit125;

  PROCESS(mem_addr_63)
  BEGIN
    CASE mem_addr_63 IS
      WHEN "00" => memoutb1_63 <= "00000000000000000";
      WHEN "01" => memoutb1_63 <= "00110010010010011";
      WHEN "10" => memoutb1_63 <= "00110100110010011";
      WHEN "11" => memoutb1_63 <= "01100111000100110";
      WHEN OTHERS => memoutb1_63 <= "01100111000100110";
    END CASE;
  END PROCESS;

  mem_addr_64 <= preaddbit128 & preaddbit127;

  PROCESS(mem_addr_64)
  BEGIN
    CASE mem_addr_64 IS
      WHEN "00" => memoutb1_64 <= "00000000000000000";
      WHEN "01" => memoutb1_64 <= "00110110100111010";
      WHEN "10" => memoutb1_64 <= "00110111101110011";
      WHEN "11" => memoutb1_64 <= "01101110010101101";
      WHEN OTHERS => memoutb1_64 <= "01101110010101101";
    END CASE;
  END PROCESS;

  mem_addr_65 <= delayline_b3071;

  PROCESS(mem_addr_65)
  BEGIN
    CASE mem_addr_65 IS
      WHEN '0' => memoutb1_65 <= "0000000000000000";
      WHEN '1' => memoutb1_65 <= "0111000000110010";
      WHEN OTHERS => memoutb1_65 <= "0111000000110010";
    END CASE;
  END PROCESS;

  sum1_1 <= resize(memoutb1_1, 14) + resize(memoutb1_2, 14);

  sum1_2 <= resize(memoutb1_3, 15) + resize(memoutb1_4, 15);

  sum1_3 <= resize(memoutb1_5, 14) + resize(memoutb1_6, 14);

  sum1_4 <= resize(memoutb1_7, 14) + resize(memoutb1_8, 14);

  sum1_5 <= resize(memoutb1_9, 12) + resize(memoutb1_10, 12);

  sum1_6 <= resize(memoutb1_11, 11) + resize(memoutb1_12, 11);

  sum1_7 <= resize(memoutb1_13, 13) + resize(memoutb1_14, 13);

  sum1_8 <= resize(memoutb1_15, 15) + resize(memoutb1_16, 15);

  sum1_9 <= resize(memoutb1_17, 15) + resize(memoutb1_18, 15);

  sum1_10 <= resize(memoutb1_19, 15) + resize(memoutb1_20, 15);

  sum1_11 <= resize(memoutb1_21, 15) + resize(memoutb1_22, 15);

  sum1_12 <= resize(memoutb1_23, 15) + resize(memoutb1_24, 15);

  sum1_13 <= resize(memoutb1_25, 13) + resize(memoutb1_26, 13);

  sum1_14 <= resize(memoutb1_27, 11) + resize(memoutb1_28, 11);

  sum1_15 <= resize(memoutb1_29, 13) + resize(memoutb1_30, 13);

  sum1_16 <= resize(memoutb1_31, 15) + resize(memoutb1_32, 15);

  sum1_17 <= resize(memoutb1_33, 16) + resize(memoutb1_34, 16);

  sum1_18 <= resize(memoutb1_35, 16) + resize(memoutb1_36, 16);

  sum1_19 <= resize(memoutb1_37, 16) + resize(memoutb1_38, 16);

  sum1_20 <= resize(memoutb1_39, 15) + resize(memoutb1_40, 15);

  sum1_21 <= resize(memoutb1_41, 14) + resize(memoutb1_42, 14);

  sum1_22 <= resize(memoutb1_43, 14) + resize(memoutb1_44, 14);

  sum1_23 <= resize(memoutb1_45, 14) + resize(memoutb1_46, 14);

  sum1_24 <= resize(memoutb1_47, 15) + resize(memoutb1_48, 15);

  sum1_25 <= resize(memoutb1_49, 16) + resize(memoutb1_50, 16);

  sum1_26 <= resize(memoutb1_51, 17) + resize(memoutb1_52, 17);

  sum1_27 <= resize(memoutb1_53, 17) + resize(memoutb1_54, 17);

  sum1_28 <= resize(memoutb1_55, 16) + resize(memoutb1_56, 16);

  sum1_29 <= resize(memoutb1_57, 15) + resize(memoutb1_58, 15);

  sum1_30 <= resize(memoutb1_59, 17) + resize(memoutb1_60, 17);

  sum1_31 <= resize(memoutb1_61, 18) + resize(memoutb1_62, 18);

  sum1_32 <= resize(memoutb1_63, 18) + resize(memoutb1_64, 18);

  sum2_1 <= resize(sum1_1, 16) + resize(sum1_2, 16);

  sum2_2 <= resize(sum1_3, 15) + resize(sum1_4, 15);

  sum2_3 <= resize(sum1_5, 13) + resize(sum1_6, 13);

  sum2_4 <= resize(sum1_7, 16) + resize(sum1_8, 16);

  sum2_5 <= resize(sum1_9, 16) + resize(sum1_10, 16);

  sum2_6 <= resize(sum1_11, 16) + resize(sum1_12, 16);

  sum2_7 <= resize(sum1_13, 14) + resize(sum1_14, 14);

  sum2_8 <= resize(sum1_15, 16) + resize(sum1_16, 16);

  sum2_9 <= resize(sum1_17, 17) + resize(sum1_18, 17);

  sum2_10 <= resize(sum1_19, 17) + resize(sum1_20, 17);

  sum2_11 <= resize(sum1_21, 15) + resize(sum1_22, 15);

  sum2_12 <= resize(sum1_23, 16) + resize(sum1_24, 16);

  sum2_13 <= resize(sum1_25, 18) + resize(sum1_26, 18);

  sum2_14 <= resize(sum1_27, 18) + resize(sum1_28, 18);

  sum2_15 <= resize(sum1_29, 18) + resize(sum1_30, 18);

  sum2_16 <= resize(sum1_31, 19) + resize(sum1_32, 19);

  sum3_1 <= resize(sum2_1, 17) + resize(sum2_2, 17);

  sum3_2 <= resize(sum2_3, 17) + resize(sum2_4, 17);

  sum3_3 <= resize(sum2_5, 17) + resize(sum2_6, 17);

  sum3_4 <= resize(sum2_7, 17) + resize(sum2_8, 17);

  sum3_5 <= resize(sum2_9, 18) + resize(sum2_10, 18);

  sum3_6 <= resize(sum2_11, 17) + resize(sum2_12, 17);

  sum3_7 <= resize(sum2_13, 19) + resize(sum2_14, 19);

  sum3_8 <= resize(sum2_15, 20) + resize(sum2_16, 20);

  sum4_1 <= resize(sum3_1, 18) + resize(sum3_2, 18);

  sum4_2 <= resize(sum3_3, 18) + resize(sum3_4, 18);

  sum4_3 <= resize(sum3_5, 19) + resize(sum3_6, 19);

  sum4_4 <= resize(sum3_7, 21) + resize(sum3_8, 21);

  sum5_1 <= resize(sum4_1, 19) + resize(sum4_2, 19);

  sum5_2 <= resize(sum4_3, 22) + resize(sum4_4, 22);

  sum6_1 <= resize(sum5_1, 23) + resize(sum5_2, 23);

  sum7_1 <= resize(sum6_1, 24) + resize(memoutb1_65, 24);

  memoutb1 <= sum7_1(19 DOWNTO 0);

  --  Shift and add the LUT results to compute the scaled accumulated sum

  memoutb1_cast <= resize(memoutb1(19 DOWNTO 0) & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0', 47);

  acc_out_shft <= resize(acc_out(46 DOWNTO 1), 47);

  add_temp <= resize(acc_out_shft, 48) + resize(memoutb1_cast, 48);
  addsub_add <= add_temp(46 DOWNTO 0);

  sub_temp <= resize(acc_out_shft, 48) - resize(memoutb1_cast, 48);
  addsub_sub <= sub_temp(46 DOWNTO 0);

  add_sub_out <= addsub_sub WHEN ( phase_24 = '1' ) ELSE
                      addsub_add;

  acc_in <= memoutb1_cast WHEN ( phase_0 = '1' ) ELSE
            add_sub_out;

  Acc_reg_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      acc_out <= (OTHERS => '0');
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        acc_out <= acc_in;
      END IF;
    END IF; 
  END PROCESS Acc_reg_process;

  Finalsum_reg_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      final_acc_out <= (OTHERS => '0');
    ELSIF clk'event AND clk = '1' THEN
      IF phase_0 = '1' THEN
        final_acc_out <= acc_out;
      END IF;
    END IF; 
  END PROCESS Finalsum_reg_process;

  output_da <= final_acc_out;

  output_typeconvert <= resize(shift_right(output_da(42 DOWNTO 0) + ( "0" & (output_da(19) & NOT output_da(19) & NOT output_da(19) & NOT output_da(19) & NOT output_da(19) & NOT output_da(19) & NOT output_da(19) & NOT output_da(19) & NOT output_da(19) & NOT output_da(19) & NOT output_da(19) & NOT output_da(19) & NOT output_da(19) & NOT output_da(19) & NOT output_da(19) & NOT output_da(19) & NOT output_da(19) & NOT output_da(19) & NOT output_da(19))), 19), 24);

  Output_Register_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      output_register <= (OTHERS => '0');
    ELSIF clk'event AND clk = '1' THEN
      IF phase_24 = '1' THEN
        output_register <= output_typeconvert;
      END IF;
    END IF; 
  END PROCESS Output_Register_process;

  -- Assignment Statements
  filter_out <= std_logic_vector(output_register);
END rtl;
